#ifdef GL_ES
 precision lowp float; 
#endif
 varying vec4 v_fragmentColor;
 varying vec2 v_texCoord;

 
 
 void main() {
 
	vec4 sample = texture2D(CC_Texture0, v_texCoord);
	float fontAlpha = sample.a;
	float outlineAlpha = (sample.r+sample.g+sample.b)/3;
	
	if (outlineAlpha > 0.0){ 
		vec4 color = sample * fontAlpha  + vec4(1,0,0,1) * (1.0 - fontAlpha); 
		gl_FragColor = v_fragmentColor * vec4( color.rgb,max(fontAlpha,outlineAlpha)*color.a);
	} else {
		discard; 
	} 
 }