AI = {}
 
AI.funtionName = enum{   --方法名字的对应KEY列表 提供给策划参照
    "randomRun=1",      -- 参数对应搜敌范围
    "sws_hitWhenStun",  -- = 2
    "sws_Attack",       -- = 3
    "monster_Attack",   -- = 4
    "monster_moveto",   -- = 5
    "monster_FightBack",   -- = 6
    "monster_FightWithSkill",   -- = 7
    "PvP_FindPath_dao",   -- = 8
    "PvP_dodge_dao",   -- = 9
    "PvP_NormalHit_dao",   -- = 10
    "PvP_SkillHit_dao",   -- = 11
    "PvP_superSkill_dao",   -- = 12
    "world_boss_clear"   -- = 13
    
}

AI.typeList ={}   --方法列表


function AI.world_boss_clear(obj,target,dis,value,time_box,skillIndex) --未入搜敌范围随机乱跑
    if time_box.passTime >= value then
        if obj._ActorState <= EnumStateType.attack and obj._LastState <= EnumStateType.attack  then
            if AI.closeWithSkill(obj,target,dis,skillIndex) == true then  --如果未到技能1的攻击范围就追踪目标 否则就使用技能1攻击目标

                obj:setFacing(target)
                obj:SetSate(EnumStateType.skill_1+(skillIndex -1),false)
            end
            return true,AI.world_boss_clear,value
        elseif obj._ActorState == EnumStateType.stand then
            time_box.passTime = 0 
            obj._LastState = EnumStateType.stand
            return false
        end
    else
        if obj._ActorState ~= EnumStateType.stand then
            obj:SetSate(EnumStateType.stand,false)
        end
        return false
    end
    
end
table.replace(AI.typeList,AI.funtionName.world_boss_clear,AI.world_boss_clear)

function AI.monster_moveto(obj,target,dis,value) --未入搜敌范围随机乱跑
    local needstop = false
    local nowSpeed = obj:AddSpeed(obj.speed_x)
    if obj._curFacing > 0  then
        if obj.x >= value or nowSpeed <=0 then
            needstop = true
        end
    elseif obj._curFacing < 0 then
        if obj.x <= value or nowSpeed >=0 then
            needstop = true
        end
    end
    
    if obj._ActorState >= EnumStateType.minor_injured and obj._ActorState <= EnumStateType.readytodie then 
        needstop = true
    end
    
    if  needstop == false then
        
        if obj._ActorState ~= EnumStateType.run then
            obj:SetSate(EnumStateType.run,false)
        end
        return true
    else
        if obj._ActorState ~= EnumStateType.stand then
            obj:SetSate(EnumStateType.stand,false)
        end
        return false
    end
end
table.replace(AI.typeList,AI.funtionName.monster_moveto,AI.monster_moveto)

function AI.randomRun(obj,target,dis,value) --未入搜敌范围随机乱跑
    -- cclog(debug.traceback())
    if dis > value then
        local tempdir = 1
        if Random(0,100)>50 then tempdir = -1 end
        local tempdestinaton = obj.x + Random(300,550)*tempdir
        if tempdestinaton < G.activearea.left+300 then tempdestinaton = G.activearea.left+300
        elseif tempdestinaton > G.activearea.right - 300 then tempdestinaton = G.activearea.right - 300 end
        obj:setFacingLR(tempdir)
        
        return true,AI.monster_moveto,tempdestinaton
    else
        if obj._ActorState ~= EnumStateType.stand then
            obj:SetSate(EnumStateType.stand,false)
        end
        return false
    end
end
table.replace(AI.typeList,AI.funtionName.randomRun,AI.randomRun)

function AI.monster_Attack(obj,target,dis,value)
    local skillCount = List.getSize(obj.skill_list)
    local tempDecisicon = 0
    local SwitchTwo = false
    
    if skillCount > 1 and obj.skill_list[2] ~= nil then
        SwitchTwo = true
    end
    --obj.self.skillchange == true
    if obj._ActorState <= EnumStateType.attack and obj._LastState <= EnumStateType.attack  then
        local nowRandom = obj:chechEnemyDis(25,2)
        if SwitchTwo == true then
            if obj.Last_skill_release ~= 1  then   --如果上次发出技能不等于1 就是用技能1
                if AI.closeWithSkill(obj,target,dis,1) == true then  --如果未到技能1的攻击范围就追踪目标 否则就使用技能1攻击目标
                    if nowRandom ~= true then
                        obj:setFacing(target)
                        obj:SetSate(EnumStateType.skill_1,false)
                    else
                        tempDecisicon = 1
                    end
                end
            elseif obj.Last_skill_release == 1  then  --如果上次发出技能等于1 就是用技能2

                if AI.closeWithSkill(obj,target,dis,2) == true then --如果未到技能2的攻击范围就追踪目标 否则就使用技能2攻击目标
                    if nowRandom ~= true then
                        obj:setFacing(target)
                        obj:SetSate(EnumStateType.skill_2,false)
                    else
                        tempDecisicon = 1
                    end
                end
            end
        else
            if AI.closeWithSkill(obj,target,dis,1) == true then  --如果未到技能1的攻击范围就追踪目标 否则就使用技能1攻击目标
                if nowRandom ~= true then
                    obj:setFacing(target)
                    obj:SetSate(EnumStateType.skill_1,false)
                else
                    tempDecisicon = 1
                end
            end
        end
        return true,AI.monster_Attack,tempDecisicon
    elseif obj._ActorState >= EnumStateType.attack and obj.skillchange == true and obj.monster_combo == true then
        if obj.AITime == 0.01 then
            obj:setFacing(target)
            if SwitchTwo == true then
                if obj.Last_skill_release ~= 1  then
                    obj:SetSate(EnumStateType.skill_1,false)
                else
                    obj:SetSate(EnumStateType.skill_2,false)
                end
            else
                obj:SetSate(EnumStateType.skill_1,false)
            end
            obj.monster_combo = false
        end
        
    elseif obj._ActorState == EnumStateType.stand then
        
        obj._LastState = EnumStateType.stand

        
        return false
    end
end
table.replace(AI.typeList,AI.funtionName.monster_Attack,AI.monster_Attack)

function AI.monster_FightWithSkill(obj,target,dis,value)
    
    if obj._ActorState <= EnumStateType.attack and obj._LastState == EnumStateType.couch then
        obj:UpDateResist(127)

        if value == 1 then
            obj:SetSate(EnumStateType.skill_1,false)
        elseif value == 2 then
            obj:SetSate(EnumStateType.skill_2,false)
        elseif value == 3 then
            obj:SetSate(EnumStateType.skill_3,false)
        elseif value == 4 then
            obj:SetSate(EnumStateType.skill_4,false)
        end
        return true
    elseif obj._ActorState >= EnumStateType.attack and obj._LastState == EnumStateType.stand then
        return true
    elseif obj._ActorState == EnumStateType.stand and obj._LastState >= EnumStateType.attack then

        obj:UpDateResist(obj.Status_Control)
        obj._LastState = EnumStateType.stand

        return false
    end
end
table.replace(AI.typeList,AI.funtionName.monster_FightWithSkill,AI.monster_FightWithSkill)

function AI.monster_FightBack(obj,target,dis,value)
   
    if obj._ActorState <= EnumStateType.attack and (obj._LastState == EnumStateType.couch or obj._LastState == EnumStateType.breakShield )then
        obj:UpDateResist(127)
        
        if value == 1 then
            obj:SetSate(EnumStateType.skill_1,false)
        elseif value == 2 then
            obj:SetSate(EnumStateType.skill_2,false)
        elseif value == 3 then
            obj:SetSate(EnumStateType.skill_3,false)
        elseif value == 4 then
            obj:SetSate(EnumStateType.skill_4,false)
        end
        return true
    elseif obj._ActorState >= EnumStateType.attack and obj._LastState == EnumStateType.stand then
        return true
    elseif obj._ActorState == EnumStateType.stand and obj._LastState >= EnumStateType.attack then
        
        obj:UpDateResist(obj.Status_Control)
        obj._LastState = EnumStateType.stand
        
        return false
    end
end
table.replace(AI.typeList,AI.funtionName.monster_FightBack,AI.monster_FightBack)


function AI.sws_Attack(obj,target,dis,value)
    --cclog("obj.Last_skill_release =%d",obj.Last_skill_release)
    local skillCount = List.getSize(obj.skill_list)
    local SwitchTwo = false

    if skillCount > 1 and obj.skill_list[2] ~= nil then
        SwitchTwo = true
    end
    
    if obj._ActorState <= EnumStateType.attack  and obj._LastState <= EnumStateType.attack  then
        if SwitchTwo == true then
            if obj.Last_skill_release ~= 1  then   --如果上次发出技能不等于1 就是用技能1
                if AI.closeWithSkill(obj,target,dis,1) == true then  --如果未到技能1的攻击范围就追踪目标 否则就使用技能1攻击目标
                    obj:setFacing(target)
                    obj:SetSate(EnumStateType.skill_1,false)
                end
            elseif obj.Last_skill_release == 1  then  --如果上次发出技能等于1 就是用技能2

                if AI.closeWithSkill(obj,target,dis,2) == true then --如果未到技能2的攻击范围就追踪目标 否则就使用技能2攻击目标
                    obj:setFacing(target)
                    obj:SetSate(EnumStateType.skill_2,false)
                end
            end
        else
            if AI.closeWithSkill(obj,target,dis,1) == true then  --如果未到技能1的攻击范围就追踪目标 否则就使用技能1攻击目标
                obj:setFacing(target)
                obj:SetSate(EnumStateType.skill_1,false)
            end
        end
        return true,AI.sws_Attack,value --返回当前需要更新的行为以及参数
    elseif obj._ActorState == EnumStateType.stand then

        obj._LastState = EnumStateType.stand


        return false
   end
end
table.replace(AI.typeList,AI.funtionName.sws_Attack,AI.sws_Attack)  --关联此方法的枚举列表




function AI.sws_hitWhenStun(obj,target,dis,value)
    local skillCount = List.getSize(obj.skill_list)
    local canAttack = value <= skillCount
    if target._ActorState == EnumStateType.stun then
    
        if canAttack == true then
            if AI.closeWithSkill(obj,target,dis,value) == true  then

                obj:setFacing(target)
                obj:SetSate(EnumStateType.skill_3,false)
            end
            return true,AI.sws_hitWhenStun,value
        else
            if obj._ActorState ~= EnumStateType.stand then
                obj:SetSate(EnumStateType.stand,false)
            end
            return false
        end
    elseif target._ActorState ~= EnumStateType.stun then
        if obj._ActorState ~= EnumStateType.stand then
            obj:SetSate(EnumStateType.stand,false)
        end
        return false
    elseif obj._ActorState == EnumStateType.stand then
        obj._LastState = EnumStateType.stand
        obj:SetSate(EnumStateType.stand,false)
        
        return false
    end
end
table.replace(AI.typeList,AI.funtionName.sws_hitWhenStun,AI.sws_hitWhenStun)


function AI.closeWithSkill(obj,target,dis,value)
    
    local xxx = obj.skill_list[value].Attack_Range
    if dis <= xxx then
        obj:setFacing(target)
        if obj._ActorState ~= EnumStateType.stand then
           obj:SetSate(EnumStateType.stand,false)
        end
        
        return true
       
    else
    
        
        if obj._ActorState ~= EnumStateType.run then
           obj:setFacing(target)
           obj:SetSate(EnumStateType.run,false)
        end
        
        
        
        return false
    end
end

function AI.keepRuning(obj,target,dis,value)
    if obj._ActorState == EnumStateType.run or obj._ActorState == EnumStateType.stand then
        if dis <= value then
            obj:setFacing(target)
            if obj._ActorState ~= EnumStateType.stand then
                obj:SetSate(EnumStateType.stand,false)
            end
        else
            if obj.lastX == obj.x and obj._ActorState == EnumStateType.run then
                obj:setFacingLR(obj._curFacing * -1)

            end
            
            if obj._ActorState ~= EnumStateType.run then
                obj:setFacing(target)
                obj:SetSate(EnumStateType.run,false)
            end
            
            

        end
    end
    
end

function AI.getAllSkillReach(obj,dis,needSkill)
    local canReach = false
    local normalSkillIndex = 0 
    local SkillIndex = 0
    
    local skillCount = List.getSize(obj.skill_list)
    local normalCount = List.getSize(obj.normal_att_list)

    for i=1,normalCount do
        local tempSkill = obj.normal_att_list[i]
        if tempSkill~= nil then
            local tempRange = tempSkill.Attack_Range
            if dis <= tempRange then
                normalSkillIndex = i
                canReach = true
                break
            end
        end
    end

    if canReach == false or needSkill == true then
        for i=1,skillCount do
            local tempSkill = obj.skill_list[i]
            if tempSkill~= nil and tempSkill.can_use then
                local tempRange = tempSkill.Attack_Range
                if dis <= tempRange then
                    SkillIndex = i 
                    canReach = true
                    break
                end
            end
        end
    end
    
    return canReach,normalSkillIndex,SkillIndex

end


function AI.PvP_FindPath_dao(obj,target,dis,value) --竞技场玩家寻路——刀男
    local shouldRun = true
    local obj_States = obj._ActorState
    
    if obj_States > EnumStateType.run then 

        return false
    end
    
    local canReach,ii,kk = AI.getAllSkillReach(obj,dis)
    shouldRun = not canReach
    
    if shouldRun == true then
        obj:setFacing(target)
        if obj_States ~= EnumStateType.run then
            
            obj:SetSate(EnumStateType.run,false)
        end
    else
        obj:setFacing(target)
        if obj_States == EnumStateType.run then

            obj:SetSate(EnumStateType.stand,false)
        end
    end
    
    return shouldRun
end
table.replace(AI.typeList,AI.funtionName.PvP_FindPath_dao,AI.PvP_FindPath_dao)

function AI.PvP_dodge_dao(obj,target,dis,value) --竞技场玩家躲避——刀男
    local shouldDodge = false
    local nowSkill_range = 0
    local obj_States = obj._ActorState
    local target_States = target._ActorState
    
    if obj._hp > 0.5*obj._hp_max or obj._shield <100 then
        local tempNum = Random(1,100)
        if tempNum >30 then return shouldDodge end
    end
    
    if target_States >= EnumStateType.attack and obj_States < EnumStateType.attack then --如果对方在攻击并且当你面对目标d在攻击范围内时发动
        if target_States == EnumStateType.attack then 
            nowSkill_range = target.normal_att_list[target._comboStep].Attack_Range
        elseif target_States > EnumStateType.attack then
            local index = target_States - EnumStateType.attack
            nowSkill_range = target.skill_list[index].Attack_Range
        end
        
        if dis <= nowSkill_range then
            if target._curFacing == 1 and obj.x >= target.x then
                shouldDodge = true
            elseif target._curFacing == -1 and obj.x <= target.x then
                shouldDodge = true
            end
        end
        
        if shouldDodge == true then
            
            if obj.role_energy >= 50 then
                obj:setFacing(target)
                obj:specialRoll()
            else
                shouldDodge = false
            end
        
        end
    end
    
    return shouldDodge
end
table.replace(AI.typeList,AI.funtionName.PvP_dodge_dao,AI.PvP_dodge_dao)

function AI.PvP_NormalHit_dao(obj,target,dis,value) --竞技场玩家普通攻击——刀男
    local isHit = false
    local canReach,normalSkill,nowSkill = AI.getAllSkillReach(obj,dis)
    local obj_States = obj._ActorState
    local inRange = canReach == true and normalSkill~= 0 and (obj_States < EnumStateType.defens or obj_States > EnumStateType.win)
    
    
    if inRange == true then
        obj:setFacing(target)
        obj:normalAttack()
        obj:normalAttack_release()
        isHit = true
    end
    
    return isHit

end
table.replace(AI.typeList,AI.funtionName.PvP_NormalHit_dao,AI.PvP_NormalHit_dao)

function AI.PvP_SkillHit_dao(obj,target,dis,value) --竞技场玩家技能攻击——刀男
    local isHit = false
    local canReach,normalSkill,nowSkill = AI.getAllSkillReach(obj,dis,true)
    local obj_States = obj._ActorState
    local inRange = canReach == true and nowSkill > 0 and nowSkill <4  and (obj_States < EnumStateType.defens or obj_States > EnumStateType.win)
    local obj_States = obj._ActorState

    if inRange == true then
        obj:setFacing(target)
        
        if nowSkill == 1 then
            obj:specialAttack1()
        elseif nowSkill == 2 then
            obj:specialAttack2()
        elseif nowSkill == 3 then
            obj:specialAttack3()
        end
        
        isHit = true
    end

    return isHit

end
table.replace(AI.typeList,AI.funtionName.PvP_SkillHit_dao,AI.PvP_SkillHit_dao)

function AI.PvP_superSkill_dao(obj,target,dis,value) --竞技场玩家大招攻击——刀男

end
table.replace(AI.typeList,AI.funtionName.PvP_superSkill_dao,AI.PvP_superSkill_dao)

