require("tools.timerquest")


local GameScene = class("GameScene",function()
    return cc.Scene:create()
end)

enemy = nil

standbyPlayer=nil

nowPlayer=nil
nowWaitPlay=nil
nowmonster=nil
nowBullet=nil
QteSeq = nil
nowShadow={}
--waveList=nil
testShader=nil
nowDropItem = nil
nowSceneScale = 1.0
nowFixTimeScale = 1.0
CFTYPE = false

local fGetCamNextXY = getCamNextXY

local mathabs = math.abs
local mathCeil = math.ceil
local mathFloor = math.floor
local mathMax = math.max
local mathMin = math.min
local mDirect = cc.Director:getInstance()
local mFPS = defaultFPS
local ui_node_base
local ui_node
local Hero_HP_node
local Hero_Energybar_node
local Hero_Energy_node
local BOSS_Bar_node
local BOSS_HP_node
local BOSS_Head_node
local BOSS_Name_node
local BOSS_Sheild_node
local BOSS_Sheild_bar
local Combo_node
local Combo_Num_node
local Time_node
local Time_Progess_node
local Time_FBName_node
local Time_Time_node
local Go_Tip_node
local Boss_Hp_each
local Boss_Hp_table
local Boss_hp_index
local Boss_Last_hp
local Boss_Last_Sheild
local Drink_node
local counter_node
local counter_count
local counter_bar
local counter_Animation
local Enemy_HP_node    
local Enemy_Energybar_node  
local Enemy_Energy_node
local lastBossHpIndex = 0
local now_max_drop_item = 0 


function GameScene.create()
    local scene = GameScene.new()
    GameManager.setMain(scene)
    scene:LoadingGame()
    
    --[[
    copyTable(FbInitValues,scene)
    scene.game_layer = scene:createLayer()
    scene:addChild(scene.game_layer)
    LableString.setLayer(scene.game_layer)
    scene:addChild(GameControlLayer.createUILayer(scene),2,1000)
    scene:initData()
    scene:playBgMusic()
    --]]
   
    --GameManager.setPlayerStartStates()
    
    scene.nowFixT = 1/defaultFPS
    --cc.Director:getInstance():setAnimationInterval(1.0 / 60)
    
    return scene
end

function GameScene.createLoadingLayer()
    
	local layerFarm = cc.Layer:create()
    local rootNode = cc.CSLoader:createNode("Loading.csb")
	--local timeline = cc.CSLoader:createTimeline(csb_file)

    local loadingItem = rootNode:getChildByTag(1):getChildByTag(2)
    local blackMask = GameAssistor.CreateMaskLayout(cc.c3b(0,0,0),255)
    layerFarm:addChild(blackMask)
	layerFarm:addChild(rootNode)
    
	--rootNode:runAction(timeline)
	--timeline:gotoFrameAndPlay(0,true)
	
	local tx_percent=rootNode:getChildByTag(1)

	return layerFarm,loadingItem,tx_percent
end

function GameScene:LoadingGame()

	local layerFarm,loadingItem,tx_percent = GameScene.createLoadingLayer()
    self:addChild(layerFarm,99,99)

    --update
    local loading_percent_now=0
    local loading_percent_idx=1
    local loading_event={30,50,80,99,100}
    local scheduleID
    local firstEnd = true
    
    self.isLoading=true

    local loading_coroutine = coroutine.create(function ()
            
            copyTable(FbInitValues,self) --副本基础属性
            coroutine.yield()
            
            --PreloadSpineRes()
            self.game_isEnd = false
            
            LableString.setPar()
            
            self.game_layer = self:createLayer()
            -- coroutine.yield()
--            self.testNode = cc.NodeGrid:create()
--            self.testNode:addChild(self.game_layer)
            self:addChild(self.game_layer,1,500)
            
            --self:addChild(self.game_layer)

            LableString.setLayer(self.bg_foreground)
            coroutine.yield()
            
            self.control_layer = GameControlLayer.createUILayer(self)
            self:addChild(self.control_layer,2,1000)
            
           
            
            
            coroutine.yield()
            
            self:initData()
            
            GameManager.setMain(self)
            
            now_max_drop_item = GameManager.FB_Value.max_drop_item
            
            --GameManager.updateEnergy(nowPlayer[1].role_energy)
            GameManager.setSkillIcon(nowPlayer[1].skill_list)
            
            GameManager.updatePlayerName()
            GameManager.updatePlayerList()
            
            --GameControlLayer.RefreshRollButtonEnergy(nowPlayer[1].role_energy)
            
            --TeachAssistor.balanceShouldAutoChange(true)
            --GameManager.Zoom(0.8,1)
            cclog("opening idx = %d",loading_percent_idx)
            coroutine.yield()
            
            
            GameManager.setGameOpening()
            cclog("opening idx = %d",loading_percent_idx)
            
            --:playBgMusic()
            
            
            
            self.loading_done = true
            
            
            
            nowGameScene=self
            
    end)


    
    local function updateLoading(delta)
        
        if self:getChildByTag(99) == nil then return end
        --if not self.isLoading then return end
        
        loading_percent_now = math.min(loading_percent_now+1,loading_event[loading_percent_idx])

        loadingItem:setPercent(loading_percent_now)
		--tx_percent:setString(loading_percent_now.."%")

        for key, var in ipairs(loading_event) do
            if loading_percent_now==loading_event[key] then 
                loading_percent_idx=math.min(key+1,5)
                coroutine.resume(loading_coroutine)
                break
            end
        end
        
        local function removeLayer()
            setMotionSpeed(0)
            self:removeChild(layerFarm,true)
            self.isLoading=false
           
            
            if GameManager.FB_Value.fb_id == 10000 then
                GameSound.PlayMusic(SoundType.BOSS_FIGHT)
                ui_node:getChildByTag(GameControlLayer.NodeEnum.roleBar):getChildByTag(5):setVisible(false)
            else
                local tempSound = {SoundType.BG_FIGHT1,SoundType.BG_FIGHT2,SoundType.BG_FIGHT4}
                GameSound.PlayMusic(tempSound[math.floor(Random(1,3))])
            end
            self.inPvP = false
            
            
            if GameManager.FB_Value.isPvP == true and GameManager.FB_Value.is_3v3 == false then
                self.inPvP = true
                local tempcamX = ((G.activearea.right - G.activearea.left) - 1280)/2
                local heroX = G.activearea.left +tempcamX + 180
                local enemyX = heroX +920
                GameManager.setHeroPosition(heroX,300)
                GameManager.addHeroRole(enemyX,300,GameManager.FB_Value.enemy_seclet_charater,GameRival)
                GameManager.updateEnemyEnergy(nowmonster[1].role_energy)
                GameManager.updatePlayerName(2)
                self.nowCamera.position.x = G.activearea.left + tempcamX
            elseif GameManager.FB_Value.is_3v3 == true then
                self.inPvP = true
                local nowRound = GameManager.FB_Value.now_Party_index
                G.activearea.left = 0
                G.activearea.right = 3840
                G.activearea.bottom =0
                G.activearea.top = 1440
                local tempcamX = ((G.activearea.right - G.activearea.left) - 1280)/2
                local heroX = G.activearea.left + tempcamX + 180
                local enemyX = heroX +920
                GameManager.setHeroPosition(heroX,300)
                --GameManager.FB_Value.enemy_PvP_mode = GameManager.FB_Value.rivalFormation[nowRound].modeId
                GameManager.addHeroRole(enemyX,300,GameManager.FB_Value.rivalFormation[nowRound].roleID,GameRival)
                --GameManager.updateEnemyEnergy(nowmonster[1].role_energy)
                GameManager.updatePlayerName(2)
                self.nowCamera.position.x = G.activearea.left + tempcamX
            else
--                G.activearea.left = 0
--                G.activearea.right = 3840
                GameManager.setHeroPosition(300,215)
                --GameManager.setCombo_Nowcount(0)
            end
            GameSound.PreloadAllGameEffects()
            local obj = nowPlayer[1]
            
            setMotionSpeed(1)
            --GameManager.Zoom(1.5,20)
            
            if obj.extra_sound_effect[1] >0 then
                GameSound.playGameEffectAttack(obj.extra_sound_effect[1])
            end
            
            loadingItem = nil
        end

        if loading_percent_now == 100 and self.loading_done == true and firstEnd == true then 
            firstEnd = false
            cc.Director:getInstance():getScheduler():unscheduleScriptEntry(scheduleID)
            --cc.Sequence:create(cc.DelayTime:create(0.012),
            loadingItem = nil
            self:runAction(cc.CallFunc:create(removeLayer))
            
            
        end
    end
    if firstEnd == true then
        scheduleID=cc.Director:getInstance():getScheduler():scheduleScriptFunc(updateLoading,0,false)
    end
end

function GameScene:followToHero()
    local rightPosition = false
    while rightPosition == false do
        local cameraPoint = self:camFollow(cc.p(self.follow_target.x,self.follow_target.y),0,CFTYPE)
        if self.nowCamera.position.x ~=cameraPoint.x then
            self.nowCamera.position.x = cameraPoint.x
        else
            rightPosition = true

            local tempOffsetX = self.nowCamera.position.x

            local offsetX = tempOffsetX*-1


            self.bg_remote:setPosition(offsetX/40,self.bg_remote_y)


            self.bg_medium_1:setPosition(mathCeil((offsetX*0.5)),self.bg_medium_1_y)


            --self.bg_medium:setPosition(mathCeil((offsetX*0.7)),self.bg_medium_y)


            self.bg_foreground:setPosition(offsetX,self.bg_foreground_y+self.offset_y)

            --self.mask_ground_1:setPosition(offsetX,self.mask_ground_1_y+self.offset_y)   --增加第7层

            --self.bg_new_foreground_1:setPosition(offsetX*1.2,self.bg_new_foreground_1_y)
        end
    end
end

function GameScene:ctor()

    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
    
    local function onNodeEvent(event)
        if event == "enter" then
            self:f_onEnter()
        elseif event=="exit" then
            self:f_onExit() 
        end
    end

    self:registerScriptHandler(onNodeEvent)
end

function  GameScene:f_onEnter()
    --setMotionSpeed(0.2)
    cclog("GameScene Scene onEnter")
    
    self.nowCamera=GameCamera.new()

    GameSound.StopMusic()

	---[[
	------------------------------------
	if PINGTEST then
		Ping_AddTestButtons()
	end
	------------------------------------
	--]]
end

function  GameScene:f_onExit()
    cclog("GameScene Scene f_onExit")
    
    List.removeAll(self.all_boundingBoxs)
    List.removeAll(self.all_boundingBoxs_big)
    
    if Boss_Hp_table ~= nil then table.clear(Boss_Hp_table) end
    
    self:resetList()
    self.appear = nil
    self.smoke = nil
    self.heal = nil 
    --self.game_layout:removeFromParent()
    --self.game_layer:removeFromParent()
    
    
    LableString.resetData()
    self:releaseData()
    
    if GameManager.battleScenes.m_Restart == false then 
        GameEventManager.Stop()
    elseif GameManager.battleScenes.m_Restart == true then
        GameManager.battleScenes.m_Restart = false 
    end
    
    GameManager.setMain(nil)
    
    
    
    --local ui_node_base = self:getChildByTag(1000)
    --ui_node_base:removeAllChildren()
    --ui_node_base:removeFromParent()
    
   
    
--    self.node_bg = nil
--    self.bg_remote = nil
--    self.bg_medium = nil
--    self.bg_foreground = nil
--    self.bg_new_foreground=nil
    
    
    --self.game_layer:removeFromParent()
    
    self.game_layout = nil
    self.game_layer=nil
	
    RemoveAllSpineRes()
    GameSound.UnloadAllGameEffect()
    self:removeAllChildren()
    
    cc.SpriteFrameCache:getInstance():removeUnusedSpriteFrames()
    
    cc.Director:getInstance():getTextureCache():removeUnusedTextures()
    cclog(cc.Director:getInstance():getTextureCache():getCachedTextureInfo())

   
    
	GameSound.PlayMusic(SoundType.BG_MAIN)
end

function  GameScene:initData()

   
    self.fb_isFinish = false
    self.appear = CreateSpineRes("effect/guai_in")
    self.smoke = CreateSpineRes("Spine/effect/smoke")
    self.heal = CreateSpineRes("Spine/effect/jiaxie")
    CreateSpineRes("res/effect/effect_shibao_boss")
    CreateSpineRes("res/effect/E_34_0")
    CreateSpineRes("res/effect/E_24_0")
    
    ui_node_base      = self:getChildByTag(1000)
    ui_node           = ui_node_base:getChildByTag(110)
    Hero_HP_node      = ui_node:getChildByTag(GameControlLayer.NodeEnum.roleBar):getChildByTag(1):getChildByTag(1):getChildByTag(1)
    --Hero_Energybar_node  = ui_node:getChildByTag(GameControlLayer.NodeEnum.roleBar):getChildByTag(2):getChildByTag(2)
    --Hero_Energy_node  = ui_node:getChildByTag(GameControlLayer.NodeEnum.roleBar):getChildByTag(4)
    BOSS_Bar_node     = ui_node:getChildByTag(GameControlLayer.NodeEnum.bossBar)
    BOSS_HP_node      = BOSS_Bar_node:getChildByTag(1):getChildByTag(1)
    BOSS_Head_node    = BOSS_Bar_node:getChildByTag(1):getChildByTag(2)
    BOSS_Name_node    = BOSS_Bar_node:getChildByTag(3)
    --BOSS_Sheild_node  = ui_node:getChildByTag(12)
    --BOSS_Sheild_bar   = BOSS_Sheild_node:getChildByTag(2)
    Combo_node        = ui_node:getChildByTag(GameControlLayer.NodeEnum.combo)
    Combo_Num_node    = Combo_node:getChildByTag(1)
    Time_node         = ui_node:getChildByTag(GameControlLayer.NodeEnum.time)
    --Time_Progess_node = Time_node:getChildByTag(1):getChildByTag(1)
    Time_FBName_node  = Time_node:getChildByTag(1):getChildByTag(1)
    Time_Time_node    = Time_node:getChildByTag(1):getChildByTag(2)
    Go_Tip_node       = ui_node:getChildByTag(GameControlLayer.NodeEnum.gotips)
    --Drink_node        = ui_node:getChildByTag(GameControlLayer.NodeEnum.drinkButton)
    
    Enemy_HP_node      = ui_node:getChildByTag(10):getChildByTag(1):getChildByTag(1):getChildByTag(1)
    --Enemy_Energybar_node  = ui_node:getChildByTag(0):getChildByTag(2):getChildByTag(2)
    --Enemy_Energy_node  = ui_node:getChildByTag(0):getChildByTag(4)
    
    --counter_node = ui_node_base:getChildByTag(888)
    --counter_count = counter_node:getChildByTag(4)
    --counter_bar = counter_node:getChildByTag(2)
    --counter_Animation = counter_node:getChildByTag(3)
    
    self.Combo_node = Combo_node
    self.Combo_node_2 = Combo_Num_node
    --self.Energy_node = Hero_Energy_node
    --self.E_Energy_node = Enemy_Energy_node
--    
--    if GameManager.FB_Value.fb_id == 10000 then 
--        local Time_Pause_button = Time_node:getChildByTag(1):getChildByTag(2):getChildByTag(1)
--        Time_Pause_button:setVisible(false)
--    end
    
    local fbData = GameDataTransfer.GetGameFB(GameManager.FB_Value.fb_id)--获取副本信息
    
    local fbName = GameDataTransfer.GetGameString(fbData.name)
    
--    local time_sward = Time_node:getChildByTag(1):getChildByTag(1):getChildByTag(1)
--    local time_flag = Time_node:getChildByTag(1):getChildByTag(1):getChildByTag(2)
--    local FBMC = ui_node:getChildByTag(8):getChildByTag(1)
--    local FBMC_NAME = FBMC:getChildByTag(2)
--    
--    FBMC_NAME:setString(fbName)
--    
--    FBMC:runAction(cc.FadeOut:create(2))
--    
--    time_sward:setVisible(false)
--    time_flag:setVisible(false)
    
    Time_FBName_node:enableOutline(cc.c4b(0,0,0,255),2)
    Time_FBName_node:setString(fbName)
    
    GameScene.showUI(0.1,false)
--    if List.getSize(nowPlayer) >1 then self.show_teammate = true else self.show_teammate = false end
--    
--    local ui_node_base = self:getChildByTag(1000)
--    local ui_node = ui_node_base:getChildByTag(110)
--    local control_node = ui_node:getChildByTag(GameControlLayer.NodeEnum.teammate)
--    
--    control_node:setVisible(self.show_teammate)
    --setMotionSpeed(0.3)
end

function GameScene.setWaveInfo(m_count)
    Time_Progess_node:setVisible(true)
    local waveText = Time_Progess_node:getChildByTag(3)
    local tempProgessBar = Time_Progess_node:getChildByTag(0):getChildByTag(2)
    local nowText = "第 ".. 0 .."/" .. m_count .. " 波"
    waveText:setString(nowText)
    waveText:enableOutline(cc.c4b(0,0,0,255),2)
    tempProgessBar:setPercentage(0)
end

function GameScene.nextWave(nowW,maxW)
    
    local waveText = Time_Progess_node:getChildByTag(3)
    local tempProgessBar = Time_Progess_node:getChildByTag(0):getChildByTag(2)
    local nowText = "第 ".. nowW .."/" .. maxW .. " 波"
    waveText:setString(nowText)
    
    local nowPercent = mathFloor(nowW/maxW*100)
    tempProgessBar:runAction(cc.ProgressTo:create(0.3,nowPercent))
end

local showUIState = true

function GameScene.showUI(moveTime,m_show)
    local pause_bar = ui_node:getChildByTag(GameControlLayer.NodeEnum.pause)
    local heroBar = ui_node:getChildByTag(GameControlLayer.NodeEnum.roleBar)
    local dirBar  = ui_node:getChildByTag(GameControlLayer.NodeEnum.direction)
    local timeBar  = ui_node:getChildByTag(GameControlLayer.NodeEnum.time)
    local buttonBar  = ui_node:getChildByTag(GameControlLayer.NodeEnum.button)
    local drinkBar = ui_node:getChildByTag(GameControlLayer.NodeEnum.drinkButton)
    local TeamBar = ui_node:getChildByTag(GameControlLayer.NodeEnum.changeButton)
    local showEnd
    
    function showEnd()
        GameManager.FB_Value.GameUI_isShow = m_show
    end
   
         
    if m_show == false and m_show ~= showUIState  then
        showUIState = m_show
        pause_bar:stopAllActions()
        heroBar:stopAllActions()
        dirBar:stopAllActions()
        drinkBar:stopAllActions()
        timeBar:stopAllActions()
        buttonBar:stopAllActions()
        TeamBar:stopAllActions()
                
        pause_bar:runAction(cc.EaseInOut:create(cc.MoveTo:create(moveTime,{x = 1920 , y =459}),3))
        heroBar:runAction(cc.EaseInOut:create(cc.MoveTo:create(moveTime,{x = -640 , y =920}),3))
        TeamBar:runAction(cc.EaseInOut:create(cc.MoveTo:create(moveTime,{x = -640 , y =0}),3))
        dirBar:runAction(cc.EaseInOut:create(cc.MoveTo:create(moveTime,{x = -480 , y =-200}),3))
        drinkBar:runAction(cc.EaseInOut:create(cc.MoveTo:create(moveTime,{x = -416 , y =-200}),3))
        timeBar:runAction(cc.EaseInOut:create(cc.MoveTo:create(moveTime,{x = 640 , y =920}),3))
        buttonBar:runAction(cc.EaseInOut:create(cc.Sequence:create(cc.MoveTo:create(moveTime,{x = 1920 , y =-200}),cc.CallFunc:create(showEnd)),3))
    elseif m_show == true and m_show ~= showUIState then
        showUIState = m_show
        
        pause_bar:stopAllActions()
        heroBar:stopAllActions()
        dirBar:stopAllActions()
        drinkBar:stopAllActions()
        timeBar:stopAllActions()
        buttonBar:stopAllActions()
        TeamBar:stopAllActions()
        
        pause_bar:runAction(cc.EaseInOut:create(cc.MoveTo:create(moveTime,{x = 1231 , y =459}),3))
        heroBar:runAction(cc.EaseInOut:create(cc.MoveTo:create(moveTime,{x = 0 , y =720}),3))
        TeamBar:runAction(cc.EaseInOut:create(cc.MoveTo:create(moveTime,{x = 0 , y =0}),3))
        dirBar:runAction(cc.EaseInOut:create(cc.MoveTo:create(moveTime,{x = 0 , y =0}),3))
        drinkBar:runAction(cc.EaseInOut:create(cc.MoveTo:create(moveTime,{x = 64 , y =235}),3))
        timeBar:runAction(cc.EaseInOut:create(cc.MoveTo:create(moveTime,{x = 640 , y =679}),3))
        buttonBar:runAction(cc.EaseInOut:create(cc.Sequence:create(cc.MoveTo:create(moveTime,{x = 1280 , y =0}),cc.CallFunc:create(showEnd)),3))
    end
end



function GameScene.updateEnemyName(m_name,obj)   --更新敌人名字
    

    local mathFloor = math.floor

    --local TextLv = control_node:getChildByTag(4)
    local TextName = BOSS_Name_node
--    local propety = TextName:getParent():getChildByTag(4)
    --TextLv:setVisible(false)

    local icon =  BOSS_Head_node
    local obj_model_id = obj.model_id
    local tempNum = mathFloor(obj_model_id/10)
    local ten =obj_model_id -  tempNum*10
    local finalNum = obj_model_id

    --if ten >1 then finalNum = tempNum*10 +1 end
    --if obj_model_id 
    local imagePath = string.format("Icons/poto/%d.png",finalNum)
    icon:loadTexture(imagePath,ccui.TextureResType.localType)

    icon:setScaleX(-1)
    icon:setPositionX(-63)
    icon:setPositionY(-57)
    TextName:setString(m_name)
    TextName:enableShadow()
    TextName:enableOutline(cc.c4b(0,0,0,255),2)
    
--    propety:removeAllChildren()
--   
--    
--    local tempList = obj.resist_list
--       
--    if tempList.minor_injured > 1 or tempList.serious_injured > 1 then
--        
--        GameScene.addPropertyText(propety,4)
--    end
--    if tempList.inair > 1 then
--        GameScene.addPropertyText(propety,3)
--    end
--    if tempList.stun > 1 then
--        GameScene.addPropertyText(propety,1)
--    end
--    if tempList.knockback > 1 or tempList.knockout > 1 or tempList.hitMove > 1 then
--        GameScene.addPropertyText(propety,2)
--    end
--    if tempList.strike > 1  then
--        GameScene.addPropertyText(propety,5)
--    end
--    propety:setTouchEnabled(false)
    
end

function GameScene.addPropertyText(m_scrollview,m_index)
    local path = "FBZD-2boss-wz"..m_index..".csb"
    local temp = cc.CSLoader:createNode(path)
    local temp1 = temp:getChildByTag(1)
    temp1:removeFromParent()
    
--    local nowParameter = ccui.LinearLayoutParameter:create()
--    nowParameter:setGravity(ccui.LinearGravity.right)
--    temp1:setLayoutParameter(nowParameter)
    local tempWidth = temp1:getContentSize().width
    
    m_scrollview:addChild(temp1)
    
    local allItem = m_scrollview:getChildren()
    
    if #allItem == 1 then
        temp1:setPosition(390 - tempWidth/2,25)
    else
        local fixX = allItem[#allItem-1]:getPositionX() - allItem[#allItem-1]:getContentSize().width/2
        temp1:setPosition(fixX - tempWidth/2,25)
    end
    
end

function  GameScene:releaseData()
    ui_node_base      = nil
    ui_node           = nil
    Hero_HP_node      = nil
    Hero_Energybar_node  = nil
    Hero_Energy_node  = nil
    BOSS_Bar_node     = nil
    BOSS_HP_node      = nil
    BOSS_Head_node    = nil
    BOSS_Name_node    = nil
    BOSS_Sheild_node  = nil
    BOSS_Sheild_bar   = nil
    Combo_node        = nil
    Combo_Num_node    = nil
    Time_node         = nil
    Time_Progess_node = nil
    Time_FBName_node  = nil
    Time_Time_node    = nil
    Go_Tip_node       = nil
    Drink_node        = nil
    
    counter_node = nil
    counter_count = nil
    counter_bar = nil
    counter_Animation = nil
    
    Enemy_HP_node = nil   
    Enemy_Energybar_node  = nil
    Enemy_Energy_node  = nil
    
    self.Combo_node = nil
    self.Combo_node_2 = nil
    self.Energy_node = nil
    self.E_Energy_node = nil
    self.BackLayer = nil

    --ccui.ImageView
    self.bg_remote = nil
    self.bg_remote_y = nil

    self.bg_medium_1 = nil
    self.bg_medium_1_y = nil

    self.bg_medium = nil
    self.bg_medium_y = nil

    self.bg_foreground = nil
    self.bg_foreground_y = nil

    self.bg_new_foreground_1 = nil
    self.bg_new_foreground_1_y = nil

    self.mask_ground_1 = nil
    self.mask_ground_1_y = nil
    
    self.game_layout = nil
    
    self.node_bg = nil
    

    self.bg_boundingBoxs = nil
    self.bg_boundingBoxs_y = nil
end

function GameScene.changeComboNum( m_value )

    Combo_Num_node:setString(""..m_value)
    local actionBy1 = cc.ScaleTo:create(0.1, 1.5, 1.5)
    local actionBy2 = cc.ScaleTo:create(0.1, 1.0, 1.0)
    local nowAction = cc.Sequence:create(actionBy1,actionBy2)
    
    Combo_Num_node:runAction(nowAction)

end


function GameScene:resetList()
    
    self.playerList = nil
    self.nowMonsterList = nil
    self.nowBulletList = nil
    self.nowShadowList = nil
    self.now_DropItem = nil
    
    
    if self.AllPlayerList ~= nil  then List.removeAll(self.AllPlayerList) end
    if self.tempPlayerList ~= nil  then List.removeAll(self.tempPlayerList) end
    
    if nowPlayer ~= nil and List.getSize(nowPlayer) > 0 then
        for i=1,List.getSize(nowPlayer) do
            --table.print(nowPlayer[i])
          nowPlayer[i]:delete()
        end
        List.removeAll(nowPlayer)
    end
    
    if  nowWaitPlay ~= nil and List.getSize(nowWaitPlay) > 0 then
        for i=1,List.getSize(nowWaitPlay) do
          nowWaitPlay[i]:delete()
        end
        List.removeAll(nowWaitPlay)
    end
    
    if  nowmonster ~= nil and List.getSize(nowmonster) > 0 then
        for i=1,List.getSize(nowmonster) do
          nowmonster[i]:delete()
        end
        List.removeAll(nowmonster)
    end

    if  nowBullet ~= nil and List.getSize(nowBullet) > 0 then
        for i=1,List.getSize(nowBullet) do
            nowBullet[i]:delete()
        end
        List.removeAll(nowBullet)
    end
    
    if  nowDropItem ~= nil and List.getSize(nowDropItem) > 0 then
        for i=1,List.getSize(nowDropItem) do
            nowDropItem[i]:delete()
        end
        List.removeAll(nowDropItem)
    end
    
    if QteSeq ~= nil and List.getSize(QteSeq) > 0 then
        for i=1,List.getSize(QteSeq) do
            QteSeq[i]:delete()
        end
        List.removeAll(QteSeq)
    end
    table.clean(nowShadow)
    
   
    if  self.kill_id_list ~= nil then List.removeAll(self.kill_id_list) end
    
    
    nowPlayer=nil
    nowWaitPlay = nil 
    nowmonster=nil
    nowBullet=nil
    QteSeq = nil
    nowShadow={}
    nowDropItem = nil 
	self.kill_id_list = nil
    self.tempPlayerList = nil
    self.AllPlayerList = nil
end
function GameScene:playBgMusic()

    Sound_PlayMusic(res_snd.background)
    
    local effectPath = cc.FileUtils:getInstance():fullPathForFilename(res_snd.effect1)
    --cc.SimpleAudioEngine:getInstance():preloadEffect(effectPath)
end


-- create layer
function GameScene:createLayer()
    self.game_layout = ccui.Layout:create()
    
    self.game_layout:setAnchorPoint(0,0)
    self.game_layout:setContentSize({width = 1280,height = 720})
    self.game_layout:setClippingEnabled(true)
    self.game_layer  = cc.Layer:create()
    
    
    
    self:resetList()
    
    nowPlayer=List.new()
    nowWaitPlay = List.new()
    nowmonster=List.new()
    nowBullet=List.new()
    QteSeq = List.new()
    nowShadow=List.new()
    nowDropItem = List.new()
    self.tempPlayerList = List.new()
    self.kill_id_list = List.new()
    self.AllPlayerList = List.new()
    
    self.playerList = nowPlayer
    self.nowMonsterList = nowmonster
    self.nowBulletList = nowBullet
    self.nowShadowList = nowShadow
    self.now_DropItem = nowDropItem
    
    self.game_layer:addChild(self.game_layout,1,666)
    self.game_layout:setPosition(0,0)
    -- add in farm background
    self:addBackgroundLayer(self.game_layout)
    
    if GameManager.FB_Value.is_3v3 == true then
        --GameManager.FB_Value.ultra_mode = GameManager.FB_Value.attFormation[1].modeId
        self:addHero(1580,216,GameManager.FB_Value.attFormation[1].roleID,1)
    else
        self:addHero(300,215,1,1)
        if GameRecorder.GetRole(2).unlock > 0 then
            self:addWaitHero(-1000,3000,2,1)
        end

        if GameRecorder.GetRole(3).unlock > 0 then
            self:addWaitHero(-1000,3000,3,1)
        end        
        -- self:addWaitHero(-1000,3000,3,1)
    end

    
    
    

    nowSceneScale = 1
    
    local nowDir = 1
    if GameManager.FB_Value.fb_type >= 7 then nowDir = 0 end
    self:setHeroFollowType(0)
    
    self:addForegroundLayer(self.game_layout)
    
    local function UpDate(dt)
        TimerQuest:Instance():Update(Time_GetCurrentTime())
        self:updateLayer(dt)
    end
    
    self:scheduleUpdateWithPriorityLua(UpDate,0)
    
    
--    local function onContactBegin(contact)
--        local a = contact:getShapeA():getBody()
--        local b = contact:getShapeB():getBody()
--
--        local objA=nil
--        local objB=nil
--
--        if a:getCollisionBitmask() == 3 or b:getCollisionBitmask() == 3 then
--            
--            if a:getCollisionBitmask() == 2 then
--                objA=a:getNode()
--                objA:isHitGround()
--            elseif b:getCollisionBitmask() == 2 then
--                objB=b:getNode()
--                objB:isHitGround()
--            end
--            
--            
--        end
--
--        return true
--    end
--
--
--    local contactListener = cc.EventListenerPhysicsContact:create()
--    contactListener:registerScriptHandler(onContactBegin, cc.Handler.EVENT_PHYSICS_CONTACT_BEGIN)
--    local eventDispatcher = self:getEventDispatcher()
--    eventDispatcher:addEventListenerWithSceneGraphPriority(contactListener, self)
    

    return self.game_layer
end

function GameScene:addBackgroundLayer(layerFarm)

    --local test_node=cc.CSLoader:createNode("test/2-huodong.csb")
    local nowId=GameManager.FB_Value.fb_map_id
    --GameManager.FB_Value.fb_map_id = 6011
    
    
    local mapPath=string.format("Scenes/%d.csb",GameManager.FB_Value.fb_map_id)
    local node_bg = cc.CSLoader:createNode(mapPath)
    local tl = cc.CSLoader:createTimeline(mapPath)
    --local node_bg = cc.CSLoader:createNode("MAP_1.csb")
    --local tl = cc.CSLoader:createTimeline("MAP_1.csb")
    
    self.BackLayer = GameAssistor.CreateMaskLayout(cc.c3b(0,0,0),180)
   
    --ccui.ImageView
    self.bg_remote = node_bg:getChildByTag(1)
    self.bg_remote_y = self.bg_remote:getPositionY()
    
    self.bg_medium_1 = node_bg:getChildByTag(2)
    self.bg_medium_1_y = self.bg_medium_1:getPositionY()
    
--    self.bg_medium = node_bg:getChildByTag(3)
--    self.bg_medium_y = self.bg_medium:getPositionY()
    
    self.bg_foreground = node_bg:getChildByTag(3)
    self.bg_foreground_y = self.bg_foreground:getPositionY()
    
--    self.bg_new_foreground_1 = node_bg:getChildByTag(5)
--    self.bg_new_foreground_1_y = self.bg_new_foreground_1:getPositionY()
    
    --self.mask_ground_1 = node_bg:getChildByTag(7)
    --self.mask_ground_1_y = self.mask_ground_1:getPositionY()
    
    local targetPlatform = cc.Application:getInstance():getTargetPlatform()

    local IS_ANDROID_OS = false
    IS_ANDROID_OS = (cc.PLATFORM_OS_ANDROID==targetPlatform)
    
--    local allNode = node_bg:getChildren()
--    local checkAllNode
--    
--    function checkAllNode(nowNode)
--       
--        for key, var in pairs(nowNode) do
--                local newNode = var:getChildren()
--                if newNode and #newNode > 0 then
--                    checkAllNode(newNode)
--                end
--                if var.setPositionType then
--                    if IS_ANDROID_OS == true and GameManager.FB_Value.fb_id ~= 10000 then
--                        var:removeFromParent()
--                    else
--                        var:setPositionType(cc.POSITION_TYPE_GROUPED)
--                    end
--                end
--            
--        end
--    
--    end
--    checkAllNode(allNode)
   
    
    --self.node_bg_test = cc.CSLoader:createNode("luweidang01.csb")
    --self.node_bg_test = xxtest
    --local count=self.bg_foreground:getChildrenCount()
    
    --local ChildrenArray= self.bg_foreground:getChildren()
   
    --local testrect=ChildrenArray[1]:getBoundingBox()
    --local tl = cc.CSLoader:createTimeline("xiaoyucun.csb")
    --local testpartile=node_bg:getChildByName("Particle_1")

    --testpartile:setPositionType(cc.POSITION_TYPE_GROUPED)

    --node_bg:runAction(tl)
    --tl:gotoFrameAndPlay(0,true)
    self.bg_foreground:addChild(self.BackLayer,res_gameLayer.LAYER_BG,3000)
    
    self.BackLayer:setVisible(false)
    
    self.node_bg = node_bg
--    local node_bg_2 = cc.CSLoader:createNode("yucun3.csb")
--    self.bg_test =node_bg_2:getChildByName("ship")
--    local all_rect=self.bg_test:getChildren()
    
--    
--    
--    for key,value in pairs(all_rect) do
--        local tempRect=cc.rect(value:getPositionX(),value:getPositionY(),value:getContentSize().width*value:getScaleX(),value:getContentSize().height*value:getScaleY())
--        List.pushlast(testList,tempRect)
--        
--    end
    
    layerFarm:addChild(self.node_bg,res_gameLayer.LAYER_BG,200)
    --layerFarm:addChild(self.node_bg_test,2)
    
    if tl then    --and IS_ANDROID_OS ~= true
        node_bg:runAction(tl)
        tl:gotoFrameAndPlay(0,true)
    end
    
    
    --layerFarm:addChild(self.bg_foreground,res_gameLayer.LAYER_BG)
     --cc.Node:getTag()
    --self.bg_boundingBoxs = self.node_bg:getChildByTag(6)
    
    self.bg_boundingBoxs = self.node_bg:getChildByTag(4)
    self.bg_boundingBoxs_2 = self.node_bg:getChildByTag(5)
    self.bg_boundingBoxs_y = self.bg_boundingBoxs:getPositionY()
    
    --self.bg_boundingBoxs = self.node_bg_test:getChildByTag(4)
    --self.bg_boundingBoxs:setVisible(false)
    
    self.all_boundingBoxs = List.new()
    self.all_boundingBoxs_big = List.new()
    
    local allground = self.bg_boundingBoxs:getChildren()
    local allground2 = self.bg_boundingBoxs_2:getChildren()
    
    cclog("allground all size = %d",#allground)
    cclog("allground2 all size = %d",#allground2)
    
    for key, var in ipairs(allground) do
        local rectBig=var:getBoundingBox()
        List.pushlast(self.all_boundingBoxs_big,rectBig)        
        local textureRect = var:getTextureRect()
        local anchor = var:getAnchorPoint()
        local scaleX=var:getScaleX()
        local scaleY=var:getScaleY()
        local tempWidth=textureRect.width*scaleX
        local tempHeight=textureRect.height*scaleY

        
        local tempx = -1*tempWidth*anchor.x
        local tempy = -1*tempHeight*anchor.y

        local rect=cc.rect(tempx,tempy,tempWidth,tempHeight)
        local tempPx,tempPy = var:getPosition()
        local mPosition=cc.p(tempPx,tempPy)
        local tl,tr = boundingPointTLR(rect,1,var:getRotationSkewX()*-1,mPosition)
        
        local tempBox = { a = tl , b = tr }
        List.pushlast(self.all_boundingBoxs,tempBox)
    end
    
    for key, var in ipairs(allground2) do
        local rectBig=var:getBoundingBox()

        local textureRect = var:getTextureRect()
        local anchor = var:getAnchorPoint()
        local scaleX=var:getScaleX()
        local scaleY=var:getScaleY()
        local tempWidth=textureRect.width*scaleX
        local tempHeight=textureRect.height*scaleY


        local tempx = -1*tempWidth*anchor.x
        local tempy = -1*tempHeight*anchor.y

        local rect=cc.rect(tempx,tempy,tempWidth,tempHeight)
        local tempPx,tempPy = var:getPosition()
        local mPosition=cc.p(tempPx,tempPy)
        local tl,tr = boundingPointTLR(rect,1,var:getRotationSkewX()*-1,mPosition)

        local tempBox = { a = tl , b = tr }
        List.pushlast(self.all_boundingBoxs,tempBox)
    end
    
    
    
    if ISDEBUG and ISDEBUG == 3 then
        self.draw = cc.DrawNode:create()
        layerFarm:addChild(self.draw,50)
    end

    
    

end

function GameScene:addForegroundLayer(layerFarm)

    --layerFarm:reorderChild(self.bg_foreground,res_gameLayer.LAYER_BG)
--    layerFarm:reorderChild(self.bg_new_foreground_1,res_gameLayer.LAYER_FG)


end
function GameScene:showCounterUI(count)
    local function active()
        counter_Animation:addAnimation(0,"animation", false)
        GameManager.ShowNormalAttackButton(false)
    end
    counter_bar:setPercentage(100)
    counter_count:setString(""..count)
    counter_bar:runAction(cc.Sequence:create(cc.ProgressTo:create(1.5,0),cc.CallFunc:create(active)))
    
    
    counter_node:setVisible(true)
end

function GameScene:closeCounterUI()
   
    counter_bar:setPercentage(100)
    counter_count:setString("1")

    counter_Animation:setToSetupPose()
    
    GameManager.finishCounter(false)
    counter_node:setVisible(false)
end

function GameScene:setCounterCount(num)
    counter_count:setString(""..num)
    local actionBy1 = cc.ScaleTo:create(0.1, 1.5, 1.5)
    local actionBy2 = cc.ScaleTo:create(0.1, 1.0, 1.0)
    local nowAction = cc.Sequence:create(actionBy1,actionBy2)

    counter_count:runAction(nowAction)
end

function GameScene:addHeroBullet(m_currentActor,m_x,m_y,m_speed,angle)
    local m_gc = self
    local newBullet=Bullet.creat(m_x,m_y,m_speed,angle,m_currentActor._curFacing,6,nowmonster,nil,m_gc)
    List.pushlast(nowBullet,newBullet)

    m_gc.game_layout:addChild(nowBullet[List.getSize(nowBullet)],res_gameLayer.LAYER_PLAYER2)
end

function GameScene:addShadow(m_x,m_y,m_currentActor)
    local m_gc = self
    local newShadow=Shadow.creat(m_x,m_y,m_currentActor._actor_id)
    
    nowShadow[m_currentActor._actor_id] = newShadow

    m_gc.game_layout:getChildByTag(200):getChildByTag(3):addChild(newShadow._sprite,res_gameLayer.LAYER_BG_EFFECT)
end

function GameScene:addDropItemN(m_x,m_y,item_id,fixX,nums,end_type)
    local m_gc = self
    local newDropItem=DropItem.creat(m_x,m_y,item_id,fixX,nums,end_type)

    List.pushlast(nowDropItem,newDropItem)

    m_gc.game_layout:getChildByTag(200):getChildByTag(3):addChild(newDropItem.shadowNode,res_gameLayer.LAYER_BG_EFFECT)
    m_gc.game_layout:getChildByTag(200):getChildByTag(3):addChild(newDropItem.baseNode,res_gameLayer.LAYER_BG_EFFECT+1)
end

function GameScene:addDropItemB(m_x,m_y,item_id,fixX,nums)
    local m_gc = self
    local newDropItem=DropItem.creat(m_x,m_y,item_id,fixX,nums)

    List.pushlast(nowDropItem,newDropItem)

    m_gc.game_layout:getChildByTag(200):getChildByTag(3):addChild(newDropItem.baseNode,res_gameLayer.LAYER_BG_EFFECT+1)
end

function GameScene:addHero(m_x,m_y,m_actor_id,type)
    local m_gc = self
    local hero = Hero.create(m_x,m_y,m_actor_id,m_gc,type)
    
--    hero.powerUP = cc.ParticleSystemQuad:create("effect/particle_powerUp.plist")
--    hero:addChild(hero.powerUP)
--    hero:reorderChild(hero.powerUP, -1)
--    hero.powerUP:setEmissionRate(50)

    List.pushlast(nowPlayer,hero)
    
    List.pushlast(self.tempPlayerList,hero)
    List.pushlast(self.AllPlayerList,hero)
    
    self:addShadow(m_x,m_y,nowPlayer[1])
    
    self.follow_target =  self.playerList[1]
    self.playerList[1]:setTarget(self.nowMonsterList)
    
    --layerFarm:addChild(nowPlayer[1],res_gameLayer.LAYER_PLAYER2)

---------------------------------------
    
end

function GameScene:addWaitHero(m_x,m_y,m_actor_id,type)
    local m_gc = self
    local hero = Hero.create(m_x,m_y,m_actor_id,m_gc,type)

    --    hero.powerUP = cc.ParticleSystemQuad:create("effect/particle_powerUp.plist")
    --    hero:addChild(hero.powerUP)
    --    hero:reorderChild(hero.powerUP, -1)
    --    hero.powerUP:setEmissionRate(50)

    List.pushlast(nowWaitPlay,hero)

    --List.pushlast(self.tempPlayerList,hero)
    --List.pushlast(self.AllPlayerList,hero)

    --self:addShadow(m_x,m_y,hero)
    
    hero._spine:setPosition(m_x,m_y)
    hero.role_effect:setPosition(m_x,m_y)
  
    hero:setTarget(self.nowMonsterList)

    --layerFarm:addChild(nowPlayer[1],res_gameLayer.LAYER_PLAYER2)

    ---------------------------------------

end

function GameScene:addHeroRole(m_x,m_y,m_id,m_actor_id,type,m_data)
    local m_gc = self
    local hero = Hero.create(m_x,m_y,m_id,m_gc,type,m_data)

    --    hero.powerUP = cc.ParticleSystemQuad:create("effect/particle_powerUp.plist")
    --    hero:addChild(hero.powerUP)
    --    hero:reorderChild(hero.powerUP, -1)
    --    hero.powerUP:setEmissionRate(50)
    
    hero._actor_id = m_actor_id

    List.pushlast(nowmonster,hero)
    
    hero._AIEnabled=true
    
    GameManager.setMonsterShow(hero,m_x,m_y,4)
    
    hero:setTarget(nowPlayer)
    hero:setFacing(nowPlayer[1])
    self:addShadow(m_x,m_y,nowmonster[List.getSize(nowmonster)])

    hero:setEliteMark()
    --layerFarm:addChild(nowPlayer[1],res_gameLayer.LAYER_PLAYER2)

    ---------------------------------------

end

function GameScene:addBoss(m_x,m_y,m_id,AI,speed,wave_id,relation,m_actor_id)
    local m_gc = self

    local Monster = Boss.create(m_x,m_y,m_id,m_gc,3)
--    Monster.powerUP = cc.ParticleSystemQuad:create("effect/particle_powerUp.plist")
--    Monster:addChild(Monster.powerUP)
--    Monster:reorderChild(Monster.powerUP, -1)
--    Monster.powerUP:setEmissionRate(50)

    Monster._actor_type = 3
    Monster:setTarget(nowPlayer)
    Monster._AIEnabled=true

    List.pushlast(nowmonster,Monster)

    if AI then Monster._ai_level = AI else   Monster._ai_level = 3 end
    if speed then Monster.speed_x = speed/defaultFPS end
    if wave_id then Monster._wave_id=wave_id end
    

    Monster._actor_id=m_actor_id
    Monster._is_boss = true
    --Monster._hp = 1
    --Monster._ai_should_hit=false

    if PINGTEST then
        Monster._hp = 1
    end
    
    GameManager.setMonsterShow(Monster,m_x,m_y,4)
    
    self:addShadow(m_x,m_y,nowmonster[List.getSize(nowmonster)])
    --m_gc.game_layout:getChildByTag(200):getChildByTag(4):addChild(nowmonster[List.getSize(nowmonster)],res_gameLayer.LAYER_PLAYER1)
end

function GameScene:addMonster(m_x,m_y,m_id,AI,speed,wave_id,relation,search_range,m_actor_id,hpLayer,appearStyle,appearDir)

    local m_gc = self
    local nowNpc =  GameDataTransfer.GetNPC(m_id) 
    
    local nowMType = nowNpc.type
    local isElite = false
    local nowMonster
     
    if nowMType < 4 then
        nowMonster = Monster.create(m_x,m_y,m_id,m_gc,2)
        nowMonster._AIEnabled=true
        if nowMType == 3 then
            nowMonster._is_boss = true
            GameManager.updateEnemyName(nowMonster.actor_name,nowMonster)
        elseif nowMType == 2 then
--            local action2 = cc.TintBy:create(0.5, 255, 255, 255)
--            local action2Back = action2:reverse()
--            local tintAct = cc.Sequence:create(action2,action2Back)
--            local repeatAction = cc.RepeatForever:create(tintAct)
--            nowMonster._spine:runAction(repeatAction)
            isElite = true
            
            
        end
        
 
        
        nowMonster._actor_type = 2
        nowMonster:setTarget(self.tempPlayerList)
        
    elseif nowMType == 4 then
        nowMonster = TreeActor.create(m_x,m_y,m_id,m_gc,2)
        nowMonster._AIEnabled=false
        nowMonster._actor_type = 2
        nowMonster:setTarget(self.tempPlayerList)
        
    elseif nowMType == 5 then
        nowMonster = Monster.create(m_x,m_y,m_id,m_gc,2)
        nowMonster._AIEnabled=false
        nowMonster._is_boss = true
        nowMonster._actor_type = 1
        nowMonster.actor_is_friend = true
        nowMonster:setTarget(self.tempPlayerList)
        GameManager.updateEnemyName(nowMonster.actor_name,nowMonster)
        nowMonster._spine:setLocalZOrder(90)
        GameManager.FB_Value.SpeacilFb = 1
    elseif nowMType == 6 then
        nowMonster = Monster.create(m_x,m_y,m_id,m_gc,2)
        nowMonster._AIEnabled=false
        nowMonster._is_boss = true
        nowMonster._actor_type = 1
        nowMonster.actor_is_friend = true
        nowMonster:setTarget(self.tempPlayerList)
        GameManager.updateEnemyName(nowMonster.actor_name,nowMonster)
        --GameManager.FB_Value.SpeacilFb = 1
    end
--    Monster.powerUP = cc.ParticleSystemQuad:create("effect/particle_powerUp.plist")
--    Monster:addChild(Monster.powerUP)
--    Monster:reorderChild(Monster.powerUP, -1)
--    Monster.powerUP:setEmissionRate(50)
    nowMonster.hpLayer = hpLayer
    if  nowMonster._is_boss == true then   --hpLayer and hpLayer >= 0 and
        Boss_Last_Sheild = 100
        if hpLayer == 0 then hpLayer = 1 end
        
        if GameManager.FB_Value.is_world_boss == true then
            self:setWorldBossHpLayer(GameManager.FB_Value.world_boss_now_hp)
        else
            self:setBossHpLayerWithEachHp(nowMonster.LifePerLayer,nowMonster._hp_max)
            --self:SetBossHpLayer(hpLayer,nowMonster._hp_max)
        end
    end
    
    if relation ==  1 then
        List.pushlast(self.tempPlayerList,nowMonster)
        List.pushlast(self.AllPlayerList,nowMonster)
        List.pushlast(nowmonster,nowMonster)
    elseif relation ==  2 then
        List.pushlast(nowmonster,nowMonster)
        List.pushlast(self.AllPlayerList,nowMonster)
    elseif relation ==  3 then
        List.pushlast(nowmonster,nowMonster)
        nowMonster:setTarget(self.AllPlayerList)
        nowMonster._actor_type = 5
        nowMonster._isInvincible = true --陷阱类的2边都打的处于无敌状态
    end
        
    if AI then nowMonster._ai_level = AI else   nowMonster._ai_level = 3 end
    if speed then nowMonster.speed_x = speed/defaultFPS end
    if wave_id then nowMonster._wave_id=wave_id end
    if search_range then
        --nowMonster.AIActionValue[1] = search_range
        nowMonster._search_range = search_range
    end
    --if relation then  Monster._actor_type = relation end
    
    nowMonster._actor_id=m_actor_id
    
    
    --Monster._hp = 1
    --Monster._ai_should_hit=false
    
    if PINGTEST then
        nowMonster._hp = 1
    end
 
    --if nowMType ~= 2 then
    self:addShadow(m_x,m_y,nowmonster[List.getSize(nowmonster)])
    --end
    --m_gc.game_layout:getChildByTag(200):getChildByTag(4):addChild(nowmonster[List.getSize(nowmonster)],res_gameLayer.LAYER_PLAYER1)
    
    if nowMonster._is_boss == true then
        appearStyle = 4
    end
            
    GameManager.setMonsterShow(nowMonster,m_x,m_y,appearStyle,appearDir)
    if isElite == true then nowMonster:setEliteMark() end
end



function GameScene:updateHeroStatus(obj)
    
    
    local hp_percent=100
    local shield_percent=100

    if obj._hp > 0 then hp_percent=mathCeil((obj._hp/obj._hp_max)*100) else hp_percent=0 end
    --if obj._shield > 0 then shield_percent=mathCeil(100-((100-(obj._shield/obj._shieldMax)*100)*0.82)) else shield_percent=0 end
    
    Hero_HP_node:setPercent(hp_percent)
    --Hero_Energybar_node:setPercentage(shield_percent)
    
    if hp_percent < 26 then 
        GameManager.showHpWarnning(true)
    else
        GameManager.showHpWarnning(false)
    end
    
end

function GameScene:updateEnemyStatus(obj)


    local hp_percent=100
    local shield_percent=100

    if obj._hp > 0 then hp_percent=mathCeil((obj._hp/obj._hp_max)*100) else hp_percent=0 end
    --if obj._shield > 0 then shield_percent=mathCeil(100-((100-(obj._shield/obj._shieldMax)*100)*0.82)) else shield_percent=0 end

    Enemy_HP_node:setPercent(hp_percent)
    --Enemy_Energybar_node:setPercentage(shield_percent)

   
end

function GameScene:setWorldBossHpLayer(boss_hit_point)
    lastBossHpIndex = 0
    Boss_Hp_each = 300000
    local m_layercount = mathFloor(boss_hit_point / Boss_Hp_each)
    if boss_hit_point % Boss_Hp_each ~= 0 then m_layercount = m_layercount +1 end
    
    local nowFirstNode = BOSS_Bar_node:getChildByTag(1):getChildByTag(1):getChildByTag(1)
    local hp_root_node = BOSS_Bar_node:getChildByTag(1):getChildByTag(1)
    local LayerNode = BOSS_Bar_node:getChildByTag(3)
    local LayerCount  = LayerNode:getChildByTag(2)

    local orginX,orginY = nowFirstNode:getPosition()
    local orginScaleX = nowFirstNode:getScaleX()
    local orginScaleY = nowFirstNode:getScaleY()
    local cache = cc.SpriteFrameCache:getInstance()
    Boss_hp_index = m_layercount
    Boss_Last_hp = boss_hit_point
    cache:addSpriteFrames("3-FBZD.plist", "3-FBZD.png")
    
    local allHpNode = hp_root_node:getChildren()
    for key, var in pairs(allHpNode) do
        if var:getTag() > 0 then var:removeFromParent() end
    end
    Boss_Hp_table = {}
    local allHp = Boss_Hp_each * m_layercount
    
    for i=1, m_layercount do
        local tempProgessBar = nil
        if i < 6 then

            local temp_path = "3-FBZD/BOSSTX-d1-"..i..".png"

            local backImg =cc.Sprite:create()   --模板图片
            backImg:setSpriteFrame(temp_path)
            tempProgessBar = cc.ProgressTimer:create(backImg)
            tempProgessBar:setType(cc.PROGRESS_TIMER_TYPE_BAR)
            tempProgessBar:setPercentage(100)
            tempProgessBar:setMidpoint(cc.p(0,0.5))
            tempProgessBar:setBarChangeRate(cc.p(1, 0))

            hp_root_node:addChild(tempProgessBar,i,i)
            tempProgessBar:setScale(-1,0.4)
            tempProgessBar:setPosition({x = 0 , y = orginY })
            tempProgessBar:setVisible(true)
        else
            tempProgessBar = Boss_Hp_table[((i-6)%4)+2].hpNode
        end

        local restHp = boss_hit_point - (i*Boss_Hp_each)
        local nowEachPercent
        if restHp < 0 then 
            nowEachPercent = mathFloor(((Boss_Hp_each + restHp)/Boss_Hp_each)*100)
        else
            nowEachPercent = 100
        end

        local tempHp = {hpNode = tempProgessBar,maxHp = Boss_Hp_each,index = i,tempPercent = nowEachPercent }
        Boss_Hp_table[i] = tempHp

    end
    
    if m_layercount > 1 then
        LayerCount:setString(""..(m_layercount-1))
        local count = #Boss_Hp_table
        local rootNode = Boss_Hp_table[count].hpNode:getParent()
        rootNode:reorderChild(Boss_Hp_table[count-1].hpNode,99)
        rootNode:reorderChild(Boss_Hp_table[count].hpNode,100)
        Boss_Hp_table[count-1].hpNode:setPercentage(100)
        Boss_Hp_table[count].hpNode:setPercentage(Boss_Hp_table[count].tempPercent)
    else
        LayerNode:setVisible(false)
        Boss_Hp_table[1].hpNode:setPercentage(Boss_Hp_table[1].tempPercent)
    end
    
end

function GameScene:setBossHpLayerWithEachHp(now_Boss_Hp_each,boss_hit_point)
    lastBossHpIndex = 0
    Boss_Hp_each = now_Boss_Hp_each
    local m_layercount = mathFloor(boss_hit_point / Boss_Hp_each)
    if boss_hit_point % Boss_Hp_each ~= 0 then m_layercount = m_layercount +1 end
    
    local nowFirstNode = BOSS_Bar_node:getChildByTag(1):getChildByTag(1)
    local hp_root_node = BOSS_Bar_node:getChildByTag(1)
    local LayerNode = BOSS_Bar_node:getChildByTag(2)
    local LayerCount  = LayerNode:getChildByTag(1)

    local orginX,orginY = nowFirstNode:getPosition()
    local orginScaleX = nowFirstNode:getScaleX()
    local orginScaleY = nowFirstNode:getScaleY()
    local cache = cc.SpriteFrameCache:getInstance()
    Boss_hp_index = m_layercount
    Boss_Last_hp = boss_hit_point
    cache:addSpriteFrames("4-ZD.plist", "4-ZD.png")
    
    local allHpNode = hp_root_node:getChildren()
    for key, var in pairs(allHpNode) do
        if var:getTag() > 10 or var:getTag() == 1 then var:removeFromParent() end
    end
    Boss_Hp_table = {}
    local allHp = Boss_Hp_each * m_layercount
    
    for i=1, m_layercount do
        local tempProgessBar = nil
        if i < 6 then

            local temp_path = "4-ZD/LoadingBar_c"..i..".png"

            local backImg =cc.Sprite:create()   --模板图片
            backImg:setSpriteFrame(temp_path)
            tempProgessBar = cc.ProgressTimer:create(backImg)
            tempProgessBar:setType(cc.PROGRESS_TIMER_TYPE_BAR)
            tempProgessBar:setPercentage(100)
            tempProgessBar:setMidpoint(cc.p(0,0.5))
            tempProgessBar:setBarChangeRate(cc.p(1, 0))

            hp_root_node:addChild(tempProgessBar,i+2,i+10)
            tempProgessBar:setScale(orginScaleX*-1,orginScaleY)
            tempProgessBar:setPosition({x = orginX , y = orginY })
            tempProgessBar:setVisible(true)
        else
            tempProgessBar = Boss_Hp_table[((i-6)%4)+2].hpNode
        end

        local restHp = boss_hit_point - (i*Boss_Hp_each)
        local nowEachPercent
        if restHp < 0 then 
            nowEachPercent = mathFloor(((Boss_Hp_each + restHp)/Boss_Hp_each)*100)
        else
            nowEachPercent = 100
        end

        local tempHp = {hpNode = tempProgessBar,maxHp = Boss_Hp_each,index = i,tempPercent = nowEachPercent }
        Boss_Hp_table[i] = tempHp

    end
    
    if m_layercount > 1 then
        LayerCount:setString(""..(m_layercount-1))
        local count = #Boss_Hp_table
        local rootNode = Boss_Hp_table[count].hpNode:getParent()
        rootNode:reorderChild(Boss_Hp_table[count-1].hpNode,99)
        rootNode:reorderChild(Boss_Hp_table[count].hpNode,100)
        Boss_Hp_table[count-1].hpNode:setPercentage(100)
        Boss_Hp_table[count].hpNode:setPercentage(Boss_Hp_table[count].tempPercent)
    else
        LayerNode:setVisible(false)
        Boss_Hp_table[1].hpNode:setPercentage(Boss_Hp_table[1].tempPercent)
    end
    
end

function GameScene:SetBossHpLayer(m_layercount,m_totalHp)
    lastBossHpIndex = 0
    Boss_Hp_each = mathFloor(m_totalHp / m_layercount)
    local nowFirstNode = BOSS_Bar_node:getChildByTag(1):getChildByTag(1):getChildByTag(1)
    local hp_root_node = BOSS_Bar_node:getChildByTag(1):getChildByTag(1)
    local LayerNode = BOSS_Bar_node:getChildByTag(3)
    local LayerCount  = LayerNode:getChildByTag(2)
    
    local orginX,orginY = nowFirstNode:getPosition()
    local orginScaleX = nowFirstNode:getScaleX()
    local orginScaleY = nowFirstNode:getScaleY()
    local cache = cc.SpriteFrameCache:getInstance()
    Boss_hp_index = m_layercount
    Boss_Last_hp = m_totalHp
    
    cache:addSpriteFrames("3-FBZD.plist", "3-FBZD.png")
    
    local allHpNode = hp_root_node:getChildren()
    for key, var in pairs(allHpNode) do
    	if var:getTag() > 0 then var:removeFromParent() end
    end
    Boss_Hp_table = {}
    local allHp = m_totalHp
    for i=1, m_layercount do
        local tempProgessBar = nil
        if i < 6 then
            
            
            local temp_path = "3-FBZD/BOSSTX-d1-"..i..".png"
            

            local backImg =cc.Sprite:create()   --模板图片
            backImg:setSpriteFrame(temp_path)
            tempProgessBar = cc.ProgressTimer:create(backImg)
            tempProgessBar:setType(cc.PROGRESS_TIMER_TYPE_BAR)
            tempProgessBar:setPercentage(100)
            tempProgessBar:setMidpoint(cc.p(0,0.5))
            tempProgessBar:setBarChangeRate(cc.p(1, 0))

            hp_root_node:addChild(tempProgessBar,i,i)
            tempProgessBar:setScale(-1,0.4)
            tempProgessBar:setPosition({x = 0 , y = orginY })
            tempProgessBar:setVisible(true)
        else
            tempProgessBar = Boss_Hp_table[(i-6)%4+2].hpNode
        end
        
        local restHp = m_totalHp - (i*Boss_Hp_each)
        local nowEach
        if restHp < Boss_Hp_each then 
            nowEach = Boss_Hp_each + restHp
        else
            nowEach = Boss_Hp_each
        end
        
        local tempHp = {hpNode = tempProgessBar,maxHp = nowEach,index = i,tempPercent = 100 }
        Boss_Hp_table[i] = tempHp
        
    end
    
    if m_layercount > 1 then
        LayerCount:setString(""..(m_layercount-1))
        local count = #Boss_Hp_table
        local rootNode = Boss_Hp_table[count].hpNode:getParent()
        rootNode:reorderChild(Boss_Hp_table[count-1].hpNode,99)
        rootNode:reorderChild(Boss_Hp_table[count].hpNode,100)
    else
        LayerNode:setVisible(false)
    end
  
end
local MoveHp


function MoveHp(targetIndex,nowPercent,obj)
    local startIndex = 1
    local hp_root_node = BOSS_Bar_node:getChildByTag(1):getChildByTag(1)
    local LayerNode = BOSS_Bar_node:getChildByTag(2)
    local LayerCount  = LayerNode:getChildByTag(1)
    local rootNode = Boss_Hp_table[startIndex].hpNode:getParent()
    
    for i = #Boss_Hp_table, 1,-1 do
        Boss_Hp_table[i].hpNode:stopAllActions() -- 以免快速减血停止ACTION后的变化
    end
    
    
    for i= #Boss_Hp_table, 1, -1 do
        if (Boss_Hp_table[i].hpNode:getPercentage() ~= 0 and Boss_Hp_table[i].tempPercent ~= 0) and startIndex == 1 then
            
            startIndex = i

        elseif (Boss_Hp_table[i].hpNode:getPercentage() ~= 0 and Boss_Hp_table[i].tempPercent == 0 and i <= lastBossHpIndex ) and startIndex == 1 then
            Boss_Hp_table[i].tempPercent = Boss_Hp_table[i].hpNode:getPercentage()
            startIndex = i
        end
    end
    
    local setAction
    function  setAction()
        local theSameHp = startIndex == targetIndex
        lastBossHpIndex = startIndex
        local fillPercent = 0 
        if theSameHp == true then
            fillPercent = nowPercent
            Boss_Hp_table[startIndex].tempPercent = nowPercent
            local progessFun2 = cc.ProgressTo:create(0.25,fillPercent)
            Boss_Hp_table[startIndex].hpNode:runAction(progessFun2)
            
            if startIndex == 1 then
                rootNode:reorderChild(Boss_Hp_table[startIndex].hpNode,100)
            else

                Boss_Hp_table[startIndex-1].hpNode:setPercentage(100)

                rootNode:reorderChild(Boss_Hp_table[startIndex-1].hpNode,99)
                rootNode:reorderChild(Boss_Hp_table[startIndex].hpNode,100)
            end
        else
            Boss_Hp_table[startIndex].tempPercent = fillPercent
         
            
            if startIndex == 1 then
                rootNode:reorderChild(Boss_Hp_table[startIndex].hpNode,100)
            else
                
                Boss_Hp_table[startIndex-1].hpNode:setPercentage(100)
                
                if Boss_Hp_table[startIndex].hpNode:getPercentage() == 0 then
                    Boss_Hp_table[startIndex].hpNode:setPercentage(100)
                end
                rootNode:reorderChild(Boss_Hp_table[startIndex-1].hpNode,99)
                rootNode:reorderChild(Boss_Hp_table[startIndex].hpNode,100)
            end
            
            local callfun = cc.CallFunc:create(setAction)
            local progessFun = cc.ProgressTo:create(0.25,fillPercent)
            Boss_Hp_table[startIndex].hpNode:runAction(cc.Sequence:create(progessFun,callfun))
            startIndex = mathMax(startIndex - 1,1)
            
            
            if startIndex == 1 then
                LayerNode:setVisible(false)
                
            else
                LayerCount:setString(""..(startIndex-1))
            end
            obj.should_furry = true
            if (startIndex-1) <2 then obj.qte_furry = true end --血条低于2层才触发QTE
        end
   end
  
    setAction()
    
end
 

function GameScene:updateBossHp(obj)

    BOSS_Bar_node:setVisible(true)

--    if obj._shieldMax >0 then
--        local shield_percent=100
--        BOSS_Sheild_node:setVisible(true)
--        if obj._shield > 0 then shield_percent=mathFloor((obj._shield/obj._shieldMax)*100) else shield_percent=0 end
--        if shield_percent == 0  and Boss_Last_Sheild ~= shield_percent then
--            GameControlLayer.playBossShieldBreakAct()
--        elseif shield_percent > 0 and Boss_Last_Sheild == 0 then
--            GameControlLayer.playBossShieldStart()
--        end
--        
--        Boss_Last_Sheild = shield_percent
--        BOSS_Sheild_bar:setPercent(shield_percent)
--    end
    
    local hp_percent
    local haveChange = false
    
    if  Boss_Last_hp > obj._hp then
        haveChange = true
    end
    
    if haveChange == true then
        Boss_Last_hp = obj._hp
        hp_percent = 0
        local targetIndex = 1
        local tempHp = 0
        
        for i= 1,#Boss_Hp_table do

            tempHp = tempHp + Boss_Hp_table[i].maxHp
            if tempHp >= obj._hp then
                if obj._hp > 0 then hp_percent =  mathCeil(((Boss_Hp_table[i].maxHp - (tempHp - obj._hp))/Boss_Hp_table[i].maxHp)*100) else hp_percent=0 end
                --Boss_Hp_table[i].hpNode:setPercent(hp_percent)
                targetIndex = i
                break
            end

        end 
        
        MoveHp(targetIndex,hp_percent,obj)
        
    end
    
    
end

function GameScene:checkQte(dt,tempOffsetX)
    local allQTE = QteSeq
    local QTE_count=List.getSize(allQTE)

    if QTE_count>0 then

        --if self:isVisible() == false then self:setVisible(true) end

        local i_offset=0
        for i=1, QTE_count do
            local obj = allQTE[i-i_offset]
            obj:baseUpdate(dt)
            --obj:updateCamera(tempOffsetX)


            if obj.isOver == true then
                obj:delete()


                List.remove(allQTE,i-i_offset)

                i_offset = i_offset+1
            end

        end
    end   
end

function GameScene:checkBullet(dt,tempOffsetX)
    local allBullet = self.nowBulletList
    local bullet_count=List.getSize(allBullet)
    
    if bullet_count>0 then
    
        --if self:isVisible() == false then self:setVisible(true) end
        
        local i_offset=0
        for i=1, bullet_count do
            local obj = allBullet[i-i_offset]
            obj:baseUpdate(dt)
            obj:updateCamera(tempOffsetX)
            
           
            if obj.isDead == true then
                obj:delete()
                

                List.remove(allBullet,i-i_offset)

                i_offset = i_offset+1
            end

        end
    end   
    

end

function GameScene:checkHero(dt,hero,tempOffsetX,tempOffsetY)
    hero:updateCamera(tempOffsetX,tempOffsetY)
    hero:baseUpdate(dt)
    
    local tP = self.tempPlayerList
    local Hero_count=List.getSize(tP)
    local i_offset=0
    
    for i=1, Hero_count do
        if tP[i-i_offset]._spine == nil then
            
            List.remove(tP,i-i_offset)

            i_offset = i_offset+1
         end
    end

end
function GameScene:getAllDrop(hero)
    local sizeCount = List.getSize(self.now_DropItem)
    if sizeCount > 0 then
        for i=1, sizeCount do
            local obj = self.now_DropItem[i]
            if obj.canCollect == true and (obj.flying == nil or obj.flying ~= true) then
                obj.flying = true
                obj.baseNode:runAction(cc.EaseIn:create(cc.MoveTo:create(0.8,{x = hero.collideRect[1].x,y = hero.collideRect[1].y+30}),4.5))
            end
        end
    end
end
function GameScene:checkDropItem(dt,hero)
    local sizeCount = List.getSize(self.now_DropItem)
    if sizeCount > 0 then
        local i_offset=0
        local newSizeCount = sizeCount
        local fixcount = 0
        
        if sizeCount > now_max_drop_item then
            newSizeCount = now_max_drop_item
            fixcount = sizeCount - now_max_drop_item
            for i=1,fixcount do
                local obj = self.now_DropItem[1]
                obj:delete()
                List.remove(self.now_DropItem,1)
            end
        end
        
        for i=1, newSizeCount do
            local nowIndex = i-i_offset
            local obj = self.now_DropItem[nowIndex]

            if obj.canCollect == true then
                if hero:boxCheckDrop(obj:getBox()) == true then
                    local nowName = obj.name
                    if obj.needNum == true then nowName = obj.name.." x"..obj.haveNum end
                    hero:addDropName(nowName,obj.quality_type)
                    obj:delete()
                    List.remove(self.now_DropItem,i-i_offset)
                    i_offset = i_offset+1
                end
            end
        end
    end
end

function GameScene:checkMonster(dt,tempOffsetX,forceDelete)
    local allMonster = self.nowMonsterList
    local monster_count=List.getSize(allMonster)
    BOSS_Bar_node:setVisible(false)
    local mustDelete = false
    if forceDelete and forceDelete == true then mustDelete = true end
    
    if monster_count>0 then
        local i_offset=0
        for i=1, monster_count do
        
            local obj = allMonster[i-i_offset]
            
            obj:updateCamera(tempOffsetX)
            
            if obj._is_boss == true then
                self:updateBossHp(obj)
            end
            obj:baseUpdate(dt)
            
            if (obj._ActorState == EnumStateType.dead  and  obj.shouldDeleteAD == true) or mustDelete == true then
                List.pushlast(self.kill_id_list,obj.role_id)
                List.removeObj(self.AllPlayerList, obj)
                obj:delete()
                --obj:removeFromParent()

                List.remove(allMonster,i-i_offset)

                i_offset = i_offset+1
                
                
            end

        end


    end
end



function GameScene:creatShock3D(m_time)
    local m_action=cc.Shaky3D:create(m_time, cc.size(1,1), 5, false)
    self.testNode:runAction(m_action)
end

function GameScene:creatShock(m_time,range)
    self.shock_time=m_time
    self.shock_range=range
    
    --LableString.addHurtString(nowPlayer[1]:getPositionX(),nowPlayer[1]:getPositionY(),"time ="..m_time.." range = "..range)
end

function GameScene:updatShock(dt)
    if self.shock_time > 0 then
        self.shock_time=self.shock_time - dt
        
        local shockX = self.shock_range
        local shockY = self.shock_range
        local xx= self.shock_count % 2
        
        if xx == 0 then 
            if self.shock_range >0 then self.shock_range=self.shock_range-1 end
        end
        if self.offset_x >= 0 then self.offset_x=-1* shockX else self.offset_x = shockX end
        if self.offset_y >= 0 then self.offset_y=-1* shockY else self.offset_y = shockY end
        
        
        self.shock_count = self.shock_count + 1
    else
        self.shock_count=0
        self.offset_x = 0
        self.offset_y = 0
    end    
end
local osDate = os.date
function GameScene:updateTime(dt)
    
    local nowTime = self.limit_time
    if nowTime >0 then self.limit_time = mathMax((nowTime - dt),0) end
    
    local minStr = mathFloor(nowTime/60)
    local secStr = mathFloor(nowTime - (minStr*60))
    local mmStr  =  mathFloor((nowTime - mathFloor(nowTime))*100)
    
    if minStr == 0 and secStr < 31 and self.time_warnning == false then
        self.time_warnning = true
        local a1 = cc.TintBy:create(0.5,0,-255,-255)
        local a2 = a1:reverse()
        local fe = cc.RepeatForever:create(cc.Sequence:create(a1,a2))
        Time_Time_node:runAction(fe)
        
    elseif (minStr > 0 or secStr > 30) and self.time_warnning == true then
        self.time_warnning = false
        Time_Time_node:stopAllActions()
    end
    
    local mS,sS,mM
    
    if minStr < 10 then mS = "0"..minStr else mS = ""..minStr  end
    if secStr < 10 then sS = "0"..secStr else sS = ""..secStr  end
    if mmStr < 10 then mM = "0"..mmStr else mM = ""..mmStr  end
      
       
    
    local nowStr = mS..":"..sS..":"..mM
    Time_Time_node:setString(nowStr)
    
end

function GameScene:setTime_Time_node_Visible(show)
    Time_Time_node:setVisible(show)
end
function GameScene:getPlayerHpPercent()
    local hero = self.playerList[1]
    local hp_percent=100
    if hero._hp > 0 then hp_percent=mathCeil((hero._hp/hero._hp_max)*100) else hp_percent=0 end
    
    return hp_percent
end


function GameScene:updateGoTips()
    

    local isVisible = Go_Tip_node:isVisible()
    if G.activearea.left > self.nowCamera.position.x then
        if self.running_count % 10 == 0 then
            Go_Tip_node:setVisible(not isVisible)
        end
    else 
        if isVisible == true then
            Go_Tip_node:setVisible(false)
        end
    end
end

function GameScene:calculateFPS(dt)
    local nowdt = dt * 0.1 + (0.9) * self.preDt
    self.preDt = nowdt
    return 1/nowdt
end

function GameScene:updateLayer(dt)
    --if self.loading_done~= true then return end
    if self.isLoading or self.fb_isFinish == true then return end
    
    local nowFPS = mathFloor(self:calculateFPS(dt))
    
    
    nowFixTimeScale = mFPS/ nowFPS
    

    
--    if mFPS > nowFPS+2 then
--        nowFixTimeScale = mFPS/ nowFPS
--    else
--        nowFixTimeScale = mFPS/ nowFPS
--    end
    
    self.pass_time = self.pass_time + dt
    
--    local shouldPrint = false
--    
--    if self.pass_time <= 1 then shouldPrint = true end
    
    self.running_count = self.running_count + 1  --计时器
    
--   local st_time,end_time = os.clock(),0
    
    self:updateGoTips()
    --GameManager.updateGoTips()
    
--    end_time = os.clock()
--    
--    if shouldPrint == true then
--        cclog("GameManager.updateGoTips() useTime  = %f ",end_time - st_time )
--    end
    
    local hero = self.playerList[1]
    --local Monster = self.Monster
    
    --self.game_layout:getChildByTag(200):setScale(1,1)
    --self.game_layout:getChildByTag(200):setPosition(0,0)
    
    
    self:updatShock(dt)
    
    if self.game_isPause ~= true and self.game_isEnd ~= true and self.game_isPause ~= true and GameManager.FB_Value.needShowTime == true then 
        if hero.gameisWin ~= true then
            self:updateTime(dt)
        end
    end
    
    
    
    
    self:updateHeroStatus(hero)
    
    if self.inPvP == true and nowmonster[1] then
        self:updateEnemyStatus(nowmonster[1])
    end
    --self:updateBossStatus()
    
    --local cPRight=self.nowCamera.visibleSize.width/2+self.nowCamera.position.x+100
    --local cPLeft=self.nowCamera.visibleSize.width/2+self.nowCamera.position.x-100
    local by 
    
    if self.follow_target.collideRect then
        by = self.follow_target.collideRect[1].y + self.offset_y + self.follow_target.actor_y_offset
    else
        by = self.follow_target.y
    end
    local cameraPoint = self:camFollow(cc.p(self.follow_target.x,by),0,CFTYPE)


    self.nowCamera.position.x=cameraPoint.x
    self.nowCamera.position.y=cameraPoint.y
    --mathabs()
    
    self.past_camera_x = self.nowCamera.position.x
    if self.need_check_camera_move == true then
        if mathabs(self.nowCamera.position.x - self.past_camera_x) <= 1 then
            if self.need_check_type == 1 then
                GameManager.ResumeGameLogic()
                self.boss_show_end = true
            elseif self.need_check_type == 2 then
                self.showUpObj._spine:setTimeScale(1)
                if self.showUpObj.role_effect ~= nil then
                    self.showUpObj.role_effect:setTimeScale(1)
                end
                GameManager.addHitEffect(640,360,103,1,false,1)
                
            end
            self.need_check_camera_move = false
            --self.past_camera_x = self.nowCamera.position.x
        else
            --self.past_camera_x = self.nowCamera.position.x
        end
    end

    --hero:updateCamera(self.nowCamera.position.x,self.nowCamera.position.y)
    
    --local test_Spine = CreatePreloadSpine(nowPlayer[1].model_id)
    
    
    local tempOffsetX = self.nowCamera.position.x
    local tempOffsetY = self.nowCamera.position.y * -1
    
    local offsetX = tempOffsetX*-1

    --self.bg_remote:setVisible(false)
    self.bg_remote:setPosition(offsetX/40,self.bg_remote_y+mathCeil((tempOffsetY*0.5)))
    
    --self.bg_medium_1:setVisible(false)
    self.bg_medium_1:setPosition(mathCeil((offsetX*0.5)),self.bg_medium_1_y+tempOffsetY)
    
    --self.bg_medium:setVisible(false)
    --self.bg_medium:setPosition(mathCeil((offsetX*0.7)),self.bg_medium_y+mathCeil((tempOffsetY*0.5)))
    
    --self.bg_foreground:setVisible(false)
    self.bg_foreground:setPosition(offsetX+self.offset_x,self.bg_foreground_y+self.offset_y+tempOffsetY)
    
    self.BackLayer:setPosition(tempOffsetX-self.offset_x,-1*tempOffsetY-self.offset_y)
    
    --self.mask_ground_1:setVisible(false)
    --self.mask_ground_1:setPosition(offsetX+self.offset_x,self.mask_ground_1_y+self.offset_y)   --增加第7层
    
    --self.bg_new_foreground_1:setVisible(false)
    --self.bg_new_foreground_1:setPosition(offsetX*1.2+self.offset_x,self.bg_new_foreground_1_y+self.offset_y+tempOffsetY)
    --self.node_bg_test:getChildByTag(3):setPosition(offsetX,self.node_bg_test:getChildByTag(3):getPositionY())
    
    if self.game_Blance then
        self.game_Blance:setPosition(0+self.offset_x,0)
    end
    
    if ISDEBUG and ISDEBUG == 3 then
        self.draw:clear()
        
        for i=1,List.getSize(self.all_boundingBoxs) do
            local LRp = self.all_boundingBoxs[i]
            self.draw:drawLine({x =LRp.a.x + offsetX,y = LRp.a.y + tempOffsetY},{x =LRp.b.x + offsetX,y = LRp.b.y + tempOffsetY},cc.c4f(1,0,1,0.5))
        end
        
        for i=1,List.getSize(self.all_boundingBoxs_big) do
            local box_draw = self.all_boundingBoxs_big[i]
            
    
            local vertices3={}
            local dir=1
            vertices3 = { cc.p(box_draw.x+offsetX,box_draw.y+tempOffsetY), cc.p(box_draw.x+offsetX,box_draw.y+box_draw.height+tempOffsetY),
                cc.p(box_draw.x+box_draw.width+offsetX,box_draw.y+box_draw.height+tempOffsetY), cc.p(box_draw.x+box_draw.width+offsetX,box_draw.y+tempOffsetY) }
            
            self.draw:drawSolidPoly( vertices3, 4, cc.c4f(1,0,1,0.3) )
        end
    end

    --self.bg_boundingBoxs:setPosition(offsetX,self.bg_boundingBoxs_y+self.offset_y)
    --ccui.Widget:addTouchEventListener(callback)
    --GameManager.drawGround(offsetX)
    --self.bg_new_foreground:setPosition(offsetX,self.bg_new_foreground:getPositionY())
    self:updateScale()
    self:updateScaleOffsetXY(self.follow_target.x,self.follow_target.y,offsetX)
    
    self:checkQte(dt,tempOffsetX)  --检测QTE
    self:checkBullet(dt,tempOffsetX)
    
     
    self:checkHero(dt,hero,tempOffsetX,self.nowCamera.position.y)
    self:checkDropItem(dt,hero)
    
    
    self:checkMonster(dt,tempOffsetX)
    
    LableString.update(tempOffsetX)
    
--    if self.pass_time <= 1 then
--        cclog("update in second  = %d ",self.running_count)
--    end
    
end

function GameScene:updateScale()
    if nowSceneScale < self.targetSceneScale then
        local temp = math.max((self.targetSceneScale - nowSceneScale) / self.SceneScaleSpeed,0.01)
        local result = math.min(nowSceneScale +temp,self.targetSceneScale)
        nowSceneScale = result
    elseif nowSceneScale > self.targetSceneScale then
        local temp = math.max((nowSceneScale - self.targetSceneScale) / self.SceneScaleSpeed,0.01)
        local result = math.max(nowSceneScale - temp,self.targetSceneScale)
        nowSceneScale = result
    end
end


function GameScene:updateScaleOffsetXY(aX,aY,m_camera_x,m_camera_y)
    local tempX=0
    local tempY = 0
    local offset = 0
    if nowSceneScale ~= 1 then
        local percent = 0
        local isZoomIn = true
        if self.targetSceneScale > 1 then 
            percent= (nowSceneScale-1)/math.abs(self.targetSceneScale - 1)
        elseif self.targetSceneScale <= 1 then
            percent= 1-(nowSceneScale-1)/math.abs(self.lastSceneScale - self.targetSceneScale)
            isZoomIn = false
        end
        tempX = aX + m_camera_x 
        tempY = aY
        local newX = tempX * nowSceneScale
        local newY = tempY * nowSceneScale
    
        local SoffsetX = -1*(newX - tempX)
        local SoffsetY = -1*(newY - tempY)
        
        offset = (640-tempX)*percent
        
        if isZoomIn == true then
            self.scaleOffset_x = SoffsetX
            self.scaleOffset_y = SoffsetY
        else
            self.scaleOffset_x = SoffsetX
            self.scaleOffset_y = SoffsetY
        end
        --cclog("m_camera_x = %f self.nowSceneScale =  %f   self.scaleOffset_x =%f  self.scaleOffset_y = %f",m_camera_x,nowSceneScale,self.scaleOffset_x,self.scaleOffset_y)
        self.game_layout:getChildByTag(200):setScale(nowSceneScale,nowSceneScale)
        self.game_layout:getChildByTag(200):setPosition(self.scaleOffset_x  ,self.scaleOffset_y)
    else
        self.scaleOffset_x = 0
        self.scaleOffset_y = 0
    end
end

function GameScene:setHeroFollowType(m_type)
    if m_type ~= 0 then m_type = 0 end
    if m_type == 1 then
        self.follow_x = self.nowCamera.visibleSize.width/4
    elseif m_type == 0 then
        self.follow_x = self.nowCamera.visibleSize.width/2
    elseif m_type == -1 then
        self.follow_x = (self.nowCamera.visibleSize.width/4) * 3
    end
end

function GameScene:camFollow(hero_position,offset,forceFollow)
    local borderRight = G.activearea.right-self.nowCamera.visibleSize.width

    local borderLeft = G.activearea.left
    local middleCam=self.nowCamera.position.x+self.follow_x
    local middleY = self.nowCamera.position.y+200
    local resultPoint=cc.p(self.nowCamera.position.x,self.nowCamera.position.y)
    local defaultPoint  = cc.p(self.nowCamera.position.x,self.nowCamera.position.y)
    local fSpeed = self.follow_speed_level

    if forceFollow == true then
        if hero_position.x > middleCam+offset  then

            resultPoint=getCamNextXY(resultPoint,cc.p(hero_position.x-self.follow_x,0),cc.p(G.defaultRight-self.nowCamera.visibleSize.width,0),math.abs((hero_position.x-middleCam-offset)/fSpeed),1)

        elseif hero_position.x < middleCam-offset then
            
            resultPoint=getCamNextXY(resultPoint,cc.p(hero_position.x-self.follow_x,0),cc.p(G.defaultLeft,0),math.abs((hero_position.x-middleCam+offset)/fSpeed),1)
            
        end
    else
        local bordY = 0
--        if hero_position.y-320 > self.nowCamera.position.y then
--            bordY = 1280
--        elseif  hero_position.y-320 < self.nowCamera.position.y then
--            bordY = 0
--        end
        local tempYpoint = 0
        if hero_position.y > 450 then
            tempYpoint = fGetCamNextXY(defaultPoint,cc.p(hero_position.x-self.follow_x,hero_position.y-200),cc.p(borderRight,bordY),math.abs((hero_position.y-middleY)/10),1)
        else
            tempYpoint = fGetCamNextXY(defaultPoint,cc.p(hero_position.x-self.follow_x,0),cc.p(borderRight,bordY),math.abs((hero_position.y-middleY)/10),1)
        end
        
        if hero_position.x > middleCam+offset  then
             

            resultPoint=fGetCamNextXY(resultPoint,cc.p(hero_position.x-self.follow_x,hero_position.y-150),cc.p(borderRight,bordY),math.abs((hero_position.x-middleCam-offset)/fSpeed),1)
           
            
        elseif hero_position.x < middleCam-offset then
            if hero_position.x < borderLeft and self.nowCamera.position.x < borderLeft then 
                resultPoint=cc.p(self.nowCamera.position)
                
            elseif hero_position.x >= borderLeft and self.nowCamera.position.x >= borderLeft then
                resultPoint=fGetCamNextXY(resultPoint,cc.p(hero_position.x-self.follow_x,hero_position.y-150),cc.p(borderLeft,bordY),math.abs((hero_position.x-middleCam+offset)/fSpeed),1)
                
            end
        
        end
        
        resultPoint.y = tempYpoint.y
        
    end
    

    return resultPoint

end

return GameScene
