TeachAssistor={}
TeachAssistor.IsTest = false
TeachAssistor.IsTestTip = false
TeachAssistor.IsRunAssistor = not quick_debug
TeachAssistor.IsHideExtraTips = true

TeachAssistor.clippingNodeTag1 = 20091
TeachAssistor.clippingNodeTag2 = 20092

TeachAssistor.topSpriteTag = 20093
TeachAssistor.bottomSpriteTag = 20094
TeachAssistor.transparentMaskTag = 20095
TeachAssistor.transparentMaskTipTag = 20096
TeachAssistor.transparentMaskTip2Tag = 20097
TeachAssistor.topSpriteTagTip = 20098
TeachAssistor.bottomSpriteTagTip = 20099
TeachAssistor.layOutshowFBZDTipsTag = 20100 --用于强制
TeachAssistor.layOutshowTxtTag = 20101 --强制
TeachAssistor.layOutshowTxtTipTag = 20102 --强制
TeachAssistor.flickerEffectTag = 20103

TeachAssistor.fontSizeMiddle = 40
TeachAssistor.fontSizeJuqing = 28
TeachAssistor.fontSizeDianJiPingMu = 25

TeachAssistor.JumpOverBtnTag = 30091

TeachAssistor.WaitTime = 8
TeachAssistor.Tipmutex = false
TeachAssistor.JumpOverBtnStatus = false

TeachAssistor.firstChapterFB_modeSeleced = false

TeachAssistor.lesson241Flag = false
TeachAssistor.lesson591Flag = false
TeachAssistor.lessonTipDataIsCallBackFlag = false

TeachAssistor.forceAssistorIsRunning = false

EnumSkillTag ={
    "attack",  --普攻击
    "Roll",    --翻滚
    "kick",    --踢脚
    "skill_1",
    "skill_2",
    "skill_3",
    "skill_4",
    "skill_5",
    "skill_6",
    "skill_7",
    "skill_8"
}
EnumSkillTag = CreateEnumTable(EnumSkillTag,0)

EnumQTETag={
    QTE1="Q_1",
    QTE2="Q_2",
    QTE3="Q_3",
    QTE4="Q_4",
    QTE5="Q_5",
    QTE6="Q_6",
    QTE7="Q_7"
}

local ActionTime = 0.25

function TeachAssistor.CreateMaskLayout(color,opacity)
    local layout = ccui.Layout:create()
    layout:setTouchEnabled(true)
    layout:setContentSize(cc.Director:getInstance():getVisibleSize())
    layout:setBackGroundColor(color)
    layout:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
    layout:setOpacity(opacity)
    return layout
end

function TeachAssistor.createFBZD_tips1(txt)
    local FBZD_tips1csb = cc.CSLoader:createNode("FBZD-tips1.csb")
    local function setImageTxt(image,txtCtrl,txt,index)
        local length = string.len(txt)
        local addWidth = 0
        local addHeight = 0
        local contentSize = image:getContentSize()
        if length > 105 then
            addWidth=addWidth+30
            addHeight=addHeight+30
        end
        image:setContentSize(contentSize.width+addWidth,contentSize.height+addHeight)
        --contentSize = image:getContentSize()
        txtCtrl:ignoreContentAdaptWithSize(false)
        txtCtrl:setTextAreaSize(cc.size(contentSize.width+addWidth-40,contentSize.height+addHeight-70))
        local x,y = txtCtrl:getPosition()
        if 1 == index then
            txtCtrl:setPosition(cc.p(x-addWidth,y+addHeight))
        elseif 2 == index then
            txtCtrl:setPosition(cc.p(x,y+addHeight))
        elseif 3 == index then
            txtCtrl:setPosition(cc.p(x-addWidth,y))
        elseif 4 == index then
            txtCtrl:setPosition(cc.p(x,y))
        end
        txtCtrl:setAnchorPoint(cc.p(0.0,1.0))
        txtCtrl:setString(txt)
    end
    local nodeTable = FBZD_tips1csb:getChildren()
    for i=1,4 do
        local image = nodeTable[i]:getChildByTag(1)
        local txtCtrl = nodeTable[i]:getChildByTag(2)
        setImageTxt(image,txtCtrl,txt,i)
    end
    return FBZD_tips1csb
end

--index 1.左上  2.右上  3.左下 4.右下
function TeachAssistor.setFBZD_tips1Type(FBZD_tips1csb,index)
    local nodeTable = FBZD_tips1csb:getChildren()
    for i=1,4 do
        if index == i then
            nodeTable[i]:setVisible(true)
        else
            nodeTable[i]:setVisible(false)
        end
    end
end


--功能强制引导
--@param1 btn 支持 getContentSize()接口的节点,具有大小,锚点无限制
--@param2 funCallBack(clippingNode) 回调函数
-- swallowEventCode 0 begined 1 moved 2 ended
-- beganIsCallBack began 事件是否算点击 回调了  true 才算 false nil 不算
function TeachAssistor.AddLayerMask(btn,scaleSTL,xOffset,funCallBack,m_color,yOffset,opacityValue,isSwallowTouches,
    swallowEventCode,beganIsCallBack,touchXOffset,touchYOffset,FBZD_tips1Txt,FBZD_tips1Tpye,FBZD_tips1Pos,
    mainTutorialEventID,subTutorialEventID,tutorialType)
    local scene = cc.Director:getInstance():getRunningScene()
    local visibleSize = cc.Director:getInstance():getVisibleSize()
    local haveColor = nil
    local clippingNode = cc.ClippingNode:create()
    local nodeGesture  = TeachAssistor.createGestureTip()
    nodeGesture:setPosition(cc.p(-200,-200))
    scene:addChild(clippingNode)
    scene:addChild(nodeGesture)
    
    --添加冒泡提示
    local FBZD_tips1csb = nil
    if nil ~= FBZD_tips1Pos and nil ~= FBZD_tips1Txt then
        FBZD_tips1csb = TeachAssistor.createFBZD_tips1(FBZD_tips1Txt)
        if nil ~= FBZD_tips1Tpye and FBZD_tips1Tpye >= 1 and FBZD_tips1Tpye <= 4 then
            TeachAssistor.setFBZD_tips1Type(FBZD_tips1csb,FBZD_tips1Tpye)
        else
            TeachAssistor.setFBZD_tips1Type(FBZD_tips1csb,0)
        end
        FBZD_tips1csb:setPosition(FBZD_tips1Pos)
        nodeGesture:addChild(FBZD_tips1csb)
    --    local FBZD_tips1csbX,FBZD_tips1csbY = FBZD_tips1csb:getPosition()
    --    local FBZD_tips1csbMoveBy = cc.MoveBy:create(0.5,cc.p(10,0))
    --    FBZD_tips1csb:runAction(cc.RepeatForever:create(cc.Sequence:create(FBZD_tips1csbMoveBy,FBZD_tips1csbMoveBy:reverse())))         
    end
    
    --2015-11-18 begin
    if nil== touchXOffset then 
        touchXOffset = 0 
    end
    if nil == touchYOffset then
        touchYOffset = 0
    end
    
    local progress = cc.Sprite:create("roleImage/zhizhao.png")
    progress:setScale(scaleSTL)

    local size = cc.size(0,0)
    local pos = cc.p(0,0)
    local btnPos = cc.p(0,0)
    local anchor = cc.p(0.5,0.5)
    local scaleX = 1.0
    local scaleY = 1.0 
    local function update(delta)
        if nil == btn or nil == progress or nil == clippingNode then
            return
        end
        if nil ~= btn:getParent() then
            pos = btn:getParent():convertToWorldSpace(cc.p(btn:getPosition()))
        end
        btnPos = clippingNode:convertToNodeSpace(cc.p(pos.x,pos.y))
        size = btn:getContentSize()
        scaleX = btn:getScaleX()
        scaleY = btn:getScaleY()
        scaleX = math.abs(scaleX)
        scaleY = math.abs(scaleY)
        anchor = btn:getAnchorPoint()
        --btn 锚点不一定是 (0.5,0.5)
        local progressPos = cc.p(0,0)
        progressPos.x = btnPos.x-size.width*anchor.x+size.width/2.0
        progressPos.y = btnPos.y-size.height*anchor.y+size.height/2.0
        if nil ~= xOffset then
            progressPos.x = progressPos.x + xOffset
        end
        if nil ~= yOffset then
            progressPos.y = progressPos.y + yOffset
        end
        progress:setPosition(progressPos)
        
        --
        local posTemp = btn:getParent():convertToWorldSpace(cc.p(btn:getPosition()))
        
        local posTemp  = scene:convertToNodeSpace(cc.p(posTemp.x,posTemp.y))
        local GesturePos = cc.p(0.0,0.0)
        GesturePos.x = posTemp.x-size.width*anchor.x+size.width/2.0
        GesturePos.y = posTemp.y-size.height*anchor.y+size.height/2.0
        if nil ~= xOffset then
            GesturePos.x = GesturePos.x + xOffset
        end
        if nil ~=  yOffset then
            GesturePos.y = GesturePos.y + yOffset
        end
        nodeGesture:setPosition(GesturePos)
        --冒泡提示适配
        if (nil ~= FBZD_tips1csb and (nil == FBZD_tips1Tpye or 0 == FBZD_tips1Tpye )) then
            local FBZD_tips1Index = 1
            if GesturePos.x > visibleSize.width/2.0 and GesturePos.y < visibleSize.height/2.0 then --左上 =>右下
                FBZD_tips1Index = 1
            elseif GesturePos.x < visibleSize.width/2.0 and GesturePos.y < visibleSize.height/2.0 then --右上 =>左下
                FBZD_tips1Index = 2
            elseif GesturePos.x > visibleSize.width/2.0 and GesturePos.y > visibleSize.height/2.0 then --左下 =>右上
                FBZD_tips1Index = 3
            elseif GesturePos.x < visibleSize.width/2.0 and GesturePos.y > visibleSize.height/2.0 then --右下 =>左上
                FBZD_tips1Index = 4
            end
            TeachAssistor.setFBZD_tips1Type(FBZD_tips1csb,FBZD_tips1Index)
        end
    end
    
    clippingNode:unscheduleUpdate()
    clippingNode:scheduleUpdateWithPriorityLua(update,0)
 
    clippingNode:setInverted(true)
    clippingNode:setAlphaThreshold(0)
    clippingNode:setStencil(progress)

    local layerColor  = nil 
    haveColor = m_color
    if haveColor~= nil then
        layerColor = cc.LayerColor:create(haveColor,100,100)
    else 
        if nil == opacityValue then
            layerColor = cc.LayerColor:create(cc.c4b(0,0,0,100),100,100)
        else
            layerColor = cc.LayerColor:create(cc.c4b(0,0,0,opacityValue),100,100)
        end
        
    end
    if nil == opacityValue then
        layerColor:setOpacity(100)
    else
        layerColor:setOpacity(opacityValue)
    end
    layerColor:setContentSize(visibleSize)
    clippingNode:addChild(layerColor)
    
    local beginEndEvent = false
    local listener = cc.EventListenerTouchOneByOne:create()
    local function eventCallBack1(touch, event)
        if swallowEventCode == event:getEventCode() then
            listener:setSwallowTouches(true)
            return true
        elseif  nil == swallowEventCode and 1 == event:getEventCode() then
            listener:setSwallowTouches(true)
            return true
        else
            listener:setSwallowTouches(false)
        end
        local touchPos=clippingNode:convertTouchToNodeSpace(touch)
        local leftPos = cc.p(0,0)
        leftPos.x = btnPos.x-size.width*anchor.x*scaleX 
        leftPos.y = btnPos.y-size.height*anchor.y*scaleY
        local distanceX = size.width*scaleX*0.1 --边距
        local distanceY = size.width*scaleY*0.1 --边距
        distanceX = touchXOffset
        distanceY = touchYOffset
        if touchPos.x >= (leftPos.x+distanceX)
        and touchPos.x <= (leftPos.x+size.width*scaleX-distanceX)
        and touchPos.y >= (leftPos.y+distanceY)
        and touchPos.y <= (leftPos.y+size.height*scaleY-distanceY) then
                 
            local SWFlag = true
            if nil == isSwallowTouches or false == isSwallowTouches then
                SWFlag = false
                if true == GameManager.isInGame() then
                    GameManager.ResumeGame()
                end
                listener:setSwallowTouches(false)
                --TeachAssistor.recordTrack(mainTutorialEventID,subTutorialEventID,tutorialType,2)
            else
                SWFlag = true
                listener:setSwallowTouches(true)
            end        
            if 0 == event:getEventCode() then
                beginEndEvent = true
                if true == beganIsCallBack then
                    clippingNode:unscheduleUpdate()
                    if true == GameManager.isInGame() then
                        GameManager.ResumeGame()
                        GameManager.ResumeGameLogic()
                    end
                    listener:setSwallowTouches(false)
                    beginEndEvent = false
                    if nil ~= funCallBack then
                        funCallBack()
                    end
                    TeachAssistor.recordTrack(mainTutorialEventID,subTutorialEventID,tutorialType,2)
                end
            elseif 2 == event:getEventCode() and true ~= beganIsCallBack then
                if true == beginEndEvent then
                    clippingNode:unscheduleUpdate()
                    if true == GameManager.isInGame() then 
                        GameManager.ResumeGame()
                        GameManager.ResumeGameLogic()
                    end
                    listener:setSwallowTouches(false)
                    beginEndEvent = false
                    if nil ~= funCallBack then
                        funCallBack()
                    end
                else
                    listener:setSwallowTouches(true)
                end
                --TeachAssistor.recordTrack(mainTutorialEventID,subTutorialEventID,tutorialType,2)
            end       
        else
            beginEndEvent = false
            listener:setSwallowTouches(true)
        end
        return true 
    end
    listener:registerScriptHandler(eventCallBack1,cc.Handler.EVENT_TOUCH_BEGAN) 
    listener:registerScriptHandler(eventCallBack1,cc.Handler.EVENT_TOUCH_MOVED)
    listener:registerScriptHandler(eventCallBack1,cc.Handler.EVENT_TOUCH_ENDED)
    local eventDispatcher = clippingNode:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listener,clippingNode)
    --scene:addChild(clippingNode)
    --scene:addChild(nodeGesture)
    return clippingNode,nodeGesture
end

--设置 ClippNode 标记
function TeachAssistor.setClippNodeTag(clippingNode,bClippingType)
    if nil == bClippingType or false == bClippingType then
        clippingNode:setTag(TeachAssistor.clippingNodeTag1)
    elseif true == bClippingType then
        clippingNode:setTag(TeachAssistor.clippingNodeTag2)
    end
end

--判断 Node 是否在场景跟节点
function TeachAssistor.NodeIsRunning(tag)
    local scene  = cc.Director:getInstance():getRunningScene()
    if nil ~= scene then
        local childNode = scene:getChildByTag(tag)
        if nil ~= childNode then
            return true
        end
    end
    return false
end

--互斥检测
function TeachAssistor.isHasTeachRunning()
    --判断是否有教程步骤正在进行
    --强制教程
    return (TeachAssistor.NodeIsRunning(TeachAssistor.clippingNodeTag1) --强制
            or TeachAssistor.NodeIsRunning(TeachAssistor.topSpriteTag) --强制
            or TeachAssistor.NodeIsRunning(TeachAssistor.bottomSpriteTag) --强制
            or TeachAssistor.NodeIsRunning(TeachAssistor.transparentMaskTag) --强制
            or TeachAssistor.NodeIsRunning(TeachAssistor.bottomSpriteTagTip) --非强制 
            or TeachAssistor.NodeIsRunning(TeachAssistor.clippingNodeTag2) --非强制的
            or TeachAssistor.NodeIsRunning(TeachAssistor.layOutshowFBZDTipsTag) --强制的       
            --or TeachAssistor.NodeIsRunning(TeachAssistor.transparentMaskTipTag) --非强制的
            --or TeachAssistor.NodeIsRunning(TeachAssistor.transparentMaskTip2Tag) --非强制的
            )      
end

function TeachAssistor.createTxt(txtTip,color)
    local visibleSize = cc.Director:getInstance():getVisibleSize()
    local txtText = ccui.Text:create()
    txtText:setFontName("Number/Number-ty3.ttf")
    if nil == color then
        txtText:setTextColor(cc.c4b(255,255,255,255))
    else
        txtText:setTextColor(cc.c4b(color.r,color.g,color.b,255))
    end
    
    txtText:setFontSize(TeachAssistor.fontSizeMiddle)
    txtText:enableShadow()
    txtText:setString(txtTip)
    txtText:setPosition(cc.p(visibleSize.width/2.0,visibleSize.height/2.0))
    return txtText
end

function TeachAssistor.enableBtnTouch(m_skill_key) --开启按钮touch
    local tempButton = TeachAssistor.getSkillBtn(m_skill_key)
   
    tempButton:getChildByTag(1):setEnabled(true)
   
    
end

function TeachAssistor.disbaleBtnTouch(m_skill_key) --开启按钮touch
    local tempButton = TeachAssistor.getSkillBtn(m_skill_key)
   
    tempButton:getChildByTag(1):setEnabled(false)

end

function TeachAssistor.enableMoveBtnTouch(isLeftOrRight) --开启移动按钮touch
    GameControlLayer.setMoveButtonState(isLeftOrRight,false)
end

function TeachAssistor.disableMoveBtnTouch(isLeftOrRight) --锁死移动按钮touch
    GameControlLayer.setMoveButtonState(isLeftOrRight,true)
end

function TeachAssistor.disableSkillButton(m_skill_key) --按攻击按钮名字屏蔽按钮
    local xx = m_skill_key
    local tempButton = TeachAssistor.getSkillBtn(m_skill_key)
    if nil ~= tempButton then
        tempButton:setVisible(false)
    end
end

function TeachAssistor.enableSkillButton(m_skill_key) --按攻击按钮名字显示按钮
    local tempButton = TeachAssistor.getSkillBtn(m_skill_key)
    if nil ~= tempButton then
        tempButton:setVisible(true)
    end
end

function TeachAssistor.getSkillBtn(skillKey)  --获取按钮
    local m_GS=GameManager.battleScenes
    local ui_node_base = nil
    ui_node_base = m_GS:getChildByTag(1000)

    if ui_node_base == nil then return false end
    local ui_node = ui_node_base:getChildByTag(110)
    local energy_node = ui_node:getChildByTag(GameControlLayer.NodeEnum.button)
    
    return energy_node:getChildByTag(skillKey)
end

function TeachAssistor.getSkillTakeMedicine()  --
    local m_GS=GameManager.battleScenes
    local ui_node_base = nil
    ui_node_base = m_GS:getChildByTag(1000)

    if ui_node_base == nil then return nil end
    local ui_node = ui_node_base:getChildByTag(110)  
    local node9 = ui_node:getChildByTag(GameControlLayer.NodeEnum.drinkButton)
    return node9
end

function TeachAssistor.enableSkillTakeMedicine()
    local tempNode = TeachAssistor.getSkillTakeMedicine()
    if nil ~= tempNode then        
        tempNode:setVisible(true)
    end
end
function TeachAssistor.disableSkillTakeMedicine()
    local tempNode = TeachAssistor.getSkillTakeMedicine()
    if nil ~= tempNode then
        tempNode:setVisible(false)
    end
end

--获取btn
function TeachAssistor.getSkillTakeMedicineBtn()
    local tempButton = TeachAssistor.getSkillTakeMedicine()
    if nil ~= tempButton then
        return tempButton:getChildByTag(1):getChildByTag(1)
    end
    return nil
end


function TeachAssistor.getSkillPosition(skillKey)  --获取相应按钮的位置

    local m_GS=GameManager.battleScenes
    local ui_node_base = nil
    ui_node_base = m_GS:getChildByTag(1000)

    if ui_node_base == nil then return false end
    local ui_node = ui_node_base:getChildByTag(110)
    local energy_node = ui_node:getChildByTag(GameControlLayer.NodeEnum.button)
    local nowButton = energy_node:getChildByTag(skillKey) 
    
    return energy_node:convertToWorldSpace(cc.p(nowButton:getPosition())) 

end

--
function TeachAssistor.createNodeCircleTip(bIsHideCircel)
    local nodeCircle = cc.CSLoader:createNode("zy-1.csb")
    local direction = nodeCircle:getChildByTag(65)
    if true == bIsHideCircel then
        direction:setVisible(false)
    end
    local tl = cc.CSLoader:createTimeline("zy-1.csb")
    nodeCircle:runAction(tl)
    tl:gotoFrameAndPlay(0,true)
    return nodeCircle
end

function TeachAssistor.modifyTxtPosition(txtCtl1,txtCtl2)
    --修正位置
    local size1 = txtCtl1:getContentSize()
    local size2 = txtCtl2:getContentSize()
    txtCtl1:setAnchorPoint(cc.p(0.0,0.5))
    txtCtl2:setAnchorPoint(cc.p(0.0,0.5))
    local x,y = txtCtl1:getPosition()
    txtCtl1:setPosition(cc.p(x-(size1.width+size2.width)/2.0,y))
    txtCtl2:setPosition(cc.p(x-(size1.width+size2.width)/2.0+size1.width,y))
end

function TeachAssistor.recordTrack(mainTutorialEventID,subTutorialEventID,tutorialType,clickedIndex)
    --埋点
    local strParam = (mainTutorialEventID or 0)..":"..(subTutorialEventID or 0)..":"..(tutorialType or 0)..":"..(clickedIndex or 0)
    if 1 == tutorialType then
        TeachAssistor.buriedPointNew(strParam)
    elseif 2 == tutorialType then
        TeachAssistor.buriedPointTipNew(strParam)
    end
end

function TeachAssistor.createClpGestureNode(skillTag,scaleSTL,txtTip1,txtTip2,color1,color2,txtTip3,txtTip4,color3,color4,
    bClippingType,mainTutorialEventID,subTutorialEventID,tutorialType)
    TeachAssistor.enableSkillButton(skillTag)
    local skillParentBtn = TeachAssistor.getSkillBtn(skillTag)
    local newBtn = skillParentBtn
    
    if skillTag > 1 and skillTag <6 then newBtn = skillParentBtn:getChildByTag(1) end
   
   
    --添加冒泡
    if nil == tutorialType then
        tutorialType = 1
    end
    local FBZD_tips1Txt = nil 
    local FBZD_tips1Tpye = nil
    local FBZD_tips1Pos = nil
    if nil ~= subTutorialEventID then
        local GameTipsData = GameCommonBox.getGameTipsData(mainTutorialEventID,subTutorialEventID,tutorialType)
        FBZD_tips1Txt = GameCommonBox.getGameTipsDataDiscription(GameTipsData)
        FBZD_tips1Tpye = GameCommonBox.getGameTipsDataWindowID(GameTipsData)
        FBZD_tips1Pos = GameCommonBox.getGameTipsDataOffsetPos(GameTipsData)
        --做良好提示
        if TeachAssistor.IsHideExtraTips == true then
            if nil == GameTipsData then
                FBZD_tips1Txt = nil
            end
        else
            if nil == GameTipsData then
                FBZD_tips1Txt = "没有主事件ID:"..mainTutorialEventID..",子事件ID:"..subTutorialEventID..",教程类型:"..tutorialType
            else
               FBZD_tips1Txt = "主事件ID:"..mainTutorialEventID..",子事件ID:"..subTutorialEventID..",教程类型:"..tutorialType.." "..FBZD_tips1Txt 
            end
        end
        TeachAssistor.recordTrack(mainTutorialEventID,subTutorialEventID,tutorialType,1)
--        if FBZD_tips1Tpye < 1 or FBZD_tips1Tpye > 4 then
--            FBZD_tips1Txt = nil
--        end  
    end
    
    --TeachAssistor.AddLayerMask(newBtn,scaleSTL) old 2016.4.15
    
    local clippingNode,nodeGesture = TeachAssistor.AddLayerMask(newBtn,scaleSTL,nil,nil,nil,nil,nil,
        nil,nil,nil,nil,nil,FBZD_tips1Txt,FBZD_tips1Tpye,FBZD_tips1Pos,
        mainTutorialEventID,subTutorialEventID,tutorialType)
    
    
    clippingNode:reorderChild(clippingNode,21)
    nodeGesture:reorderChild(nodeGesture,22)
    
    --设置标记，方便检测
    TeachAssistor.setClippNodeTag(clippingNode,bClippingType)
    
    if nil ~= txtTip2 then
        local txtCtl1 = nil
        local txtCtl2 = nil
        if nil == color1 then 
            txtCtl1=TeachAssistor.createTxt(txtTip1,cc.c3b(255,0,0))
        else
            txtCtl1 = TeachAssistor.createTxt(txtTip1,color1)
        end
        if nil == color2 then
            txtCtl2 = TeachAssistor.createTxt(txtTip2)
        else
            txtCtl2 = TeachAssistor.createTxt(txtTip2,color2)
        end
        
        clippingNode:addChild(txtCtl1)
        clippingNode:addChild(txtCtl2)
        TeachAssistor.modifyTxtPosition(txtCtl1,txtCtl2)
        --添加多一行提示
        if nil ~= txtTip3 and nil ~= txtTip4 then
            local txtCtl3 = nil
            local txtCtl4 = nil
            if nil == color3 then
                txtCtl3=TeachAssistor.createTxt(txtTip3,cc.c3b(255,0,0))
            else
                txtCtl3=TeachAssistor.createTxt(txtTip3,color3)
            end
            if nil == color4 then
                txtCtl4 = TeachAssistor.createTxt(txtTip4,cc.c3b(255,0,0))
            else
                txtCtl4 = TeachAssistor.createTxt(txtTip4,color4)
            end
            TeachAssistor.modifyTxtPosition(txtCtl3,txtCtl4)
            clippingNode:addChild(txtCtl3)
            clippingNode:addChild(txtCtl4)
            --修正4个Text位置
            local x1,y1 = txtCtl1:getPosition()
            txtCtl1:setPositionY(y1+50)
            txtCtl2:setPositionY(y1+50)
            local x2,y2 = txtCtl2:getPosition()
            txtCtl3:setPositionY(y2-50)
            txtCtl4:setPositionY(y2-50)
        end
    else
        local txtCtl = TeachAssistor.createTxt(txtTip1)
        clippingNode:addChild(txtCtl)
    end
    return clippingNode,nodeGesture
end

function TeachAssistor.createClpGestureCommon(btn,scaleSTL,txtTip1,txtTip2,funCallBack,opacityValue,xOffset,layercolor,yOffset,isSwallowTouches,swallowEventCode,bClippingType,
    beganIsCallBack,touchXOffset,touchYOffset,mainTutorialEventID,subTutorialEventID,tutorialType,newZorder)
    
    --添加冒泡
    if nil == tutorialType then
        tutorialType = 1
    end
    local FBZD_tips1Txt = nil 
    local FBZD_tips1Tpye = nil
    local FBZD_tips1Pos = nil
    if nil ~= subTutorialEventID then
        local GameTipsData = GameCommonBox.getGameTipsData(mainTutorialEventID,subTutorialEventID,tutorialType)
        FBZD_tips1Txt = GameCommonBox.getGameTipsDataDiscription(GameTipsData)
        FBZD_tips1Tpye = GameCommonBox.getGameTipsDataWindowID(GameTipsData)
        FBZD_tips1Pos = GameCommonBox.getGameTipsDataOffsetPos(GameTipsData)
        --做良好提示
        if TeachAssistor.IsHideExtraTips == true then
            if nil == GameTipsData then
                FBZD_tips1Txt = nil
            end
        else
            if nil == GameTipsData then
                FBZD_tips1Txt = "没有主事件ID:"..mainTutorialEventID..",子事件ID:"..subTutorialEventID..",教程类型:"..tutorialType
            else
                FBZD_tips1Txt = "主事件ID:"..mainTutorialEventID..",子事件ID:"..subTutorialEventID..",教程类型:"..tutorialType.." "..FBZD_tips1Txt 
            end
        end
        TeachAssistor.recordTrack(mainTutorialEventID,subTutorialEventID,tutorialType,1)
        --        if FBZD_tips1Tpye < 1 or FBZD_tips1Tpye > 4 then
        --            FBZD_tips1Txt = nil
        --        end
        
    end
    
    local scene = cc.Director:getInstance():getRunningScene()
    --local btnParent = btn:getParent()
    local size = btn:getContentSize()
    local clippingNode,nodeGesture = TeachAssistor.AddLayerMask(btn,scaleSTL,xOffset,funCallBack,layercolor,yOffset,opacityValue,
        isSwallowTouches,swallowEventCode,beganIsCallBack,touchXOffset,touchYOffset,FBZD_tips1Txt,FBZD_tips1Tpye,FBZD_tips1Pos,
        mainTutorialEventID,subTutorialEventID,tutorialType)
        
    if newZorder then
        clippingNode:reorderChild(clippingNode,newZorder)
        nodeGesture:reorderChild(nodeGesture,newZorder+1)
    else
        clippingNode:reorderChild(clippingNode,21)
        nodeGesture:reorderChild(nodeGesture,22)
    end
    
    --设置标记，方便检测
    TeachAssistor.setClippNodeTag(clippingNode,bClippingType)
     
    if nil ~= txtTip2 then
        local txtCtl1 = TeachAssistor.createTxt(txtTip1,cc.c3b(255,0,0))
        local txtCtl2 = TeachAssistor.createTxt(txtTip2)
        clippingNode:addChild(txtCtl1)
        clippingNode:addChild(txtCtl2)
        TeachAssistor.modifyTxtPosition(txtCtl1,txtCtl2)
    else
        if nil ~= txtTip1 then
            local txtCtl = TeachAssistor.createTxt(txtTip1)
            clippingNode:addChild(txtCtl)
        end
    end
    --GameMainScene.SetAllButtonTouchEnabled(false)
    --btn:setTouchEnabled(true)
    return clippingNode,nodeGesture
end

function TeachAssistor.releaseClpGestureNode(clpNode,gestureNode)
    if nil ~= clpNode then
        clpNode:removeFromParent()
    end
    if nil ~= gestureNode then
        gestureNode:removeFromParent()
    end
    --GameMainScene.SetAllButtonTouchEnabled(true)
    return nil,nil
end

function TeachAssistor.createGestureTip()
    local nodeGesture = cc.CSLoader:createNode("zy-2.csb")
    local tl = cc.CSLoader:createTimeline("zy-2.csb")
    nodeGesture:runAction(tl)
    tl:gotoFrameAndPlay(0,true)
    return nodeGesture
end
--
function TeachAssistor.getLeftButton()
    local m_GS=GameManager.battleScenes
    local ui_node_base = nil
    ui_node_base = m_GS:getChildByTag(1000)
    local ui_node_base_root = ui_node_base:getChildByTag(110)
    if ui_node_base == nil then return false end

    local move_node = ui_node_base_root:getChildByTag(GameControlLayer.NodeEnum.direction)

    local leftButton = move_node:getChildByTag(1)

    return leftButton,move_node
end

function TeachAssistor.setDirectionVisible(m_visible)
    local m_GS=GameManager.battleScenes
    local ui_node_base = nil
    ui_node_base = m_GS:getChildByTag(1000)

    if ui_node_base == nil then return false end
    local ui_node = ui_node_base:getChildByTag(110)
    local dir_node = ui_node:getChildByTag(GameControlLayer.NodeEnum.direction)
    
    dir_node:setVisible(m_visible)
end

function TeachAssistor.getRightButton()
    local m_GS=GameManager.battleScenes
    local ui_node_base = nil
    ui_node_base = m_GS:getChildByTag(1000)
    local ui_node_base_root = ui_node_base:getChildByTag(110)
    if ui_node_base == nil then return false end

    local move_node = ui_node_base_root:getChildByTag(GameControlLayer.NodeEnum.direction)

    local rightButton = move_node:getChildByTag(2)

    return rightButton,move_node
    
end

function TeachAssistor.getLeftButtonPosition()  --获取左按钮位置
    local leftButton,move_node = TeachAssistor.getLeftButton()
    return move_node:convertToWorldSpace(cc.p(leftButton:getPosition()))
end

function TeachAssistor.getRightButtonPosition()  --获取右按钮位置
    local rightButton,move_node = TeachAssistor.getRightButton()
    return move_node:convertToWorldSpace(cc.p(rightButton:getPosition()))
end

-------------------------------------------------------------------------------- 判断按键状态
function TeachAssistor.AttackIsTouch() --普攻按下状态
    local isTouch = false
    if GameControlLayer.enumTouchEvent.AttackTouch == 1 then isTouch = true end
    return isTouch
end

function TeachAssistor.LeftIsTouch() --左键按下状态
    local isTouch = false 
    if GameControlLayer.enumTouchEvent.LeftButtonTouch == 1 then isTouch = true end
    return isTouch
end

function TeachAssistor.RightIsTouch() --右键按下状态
    local isTouch = false
    if GameControlLayer.enumTouchEvent.RightButtonTouch == 1 then isTouch = true end
    return isTouch
end

function TeachAssistor.change1IsTouch() --右键按下状态
    local isTouch = false
    if GameControlLayer.enumTouchEvent.change1Touch == 1  then isTouch = true end
    return isTouch
end

function TeachAssistor.change2IsTouch() --右键按下状态
    local isTouch = false
    if GameControlLayer.enumTouchEvent.change2Touch == 1  then isTouch = true end
    return isTouch
end

function  TeachAssistor.setLeftEnable(isEnable)   --是否禁用左按钮
    if isEnable == true then
        GameControlLayer.enumTouchEvent.shoulePressLeft = 1
    else
        GameControlLayer.enumTouchEvent.shoulePressLeft = 0
        GameControlLayer.enumTouchEvent.LeftButtonTouch = 0
    end
	
end

function  TeachAssistor.setRightEnable(isEnable) --是否禁用右按钮
    if isEnable == true then
        GameControlLayer.enumTouchEvent.shoulePressRight = 1
    else
        GameControlLayer.enumTouchEvent.shoulePressRight = 0
        GameControlLayer.enumTouchEvent.RightButtonTouch = 0
    end
end

function TeachAssistor.RollIsTouch()  --翻滚按下状态
    local isTouch = false
    if GameControlLayer.enumTouchEvent.RollTouch == 1 then isTouch = true end
    return isTouch
end

function TeachAssistor.Skill1IsTouch()  --踢腿，职业技能按下状态
    local isTouch = false
    if GameControlLayer.enumTouchEvent.Skill1Touch == 1 then isTouch = true end
    return isTouch
end
function TeachAssistor.Skill2IsTouch()  --技能1按下状态
    local isTouch = false
    if GameControlLayer.enumTouchEvent.Skill2Touch == 1 then isTouch = true end
    return isTouch
end

function TeachAssistor.Skill3IsTouch()  --技能2按下状态
    local isTouch = false
    if GameControlLayer.enumTouchEvent.Skill3Touch == 1 then isTouch = true end
    return isTouch
end

function TeachAssistor.Skill4IsTouch()  --技能3按下状态
    local isTouch = false
    if GameControlLayer.enumTouchEvent.Skill4Touch == 1 then isTouch = true end
    return isTouch
end

function TeachAssistor.Skill5IsTouch()  --技能4按下状态
    local isTouch = false
    if GameControlLayer.enumTouchEvent.Skill5Touch == 1 then isTouch = true end
    return isTouch
end

function TeachAssistor.Skill6IsTouch()  --技能5按下状态
    local isTouch = false
    if GameControlLayer.enumTouchEvent.Skill6Touch == 1 then isTouch = true end
    return isTouch
end

function TeachAssistor.Skill7IsTouch()  --技能6按下状态
    local isTouch = false
    if GameControlLayer.enumTouchEvent.Skill7Touch == 1 then isTouch = true end
    return isTouch
end

function TeachAssistor.Skill8IsTouch()  --技能7按下状态
    local isTouch = false
    if GameControlLayer.enumTouchEvent.Skill8Touch == 1 then isTouch = true end
    return isTouch
end

function TeachAssistor.Skill9IsTouch()  --技能8按下状态
    local isTouch = false
    if GameControlLayer.enumTouchEvent.Skill9Touch == 1 then isTouch = true end
    return isTouch
end
------------------------------------------------------------------------------------游戏中角色控制

function TeachAssistor.allRoleEnable(isEnable) --游戏中所有角色的启用状态
    if isEnable == true then
        nowPlayer[1]:setVisible(isEnable)
        nowPlayer[1]:resume()

        for i=1,List.getSize(nowmonster) do 
            nowmonster[i]:setVisible(isEnable)
            nowmonster[1]:resume()
        end
    elseif isEnable == false then 
       nowPlayer[1]:setVisible(isEnable)
       nowPlayer[1]:Pause()

       for i=1,List.getSize(nowmonster) do 
           nowmonster[i]:setVisible(isEnable)
           nowmonster[1]:Pause()
       end
    end
end



------------------------------------------------------------------------------------ BOSS控制类
function TeachAssistor.addBoss(m_x,m_y,m_id,m_ai,m_speed)  --AI = 3 就等于不动
    GameManager.addBoss(m_x,m_y,m_id,m_ai,m_speed)
end

function TeachAssistor.getBossObj()  --AI = 3 就等于不动
    local bossobj=nil
    local monster_count=List.getSize(nowmonster)
    
    if monster_count>0 then

        for i=1, monster_count do
            local obj = nowmonster[i]
            if obj._actor_type == 3 then
                bossobj = obj
            end
        end
    end
    return bossobj
end
function TeachAssistor.getBossHP()   --传回BOSS血量百分比
    local monster_count=List.getSize(nowmonster)
    local hp_percent = 0
    if monster_count>0 then

        for i=1, monster_count do
            local obj = nowmonster[i]
            if obj._actor_type == 3 then
                if obj._hp > 0 then hp_percent=(obj._hp/obj._hp_max)*100 else hp_percent=0 end
                break
            end
        end
    end

    return hp_percent
end

function TeachAssistor.isBossAttack()   --传回BOSS是否在攻击中
    local monster_count=List.getSize(nowmonster)

    if monster_count>0 then

        for i=1, monster_count do
            local obj = nowmonster[i]
            if obj._actor_type == 3 then
                if obj._ActorState > EnumStateType.attack then
                    return true
                end
                
            end
        end
    end

    return false
end
function TeachAssistor.clearBossShield()   --清除BOSS护甲
    local monster_count=List.getSize(nowmonster)
    local hp_percent = 0
    if monster_count>0 then

        for i=1, monster_count do
            local obj = nowmonster[i]
            if obj._actor_type == 3 then
                obj._shield = 0
                break
            end
        end
    end
end

function TeachAssistor.resetBossShield()   --恢复BOSS护甲
    local monster_count=List.getSize(nowmonster)
    local hp_percent = 0
    if monster_count>0 then

        for i=1, monster_count do
            local obj = nowmonster[i]
            if obj._actor_type == 3 then
                obj._shield = obj._shieldMax
                break
            end
        end
    end
end

function TeachAssistor.setBossSkill(m_skill_1,m_skill_2)   --设置boss的技能 ,填两个技能id
    local monster_count=List.getSize(nowmonster)
    local obj = nil
    if monster_count>0 then

        for i=1, monster_count do
            obj = nowmonster[i]
            break
        end
    end
    List.removeAll(obj.skill_list)
    List.removeAll(obj.skill_cd )
    obj.skill_cd = nil
    obj.skill_list=nil
    obj.skill_list = List.new()
    obj.skill_cd = List.new()
    List.pushlast(obj.skill_list,Skill.new(m_skill_1,1))
    List.pushlast(obj.skill_cd,0) --nowSkill.cd
    
    List.pushlast(obj.skill_list,Skill.new(m_skill_2,1))
    List.pushlast(obj.skill_cd,0) --nowSkill.cd
    
end

function TeachAssistor.setBossAI(m_haveAI)   --设置BOSS AI 是否开启
    local monster_count=List.getSize(nowmonster)
    local hp_percent = 0
    if monster_count>0 then

        for i=1, monster_count do
            local obj = nowmonster[i]
            if obj._actor_type == 3 then
                obj._AIEnabled = m_haveAI
                break
            end
        end
    end
end

function TeachAssistor.setBossHit(lostHPPercent,b_x,b_y)   --设置BOSS受击弹数字 
    local monster_count=List.getSize(nowmonster)
    local hp_percent = 0
    if monster_count>0 then

        for i=1, monster_count do
            local obj = nowmonster[i]
            if obj._actor_type == 3 then
                local lhp = obj._hp_max * lostHPPercent/100
                obj._hp = math.max(1,obj._hp - lhp)
                LableString.addHurtString(b_x,b_y+50,1,lhp)
                break
            end
        end
    end
end

function TeachAssistor.setBossSpeed(m_value)   --设置BOSS移动速度
    local monster_count=List.getSize(nowmonster)
    local hp_percent = 0
    if monster_count>0 then

        for i=1, monster_count do
            local obj = nowmonster[i]
            if obj._actor_type == 3 then
                obj.speed_x = m_value
                
                break
            end
        end
    end
end
function TeachAssistor.setBossAILevel(AI_level)   --设置BOSS AI 等级，1是正常 2是乱走  3是不动
    local monster_count=List.getSize(nowmonster)
    local hp_percent = 0
    if monster_count>0 then

        for i=1, monster_count do
            local obj = nowmonster[i]
            if obj._actor_type == 3 then
                obj._ai_level = AI_level
                break
            end
        end
    end
end
function TeachAssistor.BossWillHitHero()

    local monster_count=List.getSize(nowmonster)
    local nowBoss = nil
    if monster_count>0 then

        for i=1, monster_count do
            local obj = nowmonster[i]
            if obj._actor_type == 3 then
                nowBoss = obj
                break
            end
        end
    end
    local hero = nowPlayer[1]
    local willhit = false
    if nowBoss._ActorState >= EnumStateType.attack then
        if math.abs(nowBoss.x - hero.x) < 450 then
            willhit = true
        end
    end
    
    return willhit
end
function TeachAssistor.setBossFacingHero()   --设置BOSS AI 等级，1是正常 2是乱走  3是不动
    local monster_count=List.getSize(nowmonster)
    local hp_percent = 0
    if monster_count>0 then

        for i=1, monster_count do
            local obj = nowmonster[i]
            if obj._actor_type == 3 then
                obj:setFacing(nowPlayer[1])
                break
            end
        end
    end
end

function TeachAssistor.getBossPosition()
    local monster_count=List.getSize(nowmonster)
    local hp_percent = 0
    if monster_count>0 then        
        return cc.p(nowmonster[1].x,nowmonster[1].y)
    end
    return cc.p(0.0,0.0)
end

function TeachAssistor.HeroButtonRelease()
    nowPlayer[1]:normalAttack_release()
end
------------------------------------------------------------------------------------
function TeachAssistor.getCameraOffsetX()
    local m_GS=GameManager.battleScenes
    return m_GS.nowCamera.position.x
end

function TeachAssistor.getCameraOffsetY()
    local m_GS=GameManager.battleScenes
    return m_GS.nowCamera.position.y
end
--------------------------------------------------------------------------------------
----------------------------------主界面接口---------------------------------------------
function TeachAssistor.MainSceneIsRunning()
    return GameAssistor.SceneIsRunning("GameMainScene")
end

function TeachAssistor.GetLuckDrawButton()
    return GameMainScene.GetPageButton(main_buttons.AWARD)
end

function TeachAssistor.GetWeaponPageButton()
    return GameMainScene.GetPageButton(main_buttons.WEAPON)
end

function TeachAssistor.GetFBPageButton()
    return GameMainScene.GetPageButton(main_buttons.FB)
end

function TeachAssistor.getReturnBtn()
    return GameMainScene.GetPageButton(main_buttons.RETURN)
end



----------------------------------寻宝接口------------------------------------------------
--判断场景是处于活动中
function TeachAssistor.HuntBaoSceneIsRunning()
    return HuntBaoScene.SceneIsRunning()
end

--获取金币单抽按钮
function TeachAssistor.getHBBtnGoldOne()
    return HuntBaoScene.getBtnGoldOne()
end

--获取确定按钮
function TeachAssistor.getHBBtnOK()
    return HuntBaoScene.getBtnOK()
end
function TeachAssistor.getBtnGoldOneStatus()
    return HuntBaoScene.getBtnGoldOneStatus()
end
function TeachAssistor.getHBBtnOKStatus()
    return HuntBaoScene.getBtnOKStatus()
end

---------------------------------武器--------------------------------------------------------------
function TeachAssistor.WeaponSceneIsRunning()
    return WeaponScene.ScenceIsRunning()
end

--获取第二把武器单元对象
function TeachAssistor.getSecondWeaponCellEquipBtn()
    return WeaponScene.getSecondWeaponCellEquipBtn()
end

-----------------------------------角色接口---------------------------------------------------------
function TeachAssistor.RoleEquipSceneIsRunning()
    return RoleEquipScene.SceneIsRunning()
end

------------------------------------副本-----------------------------------------------------------
--判断当前场景是否处于活动中

function TeachAssistor.StagesSceneIsRunning()
   return StagesScene.SceneIsRunning()
end

function TeachAssistor.isFbEnd()   --判断FB流程是否结束
    return not GameManager.blanceIsEnd()
end

function TeachAssistor.balanceShouldAutoChange(isAuto)  --结算是否自动切换
    BalanceValues.shouldAutoChangeScene = isAuto
end
--获取第一个副本单元btn
function TeachAssistor.getFirstFBCellBtn()
    return StagesScene.getFirstFBCellBtn()
end
--获取第一章第一单元的btn状态
function TeachAssistor.getFirstFBCellBtnStatus()
    return  StagesScene.getFirstFBCellBtnStatus()
end

----
function TeachAssistor.playQTE(QTESpine,QTETag,loop)
    if nil ~= QTESpine then
        QTESpine:setAnimation(0,QTETag,loop)
    end
end
-------------------------------------------------------------
----------------------------------任务-----------------------------------
--
function TeachAssistor.lockScene()
    --G.activearea.left = 0
    --G.activearea.right = 3000
end
function TeachAssistor.unlockScene()
    --G.activearea.left = 0
    --G.activearea.right = 3840
end
function TeachAssistor.setQTEPosition(spine,viewName,heroDirection)
    local  x,y = GameManager.getSpineSlotXY(spine,viewName)
    if false == heroDirection then
        --local  monsterX,monsterY = GameManager.getSpineSlotXY(spine,"view_2")
        --local  monsterX,monsterY = spine:getPosition()
        --cclog("monsterX=%d,x=%d",monsterX,x)
        GameManager.setCarmeraFollowPoint(cc.p(x,y))
    else
        GameManager.setCarmeraFollowPoint(cc.p(x,y))
    end
end
----------------------------------------------------------------------------------------------

--显示上下黑边
--
function TeachAssistor.showUDBlackBorder(funActionCallBack,isTipThread)
    local visibleSize = cc.Director:getInstance():getVisibleSize()
    local topSprite = cc.Sprite:create("JuQing/d.png")
    local bottomSprite = cc.Sprite:create("JuQing/e.png")
    
    local size1 = topSprite:getContentSize()
    local size2 = bottomSprite:getContentSize()
    
    topSprite:setAnchorPoint(0.0,0.0)
    bottomSprite:setAnchorPoint(0.0,0.0)
    
    topSprite:setPosition(cc.p(0,visibleSize.height))
    bottomSprite:setPosition(cc.p(0,-size2.height))
    
    local action1 = cc.MoveTo:create(ActionTime,cc.p(0,visibleSize.height-size1.height))
    local action2 = cc.MoveTo:create(ActionTime,cc.p(0,0))
    topSprite:runAction(action1)
    bottomSprite:runAction(cc.Sequence:create(action2,
    cc.CallFunc:create(function()
            if nil ~= funActionCallBack then
                funActionCallBack()
        end
     end))
    )
    local tag1 = TeachAssistor.topSpriteTag
    local tag2 = TeachAssistor.bottomSpriteTag
    if true == isTipThread then
        tag1 = TeachAssistor.topSpriteTagTip
        tag2 = TeachAssistor.bottomSpriteTagTip
    end
    cc.Director:getInstance():getRunningScene():addChild(topSprite,30,tag1)
    cc.Director:getInstance():getRunningScene():addChild(bottomSprite,25,tag2)
end
--隐藏上下黑边
function TeachAssistor.removeUDBlackBorder(funCallBack)

    local scene = cc.Director:getInstance():getRunningScene()
    local visibleSize = cc.Director:getInstance():getVisibleSize()
    local topSprite =  scene:getChildByTag(TeachAssistor.topSpriteTag)
    local bottomSprite =  scene:getChildByTag(TeachAssistor.bottomSpriteTag)
    
    if nil == topSprite then
        topSprite =  scene:getChildByTag(TeachAssistor.topSpriteTagTip)
    end
    if nil == bottomSprite then
        bottomSprite =  scene:getChildByTag(TeachAssistor.bottomSpriteTagTip)
    end
    
    local function actionCallBack1()
        topSprite:removeFromParent()
    end
    
     local function actionCallBack2()
        bottomSprite:removeFromParent()
        if nil ~= funCallBack then
            funCallBack()
        end
    end
    
    if nil ~= topSprite then
        local size1 = topSprite:getContentSize()
        local action1 = cc.MoveTo:create(ActionTime,cc.p(0,visibleSize.height))
        topSprite:runAction(cc.Sequence:create(action1,cc.CallFunc:create(actionCallBack1)))
    end
    
    if nil ~= bottomSprite then
        local size2 = bottomSprite:getContentSize()
        local action2 = cc.MoveTo:create(ActionTime,cc.p(0,-size2.height))
        bottomSprite:runAction(cc.Sequence:create(action2,cc.CallFunc:create(actionCallBack2)))
    end
    --删除 跳过 csb
    local jumpOverNode = scene:getChildByTag(TeachAssistor.JumpOverBtnTag)
    if nil ~= jumpOverNode then
        jumpOverNode:removeFromParent()
    end
end

--显示灰色层
--2003
function TeachAssistor.showGrayMask(opacity)
    local scene = cc.Director:getInstance():getRunningScene()
    local layerFarm = cc.Layer:create()
    local layout = nil
    if nil == opacity then
        layout = GameCommonBox.CreateMaskLayout(cc.c3b(0,0,0),opacity or 150)
    else
        layout = GameCommonBox.CreateMaskLayout(cc.c3b(0,0,0),opacity)
    end
    scene:addChild(layout,24,2003)
end
--隐藏灰色层
--2003
function TeachAssistor.removeGrayMask(funCallBack)
    local scene = cc.Director:getInstance():getRunningScene()
    local layout = scene:getChildByTag(2003)
    local function actionFinished()
        layout:removeFromParent()
        if nil ~= funCallBack then
            funCallBack()
        end
    end
    if nil ~= layout then
        local fadeOut = cc.FadeOut:create(ActionTime)
        layout:runAction(cc.Sequence:create(fadeOut,cc.CallFunc:create(actionFinished)))
    end
end

--添加女性角色画，带动作
--2004
function TeachAssistor.showFemaleActor(funActionCallBack)
    local scene = cc.Director:getInstance():getRunningScene()
    local visibleSize = cc.Director:getInstance():getVisibleSize()
    local sprtFemaleActor =cc.Sprite:create("JuQing/16.png")
    sprtFemaleActor:setScaleX(-1)
    sprtFemaleActor:setAnchorPoint(0.0,0.5)
    local size = sprtFemaleActor:getContentSize()
    sprtFemaleActor:setPosition(cc.p(visibleSize.width+size.width,visibleSize.height/2.0))
    local moveTo1 = cc.MoveTo:create(ActionTime,cc.p(visibleSize.width,visibleSize.height/2.0))
    
    
    local sprtFemaleName =cc.Sprite:create("JuQing/b.png")
    sprtFemaleName:setScaleX(-1)
    sprtFemaleName:setAnchorPoint(0.0,0.5)
    sprtFemaleName:setPosition(cc.p(-200,size.height*0.2))
    
    scene:addChild(sprtFemaleActor,26,2004)
    sprtFemaleActor:addChild(sprtFemaleName)

    --添加动作
    local function actionFinished2()
        if nil ~= funActionCallBack then
            funActionCallBack()
        end
    end
    local function actionFinished1()
        local moveTo2 = cc.MoveTo:create(ActionTime,cc.p(500,size.height*0.2))
        sprtFemaleName:runAction(cc.Sequence:create(moveTo2,cc.CallFunc:create(actionFinished2)))
    end
    sprtFemaleActor:runAction(cc.Sequence:create(moveTo1,cc.CallFunc:create(actionFinished1)))
end

--2004
function TeachAssistor.removeFemaleActor(funCallBack)
    local scene = cc.Director:getInstance():getRunningScene()
    local visibleSize = cc.Director:getInstance():getVisibleSize()
    local sprtFemaleActor =scene:getChildByTag(2004)
    local function actionFinished()
        if nil ~= funCallBack then
            sprtFemaleActor:removeFromParent()
            funCallBack()
        end
    end
    if nil ~= sprtFemaleActor then
        local size = sprtFemaleActor:getContentSize()
        local moveTo = cc.MoveTo:create(ActionTime,cc.p(visibleSize.width+size.width,visibleSize.height/2.0))
        sprtFemaleActor:runAction(cc.Sequence:create(moveTo,cc.CallFunc:create(actionFinished)))
    else
       cclog("nil == scene:getChildByTag(2004)") 
    end
end
 
--2005
function TeachAssistor.showMaleActor(funCallBack)
    local scene = cc.Director:getInstance():getRunningScene()
    local visibleSize = cc.Director:getInstance():getVisibleSize()
    local sprtMaleActor =cc.Sprite:create("JuQing/1.png")
    sprtMaleActor:setAnchorPoint(1.0,0.5)
    local size = sprtMaleActor:getContentSize()
    sprtMaleActor:setPosition(cc.p(0,visibleSize.height/2.0))
    local moveTo1 = cc.MoveTo:create(ActionTime,cc.p(size.width,visibleSize.height/2.0))


    local sprtFemaleName =cc.Sprite:create("JuQing/a.png")
    sprtFemaleName:setAnchorPoint(1.0,0.5)
    sprtFemaleName:setPosition(cc.p(0,size.height*0.2))

    scene:addChild(sprtMaleActor,26,2005)
    sprtMaleActor:addChild(sprtFemaleName)

    --添加动作
    local function actionFinished2()
        if nil ~= funCallBack then
            funCallBack()
        end
    end
    local function actionFinished1()
        local moveTo2 = cc.MoveTo:create(ActionTime,cc.p(size.width+120,size.height*0.2))
        sprtFemaleName:runAction(cc.Sequence:create(moveTo2,cc.CallFunc:create(actionFinished2)))
    end
    sprtMaleActor:runAction(cc.Sequence:create(moveTo1,cc.CallFunc:create(actionFinished1)))
end

--2005
function TeachAssistor.removeMaleActor(funCallBack)
    local scene = cc.Director:getInstance():getRunningScene()
    local visibleSize = cc.Director:getInstance():getVisibleSize()
    local sprtMaleActor =scene:getChildByTag(2005)
    local function actionFinished()
        if nil ~= funCallBack then
            sprtMaleActor:removeFromParent()
            funCallBack()
        end
    end
    if nil ~= sprtMaleActor then
        local size = sprtMaleActor:getContentSize()
        local moveTo = cc.MoveTo:create(ActionTime,cc.p(0,visibleSize.height/2.0))
        sprtMaleActor:runAction(cc.Sequence:create(moveTo,cc.CallFunc:create(actionFinished)))
    else
        cclog("nil == scene:getChildByTag(2004)") 
    end
end

--2006
function TeachAssistor.showGestureTxt(index)
    local scene = cc.Director:getInstance():getRunningScene()
    local visibleSize = cc.Director:getInstance():getVisibleSize()
    local gestureTip = TeachAssistor.createGestureTip()
    --隐藏圆圈
    local circle1 = gestureTip:getChildByTag(1)
    local circle2 = gestureTip:getChildByTag(2)
    circle1:setVisible(false)
    circle2:setVisible(false)
    
    local txtText = ccui.Text:create()
    txtText:setFontName("Number/Number-ty3.ttf")
    txtText:setTextColor(cc.c4b(255,255,255,255))
    txtText:setAnchorPoint(0.0,0.5)
    txtText:setFontSize(TeachAssistor.fontSizeDianJiPingMu)
    txtText:enableShadow()
    txtText:setString("点击屏幕继续")
    txtText:setPosition(cc.p(70,0))
    if 1 == index then
        gestureTip:setPosition(cc.p(visibleSize.width*0.8,50))
    elseif 2 == index then
        gestureTip:setPosition(cc.p(visibleSize.width*0.55,50))
    end
    gestureTip:addChild(txtText)
    scene:addChild(gestureTip,31,2006)
end

--2006
function TeachAssistor.removeGestureTxt()
    local scene = cc.Director:getInstance():getRunningScene()
    local gestureTxt = scene:getChildByTag(2006)
    if nil ~= gestureTxt then
        gestureTxt:removeFromParent()
    end
end

--2007
function TeachAssistor.showActionTxt(index,txt,funCallBack)
    
    local length = string.len(txt)
    
    local scene = cc.Director:getInstance():getRunningScene()
    local visibleSize = cc.Director:getInstance():getVisibleSize()
    local txtText = ccui.Text:create()
    txtText:setFontName("Number/Number-ty3.ttf")
--    if length <= 75 then
--        txtText:ignoreContentAdaptWithSize(false)
--        txtText:setTextAreaSize(cc.size(600,30))
--    elseif length > 75 and length <= 150 then
--        txtText:ignoreContentAdaptWithSize(false)
--        txtText:setTextAreaSize(cc.size(600,60))
--    else
--        txtText:ignoreContentAdaptWithSize(false)
--        txtText:setTextAreaSize(cc.size(600,90))
--    end
    if length <= 75 then
        txtText:ignoreContentAdaptWithSize(false)
        txtText:setTextAreaSize(cc.size(600,60))
    elseif length > 75 and length <= 150 then
        txtText:ignoreContentAdaptWithSize(false)
        txtText:setTextAreaSize(cc.size(600,90))
    else
        txtText:ignoreContentAdaptWithSize(false)
        txtText:setTextAreaSize(cc.size(600,110))
    end
    txtText:setTextColor(cc.c4b(255,255,255,255))
    txtText:setAnchorPoint(0.5,0.5)
    --txtText:setFontSize(23)
    txtText:setFontSize(TeachAssistor.fontSizeJuqing)
    txtText:enableShadow()
    if 1==index then
        txtText:setPosition(cc.p(visibleSize.width*0.68,80))
    elseif 2 ==index then
        txtText:setPosition(cc.p(visibleSize.width*0.32,80))
    end
    scene:addChild(txtText,31,2007)
--    if nil ~= TeachAssistor.ScheduleId then
--        --cc.Director:getInstance():getScheduler():unscheduleScriptEntry(TeachAssistor.ScheduleId)
--        txtText:getScheduler():unscheduleScriptEntry(TeachAssistor.ScheduleId)
--        TeachAssistor.ScheduleId = nil
--    end
    local tempTxt = ""
    local index = 1
    local function update(dt)
        index = index+1
        if index <= length then
            tempTxt = string.sub(txt,1,index)
            txtText:setString(tempTxt)
        else
            --if nil ~= TeachAssistor.ScheduleId then
                --cc.Director:getInstance():getScheduler():unscheduleScriptEntry(TeachAssistor.ScheduleId)
                --TeachAssistor.ScheduleId = nil
                txtText:unscheduleUpdate()
                local sceneLayout = scene:getChildByTag(200701)
                if nil ~= sceneLayout then
                    sceneLayout:removeFromParent()
                end
                if nil ~= funCallBack then
                    funCallBack()
                end
            --end
        end
    end
--    if nil == TeachAssistor.ScheduleId then
--        --TeachAssistor.ScheduleId = cc.Director:getInstance():getScheduler():scheduleScriptFunc(updateTxt,0.02,false)
--        txtText:getScheduler():unscheduleScriptEntry(TeachAssistor.ScheduleId)
--    end
    txtText:unscheduleUpdate()
    txtText:scheduleUpdateWithPriorityLua(update,0) 
    
    --双击 文字全部显示出来
    local function delayTimeCallBack()
        if nil ~= funCallBack then
            funCallBack()
        end
    end
    local touchEndedNum = 0
    local layout = GameCommonBox.CreateMaskLayout(cc.c3b(0,0,0),0)
    layout:addTouchEventListener(
        function(sender,eventType)
            if eventType== ccui.TouchEventType.ended then
                touchEndedNum = touchEndedNum+1
                if touchEndedNum >= 2 then
                    touchEndedNum = 0
                    --if nil ~= TeachAssistor.ScheduleId then
                        --cc.Director:getInstance():getScheduler():unscheduleScriptEntry(TeachAssistor.ScheduleId)
                        --TeachAssistor.ScheduleId = nil
                        if nil ~= txtText then
                            txtText:unscheduleUpdate()
                            txtText:setString(txt)
                        end
                    --end
                    layout:removeFromParent()
                    TeachAssistor.runDelayTime(0.25,delayTimeCallBack)
                end
            end
        end)
    scene:addChild(layout,31,200701)
end

function TeachAssistor.removeDoubleClickLayout()
    local scene = cc.Director:getInstance():getRunningScene()
    local childNode = scene:getChildByTag(200701)
    if nil ~= childNode then
        childNode:removeFromParent()
    end
end

--2007
function TeachAssistor.removeActionTxt()
    local scene = cc.Director:getInstance():getRunningScene()
    local actionTxt = scene:getChildByTag(2007)
    if nil ~= actionTxt then
        actionTxt:removeFromParent()
    end
end

--2008
function TeachAssistor.showBossActor(funCallBack)
    local scene = cc.Director:getInstance():getRunningScene()
    local visibleSize = cc.Director:getInstance():getVisibleSize()
    local sprtBossActor =cc.Sprite:create("JuQing/7.png")
    sprtBossActor:setScaleX(-1)
    sprtBossActor:setAnchorPoint(0.0,0.5)
    local size = sprtBossActor:getContentSize()
    sprtBossActor:setPosition(cc.p(visibleSize.width+size.width,visibleSize.height/2.0))
    local moveTo1 = cc.MoveTo:create(ActionTime,cc.p(visibleSize.width,visibleSize.height/2.0))


    local sprtBossName =cc.Sprite:create("JuQing/c.png")
    sprtBossName:setScaleX(-1)
    sprtBossName:setAnchorPoint(0.0,0.5)
    sprtBossName:setPosition(cc.p(-200,size.height*0.2))

    scene:addChild(sprtBossActor,26,2008)
    sprtBossActor:addChild(sprtBossName)

    --添加动作
    local function actionFinished2()
        if nil ~= funCallBack then
            funCallBack()
        end
    end
    local function actionFinished1()
        local moveTo2 = cc.MoveTo:create(ActionTime,cc.p(500,size.height*0.2))
        sprtBossName:runAction(cc.Sequence:create(moveTo2,cc.CallFunc:create(actionFinished2)))
    end
    sprtBossActor:runAction(cc.Sequence:create(moveTo1,cc.CallFunc:create(actionFinished1)))
end
--2008
function TeachAssistor.removeBossActor(funCallBack)
    local scene = cc.Director:getInstance():getRunningScene()
    local visibleSize = cc.Director:getInstance():getVisibleSize()
    local sprtBossActor =scene:getChildByTag(2008)
    local function actionFinished()
        if nil ~= funCallBack then
            sprtBossActor:removeFromParent()
            funCallBack()
        end
    end
    if nil ~= sprtBossActor then
        local size = sprtBossActor:getContentSize()
        local moveTo = cc.MoveTo:create(ActionTime,cc.p(visibleSize.width+size.width,visibleSize.height/2.0))
        sprtBossActor:runAction(cc.Sequence:create(moveTo,cc.CallFunc:create(actionFinished)))
    else
        cclog("nil == scene:getChildByTag(2008)") 
    end
end

--2009
function TeachAssistor.showColorLayer(funCallBack)
    local scene = cc.Director:getInstance():getRunningScene()
    local visibleSize = cc.Director:getInstance():getVisibleSize()
    local layerFarm = cc.Layer:create()
    local colorLayer = cc.LayerColor:create(cc.c3b(0,0,0),100,100)
    colorLayer:setOpacity(120)
    colorLayer:setContentSize(visibleSize)
    local fadeIn = cc.FadeIn:create(ActionTime)
    local function actionFinished()
        if nil ~= funCallBack then
            funCallBack()
        end
    end
    colorLayer:runAction(cc.Sequence:create(fadeIn,cc.CallFunc:create(actionFinished)))
    scene:addChild(colorLayer,24,2009)
end

--2009
function TeachAssistor.removeColorLayer(funCallBack)
    local scene = cc.Director:getInstance():getRunningScene()
    local colorLayer = scene:getChildByTag(2009)
    local function actionFinished()
        if nil ~= funCallBack then
            funCallBack()
        end
    end
    if nil ~= colorLayer then
        local fadeOut = cc.FadeOut:create(ActionTime)
        colorLayer:runAction(cc.Sequence:create(fadeOut,cc.CallFunc:create(actionFinished)))
    end
end

--添加可点击的
--2010
function TeachAssistor.showButtonMask(funCallBack)
    local scene = cc.Director:getInstance():getRunningScene() 
    local layout = GameCommonBox.CreateMaskLayout(cc.c3b(0,0,0),0)
    layout:addTouchEventListener(
        function(sender,eventType)
            if eventType== ccui.TouchEventType.ended then
                layout:removeFromParent()
                if nil ~= funCallBack then
                    funCallBack()
                end
            end
        end)
    scene:addChild(layout,100,2010)
end

function TeachAssistor.removeButtonMask()
    local scene = cc.Director:getInstance():getRunningScene() 
    if nil ~= scene then
        local noldChild = scene:getChildByTag(2010)
        if nil ~= noldChild then
            noldChild:removeFromParent()
        end
    end
end

--2011
function TeachAssistor.showTransparentMask()
    local scene = cc.Director:getInstance():getRunningScene()
    if nil == scene:getChildByTag(TeachAssistor.transparentMaskTag) then
        local layout = GameCommonBox.CreateMaskLayout(cc.c3b(0,0,0),0)
        scene:addChild(layout,50,TeachAssistor.transparentMaskTag)
    end
end
--2011
function TeachAssistor.removeTransparentMask()
    local scene = cc.Director:getInstance():getRunningScene()
    local layout = scene:getChildByTag(TeachAssistor.transparentMaskTag)
    if nil~= layout then
        layout:removeFromParent()
    end
end

function TeachAssistor.showTransparentMaskTip(zOrder)
    local scene = cc.Director:getInstance():getRunningScene()
    if nil == scene:getChildByTag(TeachAssistor.transparentMaskTip2Tag) then
        local layout = GameCommonBox.CreateMaskLayout(cc.c3b(0,0,0),0)
        scene:addChild(layout,zOrder or 50,TeachAssistor.transparentMaskTip2Tag)
    end
end
--2011
function TeachAssistor.removeTransparentMaskTip()
    local scene = cc.Director:getInstance():getRunningScene()
    local layout = scene:getChildByTag(TeachAssistor.transparentMaskTip2Tag)
    if nil~= layout then
        layout:removeFromParent()
    end
end

function TeachAssistor.showBtnTxtMask(txtTip1,txtTip2,color1,color2,funCallBack)
    local scene = cc.Director:getInstance():getRunningScene()
    local txtCtl1 = nil
    local txtCtl2 = nil
    if nil ~= txtTip1 then
        if nil == color1 then
            txtCtl1=TeachAssistor.createTxt(txtTip1,cc.c3b(255,255,255))
        else
            txtCtl1=TeachAssistor.createTxt(txtTip1,color1)
        end
    end
    
    if nil == txtCtl2 then
        if nil == color2 then
            txtCtl2=TeachAssistor.createTxt(txtTip2,cc.c3b(255,0,0))
        else
            txtCtl2=TeachAssistor.createTxt(txtTip2,color2)
        end
    end
    
    local layout = GameCommonBox.CreateMaskLayout(cc.c3b(0,0,0),150)
    layout:addTouchEventListener(
        function(sender,eventType)
            if eventType== ccui.TouchEventType.ended then
                layout:removeFromParent()
                if nil ~= funCallBack then
                    funCallBack()
                end
            end
        end)
    layout:addChild(txtCtl1)
    layout:addChild(txtCtl2)
    TeachAssistor.modifyTxtPosition(txtCtl1,txtCtl2)
    scene:addChild(layout)
end

--先出现单刀男
function TeachAssistor.showFirstMaleActor(txtTip,funCallBack,isTipThread)
    local function removeMaleActorCallBack()
        if nil ~= funCallBack then
            funCallBack()
        end
    end
    local function showButtonMaskCallBack()
        TeachAssistor.removeGestureTxt()
        TeachAssistor.removeActionTxt()
        TeachAssistor.removeMaleActor(removeMaleActorCallBack)
    end
    local function showActionTxtCallBack()
        TeachAssistor.showGestureTxt(1)
        TeachAssistor.showButtonMask(showButtonMaskCallBack)
        TeachAssistor.JumpOverBtnToRunningScene(function() 
            TeachAssistor.JumpOverBtnStatus = true
            TeachAssistor.removeComonJuQing()
            TeachAssistor.removeMaleActor(nil)
            removeMaleActorCallBack()
        end)
    end
    local function showMaleActorCallBack()
        TeachAssistor.showActionTxt(1,txtTip,showActionTxtCallBack)
    end
    local function showUDCallBack()
        TeachAssistor.showMaleActor(showMaleActorCallBack)
    end
    TeachAssistor.showGrayMask()
    TeachAssistor.showUDBlackBorder(showUDCallBack,isTipThread)
end

--添加跳过按钮功能
function TeachAssistor.JumpOverBtnToRunningScene(callBack)
    TeachAssistor.JumpOverBtnStatus = false
    local scene = cc.Director:getInstance():getRunningScene()
    local size = cc.Director:getInstance():getVisibleSize()
    --添加跳过按钮功能
    local csbjumpOver = cc.CSLoader:createNode("zy-4.csb")
    csbjumpOver:setPosition(cc.p(size.width-85,size.height-75))
    scene:addChild(csbjumpOver,101,TeachAssistor.JumpOverBtnTag)
    --监听
    local btn = csbjumpOver:getChildByTag(13)
    btn:setPressedActionEnabled(true)
    btn:addTouchEventListener(function(sender,eventType)
            if eventType== ccui.TouchEventType.began then
                csbjumpOver:removeFromParent()
                if nil ~= callBack then
                    callBack()
                end
            end
        end)
end

--第二出现单刀男
function TeachAssistor.showSecondMaleActor(txtTip,funCallBack)
    if true == TeachAssistor.JumpOverBtnStatus then
        TeachAssistor.runDelayTime(0.2,function() 
            if nil ~= funCallBack then
                funCallBack()
            end
        end)
        return 
    end
    local function removeGrayMaskCallBack()
        if nil ~= funCallBack then
            funCallBack()
        end
    end
    local function removeUDBlackBorderCallBack()
        TeachAssistor.removeGrayMask(removeGrayMaskCallBack)
    end
    local function removeMaleActorCallBack()
        TeachAssistor.removeUDBlackBorder(removeUDBlackBorderCallBack)
    end
    local function showButtonMaskCallBack()
        TeachAssistor.removeActionTxt()
        TeachAssistor.removeGestureTxt()
        TeachAssistor.removeMaleActor(removeMaleActorCallBack)
    end
    local function showActionTxtCallBack()
        TeachAssistor.showGestureTxt(1)
        TeachAssistor.showButtonMask(showButtonMaskCallBack)
    end
    local function showMaleActorCallBack()
        TeachAssistor.showActionTxt(1,txtTip,showActionTxtCallBack)
    end
    TeachAssistor.showMaleActor(showMaleActorCallBack)
end

--第一出现大波妹
function TeachAssistor.showFirstFemaleActor(txtTip,funCallBack,isTipThread,GrayMaskOpacity)
    local function removeFemaleActorCallBack()
        if nil ~= funCallBack then
            funCallBack()
        end
    end
    local function showButtonMaskCallBack()
        TeachAssistor.removeGestureTxt()
        TeachAssistor.removeActionTxt()
        TeachAssistor.removeFemaleActor(removeFemaleActorCallBack)
    end
    local function showActionTxtCallBack()
        TeachAssistor.showGestureTxt(2)
        TeachAssistor.showButtonMask(showButtonMaskCallBack)
        TeachAssistor.JumpOverBtnToRunningScene(function() 
            TeachAssistor.JumpOverBtnStatus = true
            TeachAssistor.removeComonJuQing()
            TeachAssistor.removeFemaleActor(nil)
            removeFemaleActorCallBack()
        end)
    end
    local function showFemaleActorCallBack()
        TeachAssistor.showActionTxt(2,txtTip,showActionTxtCallBack)
    end
    local function showUDCallBack()
        TeachAssistor.showFemaleActor(showFemaleActorCallBack)
    end
    TeachAssistor.showGrayMask(GrayMaskOpacity)
    TeachAssistor.showUDBlackBorder(showUDCallBack,isTipThread)
end

function TeachAssistor.removeComonJuQing()
    TeachAssistor.removeDoubleClickLayout()
    TeachAssistor.removeButtonMask()
    TeachAssistor.removeGestureTxt()
    TeachAssistor.removeActionTxt()
    TeachAssistor.removeGrayMask(nil)
    TeachAssistor.removeUDBlackBorder(nil)
    local scene = cc.Director:getInstance():getRunningScene()
    GameCommonBox.removeFromParent(scene,2005)
    GameCommonBox.removeFromParent(scene,2004)
    GameCommonBox.removeFromParent(scene,2008)
end

--剧情单个对话
function TeachAssistor.removeSingleJuQing(callBack)
    local function removeGrayMaskCallBack()
        if nil ~= callBack then
            callBack()
        end
    end
    local function removeUDBlackBorderCallBack()
        TeachAssistor.removeGrayMask(removeGrayMaskCallBack)
    end
    TeachAssistor.removeActionTxt()
    TeachAssistor.removeGestureTxt()
    TeachAssistor.removeUDBlackBorder(removeUDBlackBorderCallBack)
end

--第二出现大波妹
function TeachAssistor.showSecondFemaleActor(txtTip,funCallBack)
    if true == TeachAssistor.JumpOverBtnStatus then
        TeachAssistor.runDelayTime(0.2,function() 
            if nil ~= funCallBack then
                funCallBack()
            end
        end)
        return 
    end
    local function removeGrayMaskCallBack()
        if nil ~= funCallBack then
            funCallBack()
        end
    end
    local function removeUDBlackBorderCallBack()
        TeachAssistor.removeGrayMask(removeGrayMaskCallBack)
    end
    local function removeFemaleActorCallBack()
        TeachAssistor.removeUDBlackBorder(removeUDBlackBorderCallBack)
    end
    local function showButtonMaskCallBack()
        TeachAssistor.removeGestureTxt()
        TeachAssistor.removeActionTxt()
        TeachAssistor.removeFemaleActor(removeFemaleActorCallBack)
    end
    local function showActionTxtCallBack()
        TeachAssistor.showGestureTxt(2)
        TeachAssistor.showButtonMask(showButtonMaskCallBack)
    end
    local function showFemaleActorCallBack()
        TeachAssistor.showActionTxt(2,txtTip,showActionTxtCallBack)
    end
    TeachAssistor.showFemaleActor(showFemaleActorCallBack)
end

--第二出现boss
function TeachAssistor.showSecondBossActor(txtTip,funCallBack)
    if true == TeachAssistor.JumpOverBtnStatus then
        TeachAssistor.runDelayTime(0.2,function() 
            if nil ~= funCallBack then
                funCallBack()
            end
        end)
        return 
    end
    local function removeGrayMaskCallBack()
        if nil ~= funCallBack then
            funCallBack()
        end
    end
    local function removeUDBlackBorderCallBack()
        TeachAssistor.removeGrayMask(removeGrayMaskCallBack)
    end
    local function removeBossActorCallBack()
        TeachAssistor.removeUDBlackBorder(removeUDBlackBorderCallBack)
    end
    local function showButtonMaskCallBack()
        TeachAssistor.removeActionTxt()
        TeachAssistor.removeGestureTxt()
        TeachAssistor.removeBossActor(removeBossActorCallBack)
    end
    local function showActionTxtCallBack()
        TeachAssistor.showGestureTxt(2)
        TeachAssistor.showButtonMask(showButtonMaskCallBack)
    end
    local function showBossActorCallBack()
        TeachAssistor.showActionTxt(2,txtTip,showActionTxtCallBack)
    end
    TeachAssistor.showBossActor(showBossActorCallBack)
end

function TeachAssistor.OpenRoleEquipScene()
    if false == GameMainScene.CheckSubFuncPageShowing(GameMainScene.pageZOrder.SUBPAGE_ROLEEQUIP) then
        if true == TeachAssistor.MainSceneIsRunning() then
            GameMainScene.AddSceneToSubFuncPage(GameMainScene.pageZOrder.SUBPAGE_ROLEEQUIP)
            RoleEquipScene.ReturnAllSubPage()
            return false
        else
            NowSceneReplace(GameMainScene,true)
            return false
        end
    end
    return true
end

function TeachAssistor.RoleEquipSceneIsShowing()
    return GameMainScene.CheckSubFuncPageShowing(GameMainScene.pageZOrder.SUBPAGE_ROLEEQUIP)
end

------
function TeachAssistor.OpenTaskScene()
    if false == GameMainScene.CheckSubFuncPageShowing(GameMainScene.pageZOrder.SUBPAGE_TASK) then
        if true == TeachAssistor.MainSceneIsRunning() then
            GameMainScene.AddSceneToSubFuncPage(GameMainScene.pageZOrder.SUBPAGE_TASK)
            AchieveScene.ReturnAllSubPage()
            return false
        else
            NowSceneReplace(GameMainScene,true)
            return false
        end
    end
    return true
end

----
function TeachAssistor.RoleTaskIsShowing()
    return GameMainScene.CheckSubFuncPageShowing(GameMainScene.pageZOrder.SUBPAGE_TASK)
end


------武器
function TeachAssistor.OpenWeaponScene()
    if false == GameMainScene.CheckSubFuncPageShowing(GameMainScene.pageZOrder.SUBPAGE_WEAPON) then
        if true == TeachAssistor.MainSceneIsRunning() then
            GameMainScene.AddSceneToSubFuncPage(GameMainScene.pageZOrder.SUBPAGE_WEAPON)
            WeaponScene.ReturnAllSubPage()
            return false
        else
            NowSceneReplace(GameMainScene,true)
            return false
        end
    end
    return true
end

----
function TeachAssistor.WeaponIsShowing()
    return GameMainScene.CheckSubFuncPageShowing(GameMainScene.pageZOrder.SUBPAGE_WEAPON)
end

function TeachAssistor.closeAllSubPage(subPage)
    if GameMainScene.pageZOrder.SUBPAGE_STORE == subPage then
        HuntBaoScene.ReturnAllSubPage()
    end
end
---
function TeachAssistor.OpenScene(subPage)
    if false == GameMainScene.CheckSubFuncPageShowing(subPage) then
        if true == TeachAssistor.MainSceneIsRunning() then
            GameMainScene.AddSceneToSubFuncPage(subPage)
            TeachAssistor.closeAllSubPage(subPage) 
            return false
        else
            NowSceneReplace(GameMainScene,true)
            return false
        end
    end
    return true
end

function TeachAssistor.addFlickerEffect(txtTip,offsetX1,offsetY1,offsetX2,offsetY2,scaleX,scaleY)
    
    if nil == offsetX1 then
        offsetX1 = 280
    end
    if nil == offsetY1 then
        offsetY1 = 90
    end
    if nil == offsetX2 then
       offsetX2 = 200
    end
    if nil == offsetY2 then
       offsetY2 = 52
    end
    if nil == scaleX then
        scaleX = 1.0
    end
    if nil == scaleY then
        scaleY = 1.0
    end
    
    local scene = cc.Director:getInstance():getRunningScene()
    local visibleSize = cc.Director:getInstance():getVisibleSize()
    local layout = GameCommonBox.CreateMaskLayout(cc.c3b(0,0,0),0)
   
    --添加冒泡指示
    local csbFBZDTips = cc.CSLoader:createNode("FBZD-tips.csb")
    csbFBZDTips:setPosition(cc.p(visibleSize.width-offsetX1,visibleSize.height-offsetY1))
    local imgCtl=csbFBZDTips:getChildByTag(1)
    local txtCtl=csbFBZDTips:getChildByTag(2)
    --txtCtl:enableShadow()
    txtCtl:ignoreContentAdaptWithSize(false)
    txtCtl:setTextAreaSize(cc.size(270,144))
    txtCtl:setPositionX(txtCtl:getPositionX()-10)
    txtCtl:setPositionY(txtCtl:getPositionY()-65)
    txtCtl:setString(txtTip)
    
    --添加闪烁
    local csbFBZD3cje = cc.CSLoader:createNode("FBZD-3cje.csb")
    local lineTimeFBZD3cje = cc.CSLoader:createTimeline("FBZD-3cje.csb")
    csbFBZD3cje:runAction(lineTimeFBZD3cje)
    lineTimeFBZD3cje:gotoFrameAndPlay(0,true)
    csbFBZD3cje:setPosition(cc.p(visibleSize.width-offsetX2,visibleSize.height-offsetY2))
    
    csbFBZD3cje:setScaleX(scaleX)
    csbFBZD3cje:setScaleX(scaleY)
    
    
    layout:addChild(csbFBZD3cje)
    layout:addChild(csbFBZDTips)
    scene:addChild(layout,50,TeachAssistor.flickerEffectTag)
    return layout
end

function TeachAssistor.showFBZDTips(txt,color,pos,txtAreaSize,isLeftFacing,imgSize,threadType)
    local csbFBZDTips = cc.CSLoader:createNode("FBZD-tips.csb")
    local imgCtl=csbFBZDTips:getChildByTag(1)
    local txtCtl=csbFBZDTips:getChildByTag(2)
    
    if nil ~= imgSize then
        imgCtl:setContentSize(imgSize)
    end
    
    if true == isLeftFacing then
        imgCtl:setScaleX(-1)
    end 
    txtCtl:ignoreContentAdaptWithSize(false)
    txtCtl:setTextAreaSize(txtAreaSize or cc.size(258,144))
       
    txtCtl:setPositionX(txtCtl:getPositionX()-10)
    txtCtl:setPositionY(txtCtl:getPositionY()-65)
    
    txtCtl:setString(txt)
    txtCtl:setColor(color or cc.c3b(0,0,0))
    local scene = cc.Director:getInstance():getRunningScene()
    local layout = GameCommonBox.CreateMaskLayout(cc.c3b(0,0,0),0)
    if false == threadType then
        scene:addChild(layout,50,TeachAssistor.layOutshowFBZDTipsTag)
    else
        scene:addChild(layout,50,TeachAssistor.transparentMaskTipTag)
    end
    
    
    csbFBZDTips:setPosition(pos)
    layout:addChild(csbFBZDTips)
end

function TeachAssistor.removeFBZDTips()
    local scene = cc.Director:getInstance():getRunningScene()
    local layout = scene:getChildByTag(TeachAssistor.transparentMaskTipTag)
    if nil == layout then
        layout = scene:getChildByTag(TeachAssistor.layOutshowFBZDTipsTag)
    end 
    if nil~= layout then
        layout:removeFromParent()
    end
end


function TeachAssistor.releaseFlickerEffect()
    local scene = cc.Director:getInstance():getRunningScene()
    if nil ~= scene then
        local nodeChild = scene:getChildByTag(TeachAssistor.flickerEffectTag)
        if nil ~= nodeChild then
            nodeChild:removeFromParent()
        end
    end
end

--20081
function TeachAssistor.addBtnCircleEffect(btn,scaleX,scaleY)
    local nowPath = "FBZD-3cje.csb"
    local effect = GameCommonBox.createEffective(nowPath,true)
    effect:setScaleX(scaleX or 1.0)
    effect:setScaleY(scaleY or 1.0)
    local size = btn:getContentSize()
    effect:setPosition(cc.p(size.width/2.0,size.height/2.0))
    btn:addChild(effect,0,20081)
end

function TeachAssistor.removeBtnCircleEffect(btn)
    local childNode = btn:getChildByTag(20081)
    if nil ~= childNode then
        childNode:removeFromParent()
    end
end

function TeachAssistor.showTxtInScene(txtTip,color,isTipThread)
    local visibleSize = cc.Director:getInstance():getVisibleSize()
    local scene = cc.Director:getInstance():getRunningScene()
    local txtCtrl = TeachAssistor.createTxt(txtTip,color)
    local layout = TeachAssistor.CreateMaskLayout(cc.c3b(0,0,0),180)
    txtCtrl:setPosition(cc.p(visibleSize.width/2.0,visibleSize.height/2.0))
    layout:addChild(txtCtrl)
    if true == isTipThread then
        scene:addChild(layout,22,TeachAssistor.layOutshowTxtTag)
    else
        scene:addChild(layout,22,TeachAssistor.layOutshowTxtTipTag)
    end
end

function TeachAssistor.removeTxtInScene()
    local scene = cc.Director:getInstance():getRunningScene()
    local  childNode = scene:getChildByTag(TeachAssistor.layOutshowTxtTag)
    if nil == childNode then
        childNode = scene:getChildByTag(TeachAssistor.layOutshowTxtTipTag)
    end
    if nil ~= childNode then
        childNode:removeFromParent()
    end
end

-----
function TeachAssistor.sceneIsShowing(subPage)
    return GameMainScene.CheckSubFuncPageShowing(subPage)
end


--判断子界面是否有显示

function TeachAssistor.isHasChildShowAtMainScene()
    for key,value in pairs(GameMainScene.pageZOrder) do
        if true == GameMainScene.CheckSubFuncPageShowing(value) then
            return true
        end
    end
    return false
end


--走装备流程
function TeachAssistor.equipDemo(btn,funCallBack,bFlag)
    local function actionFinished()
        RoleEquipScene.AutoShowCanEquipPosition()
        if nil ~= funCallBack then
            funCallBack()
        end
    end
    cc.Director:getInstance():getRunningScene():runAction(cc.Sequence:create(cc.DelayTime:create(1),cc.CallFunc:create(actionFinished)))
end

--执行延迟动作
function TeachAssistor.runDelayTime(funCallBack)
    local node = cc.Node:create()
    local function actionFinished()
        if nil ~= node then
            node:removeFromParent()
            node = nil
        end
        if nil ~= funCallBack then
            funCallBack()
        end
    end
    local scene = cc.Director:getInstance():getRunningScene()
    scene:addChild(node)
    node:runAction(cc.Sequence:create(cc.DelayTime:create(0.5),cc.CallFunc:create(actionFinished)))
end

--执行延迟动作
function TeachAssistor.runDelayTime(delayTime,funCallBack)
    local node = cc.Node:create()
    local function actionFinished()
        if nil ~= node then
            node:removeFromParent()
            node = nil
        end
        if nil ~= funCallBack then
            funCallBack()
        end
    end
    local scene = cc.Director:getInstance():getRunningScene()
    scene:addChild(node)
    node:runAction(cc.Sequence:create(cc.DelayTime:create(delayTime),cc.CallFunc:create(actionFinished)))
end

function TeachAssistor.normalBossWillHitHero()
    local monster_count=List.getSize(nowmonster)
    local nowBoss = nil
    if monster_count>0 then

        for i=1, monster_count do
            local obj = nowmonster[i]
            if obj._is_boss == true then
                nowBoss = obj
                break
            end
        end
    end
    local hero = nowPlayer[1]
    local willhit = false
    if nil ~= nowBoss and nowBoss._ActorState >= EnumStateType.attack then
        if math.abs(nowBoss.x - hero.x) < 450 then
            willhit = true
        end
    end
    return willhit
end

--增加埋点函数
function TeachAssistor.buriedPoint(strParam)
    --GameNetwork.Game_Request(request_num.NETWORK_REQUEST_TUTORIAL_SETSTEP_EX1,strParam)
end

function TeachAssistor.buriedPointNew(strParam)
    --GameNetwork.Game_Request(request_num.NETWORK_REQUEST_TUTORIAL_SETSTEP_EX1,strParam)
end

function TeachAssistor.buriedPointTip(strParam)
    --GameNetwork.Game_Request(request_num.NETWORK_REQUEST_TUTORIAL_SETSTEP_EX2,strParam)
end

function TeachAssistor.buriedPointTipNew(strParam)
    --GameNetwork.Game_Request(request_num.NETWORK_REQUEST_TUTORIAL_SETSTEP_EX2,strParam)
end


--返回 step key
function TeachAssistor.getNextKeyFromLessonAllSteps(stepLesson)
    for key=1,table.getn(LessonAllSteps) do
        if LessonAllSteps[key] == stepLesson then
            return key+1
        end
    end
    return -1
end

--是否需要 skip
function TeachAssistor.isNeedSkip(value)
    for key =1,table.getn(LessonSkip) do
        if LessonSkip[key]== value then
            return true
        end
    end
    return false
end

function TeachAssistor.setNextStep(curLesson)
    local nextKey = TeachAssistor.getNextKeyFromLessonAllSteps(curLesson)
    if -1 ~= nextKey then
        local nextLesson = LessonAllSteps[nextKey]
        if nil ~= nextLesson then
            GameTeachManager.AddLesson("Lesson"..nextLesson)
            return true
        else
            GameTeachManager.Shutdown()
            return false
        end
    else
        GameTeachManager.Shutdown()
        return false
    end
end

--旧
--LessonAllSteps={
--    1,2,31,41,51,61,71,81,
--    91,101,111,121,131,141,
--    151,371,221,181,191,201,211,
--    271,281,331,341,351,161,171,
--    231,241,251,261,262,361,282,
--    291,301,302,311,321
--}
--
--LessonSkip={51,61,71,81,91,101,111,121,131,141,151,161,171,181,201,371,221,231,262,271,282,291,302,311,331,351,361,321}

--新 旧
--181,191,201,211,231,241,251,261
--LessonAllSteps={
--    1,2,31,41,51,61,71,81,
--    91,101,111,121,131,141,
--    151,371,221,271,281,331,
--    341,351,161,171,262,361,
--    282,381,291,301,302,391,401,411,311,321
--}
--181 231
--LessonSkip={51,61,71,81,91,101,111,121,131,141,151,161,171,201,371,221,262,271,281,282,381,291,301,302,311,331,351,361,321,391,401,411}

--新
--181,191,201,211,231,241,251,261
--LessonAllSteps={
--    1,2,31,41,61,71,81,
--    91,101,111,121,131,481,141,
--    151,491,371,221,401,411,262,
--    381,291,301,302,431,391,471,501,271,
--    331,341,351,311,361,441,451,461
--}
----2016-18
--LessonAllSteps={
--    1,2,31,41,61,71,81,
--    91,101,371,221,401,411,262,
--    381,291,301,302,431,391,471,501,271,
--    331,341,351,311,361,441,451,461
--}
--2016-19
--LessonAllSteps={
--    1,2,31,41,81,91,101,61,521,201,
--    221,541,371,551,531,571,341,561,351,401,581,181,591,411,262,291,301,302,431,471,311,361,441,451,461,501,271,111,131,391
--}

--2016-3-15 --81,91 371 262  391  451  461 131
LessonAllSteps={
   1,2,3,4,5,6,7,8,9,10,11,12
}
--181 231 661 131
LessonSkip={61,81,91,101,111,121,161,171,201,371,221,262,271,381,291,301,302,311,
331,341,351,361,391,401,181,411,431,441,451,461,471,481,491,501,521,201,531,541,551,561,571,581,591,601,611,621,631,641,651,661}

--登录成功之前调用
function TeachAssistor.setIsRunAssistor(isRunAssistor)
    TeachAssistor.IsRunAssistor = isRunAssistor
end

function TeachAssistor.setIsHideExtraTips(isHideExtraTips) 
    TeachAssistor.IsHideExtraTips = isHideExtraTips
end
function TeachAssistor.setForceAssistorIsRunning(forceAssistorIsRunning)
    TeachAssistor.forceAssistorIsRunning = forceAssistorIsRunning
end

function TeachAssistor.LessonComplete(mian_t_index)
    GameRecorder.SetBasicData("tutorial1",mian_t_index)
    GameRecorder.SaveBasicData()
end

function TeachAssistor.runTeachAssistor(need_check)
    --判断是否跑教程
    if false == TeachAssistor.IsRunAssistor then
        return false
    end
    
--    if GamePlayer.GetBasicData("type")== user_type.USER_TYPE_GM then
--        TeachAssistor.setIsHideExtraTips(false)
--    else
--        TeachAssistor.setIsHideExtraTips(true)
--    end
    
--    GameNetwork.Game_Request(request_num.NETWORK_REQUEST_ACTIVEFILTER_GET) --请求列表
--    if true then
--        --GameManager.setLessonStep(581)
--        return false
--    end

    
--    GameNetwork.Game_Request(request_num.NETWORK_REQUEST_ACTIVEFILTER_GET) --请求列表
    if TeachAssistor.IsRunAssistor then
--        local totalNum = table.getn(LessonAllSteps)
--        GameTeachManager.Shutdown()
--        local stepLesson = GamePlayer.GetBasicData("tutorialStep")
--        local nextKey = TeachAssistor.getNextKeyFromLessonAllSteps(stepLesson)
--        if -1 ~= nextKey and nil ~= LessonAllSteps[nextKey] then
--            local nextStep = LessonAllSteps[nextKey]
--            local lessonPath = "Lesson"..nextStep
--            if true == TeachAssistor.isNeedSkip(nextStep) then
--                NowSceneReplace(GameMainScene,true)
--            end
--            if 591 == nextStep then
--                TeachAssistor.lesson591 = true
--            end
--            GameTeachManager.AddLesson(lessonPath)
--            GameTeachManager.Run()
--            return  true
--        end
        local curLesson = GameRecorder.GetBasicData("tutorial1") 
        -- curLesson = 6
        if need_check and curLesson>0 then
            
            if TeachAssistor.setNextStep(curLesson) then
                GameTeachManager.Run()
            end
            
        else
            local lessonPath = "Lesson"..LessonAllSteps[1]
            GameTeachManager.AddLesson(lessonPath)
            GameTeachManager.Run()
        end
        
    else
        return false
    end
    
end

LessonTipAllSteps = {}

function TeachAssistor.lessonIsDone(id)
    for key,value in pairs(LessonTipAllSteps) do
        if id == value.id then
            return false
        end
    end
    return true
end

function TeachAssistor.runTeachTipAssistor(tableInfo)
    --判断是否跑教程
    if QUICK_DEBUG then
        return false
    end
    if false == TeachAssistor.IsRunAssistor then
        return false
    end
--        if true then
--            local pathLesson = "LessonTip"..321
--            GameTeachTipManager.AddLesson(pathLesson)
--            GameTeachTipManager.Run()
--            return true
--        end
    if type(tableInfo) == "table" then
        table.clear(LessonTipAllSteps)
        table.copy(tableInfo,LessonTipAllSteps)
        local flag = false
        for key,value in pairs(LessonTipAllSteps) do
            if 201 ~= value.id and 231 ~= value.id  and 181 ~= value.id then --
                local pathLesson = "LessonTip"..value.id
                if false == GameTeachTipManager.lessonIsRuning(pathLesson) then
                    GameTeachTipManager.AddLesson(pathLesson)
                    flag = true
                end
            end
        end   
        if true == flag then
            GameTeachTipManager.Run()
        else
            GameTeachTipManager.Shutdown()
            TeachAssistor.Tipmutex = false
        end
        TeachAssistor.lessonTipDataIsCallBackFlag = true
    end
end
