
KEYBOARDLISTENER_NODE_TAG=444

KeyboardListener={}

function KeyboardListener.Run()

    local targetPlatform = cc.Application:getInstance():getTargetPlatform()
    if (cc.PLATFORM_OS_ANDROID~=targetPlatform) then return end

    local function tick()
        KeyboardListener.UpdateProcess()
    end
    KeyboardListener.schedulerID = cc.Director:getInstance():getScheduler():scheduleScriptFunc(tick, 0, false)
end

function KeyboardListener.UpdateProcess()
    KeyboardListener.AddNode()
end

function KeyboardListener.AddNode()
    
    local nowScene = cc.Director:getInstance():getRunningScene()
    if not nowScene then return end
    
    if nowScene:getChildByTag(KEYBOARDLISTENER_NODE_TAG) then return end
    local node = cc.Node:create()
    nowScene:addChild(node,KEYBOARDLISTENER_NODE_TAG,KEYBOARDLISTENER_NODE_TAG)
    
    local function onrelease(code,event)
        if code == 6 then
            if GameAssistor.SceneIsRunning("GameScene") then
            end
            --GameAssistor.EndToLua()
        end
        --outputString("code:",code)
    end
    local listener = cc.EventListenerKeyboard:create()
    listener:registerScriptHandler(onrelease, cc.Handler.EVENT_KEYBOARD_RELEASED)
    local eventDispatcher = nowScene:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listener,nowScene)
end

KeyboardListener.Run()


