
MainScene = {}

MainScene = class("MainScene",function()
    return cc.Scene:create()
end)

function MainScene.create()

    local scene = MainScene.new()

    local page_login = cc.CSLoader:createNode("login.csb")
    scene:addChild(page_login) page_login:setVisible(false)

    local btLogin=page_login:getChildByTag(1)
    btLogin.loading = false

    local function Login()
        if btLogin.loading then
            return 
        end 
        btLogin.loading=true         
        GameDataTransfer.LoadServerData()
    end

   -- local splash = MainScene.createLogo()
   -- scene:addChild(splash)

    local logoSplash = function()

        CommonAssistor.AddSimpleTouchEvent(btLogin,function()
            Login()
        end)


        local page_logo = cc.CSLoader:createNode("LOGO.csb")
        
        local visibleSize=cc.Director:getInstance():getVisibleSize()
        page_logo:setPosition(visibleSize.width/2,visibleSize.height/2)
        
        



        local function HidePage()
            if PINGTEST then return GameDataTransfer.LoadServerData() end
            page_logo:setVisible(false)
            local spine = CreateSpineRes("effect/piantou","effect/piantou")
            spine:setPosition(visibleSize.width/2,visibleSize.height/2)
            spine:setAnimation(0,"animation",false)
            local bg = page_login:getChildByTag(0)
            




            scene:addChild(spine)

            local screenSize = cc.Director:getInstance():getWinSize()
            local resfont={
                        outlineSize=0,fontSize=30,fontFilePath="Fonts/Number-ty3.ttf"
                    }
            local strLable=cc.Label:createWithTTF(resfont,"任意点击跳过动画")
            strLable:setAlignment(cc.TEXT_ALIGNMENT_LEFT,cc.TEXT_ALIGNMENT_CENTER)
            strLable:setWidth(screenSize.width)
            strLable:setAnchorPoint(cc.p(0,1))
            strLable:setPosition(-100,-300)
            spine:addChild(strLable,10000000)

            spine:registerSpineEventHandler(function (event)
                strLable:removeFromParent()
            end, sp.EventType.ANIMATION_COMPLETE)

            bg:addTouchEventListener(function(sender,eventType)
                if eventType==ccui.TouchEventType.ended then
                    Login()
                end
            end)

            
            page_login:setVisible(true)
        end
        page_logo:runAction(cc.Sequence:create(cc.DelayTime:create(2),cc.FadeOut:create(1),cc.CallFunc:create(HidePage)))
        
        scene:addChild(page_logo)
        --splash:removeFromParent()
    end

    logoSplash()
    --splash:runAction(cc.Sequence:create(cc.DelayTime:create(2),cc.CallFunc:create(logoSplash)))

    return scene
end

function MainScene.create2()

    local scene = MainScene.new()

    local page_login = cc.CSLoader:createNode("login.csb")
    scene:addChild(page_login)

    local btLogin=page_login:getChildByTag(1)
    CommonAssistor.AddSimpleTouchEvent(btLogin,function()
        if btLogin.loading then return end btLogin.loading=true         
        GameDataTransfer.LoadServerData()
    end)

    local visibleSize=cc.Director:getInstance():getVisibleSize()
    
    local spine = CreateSpineRes("effect/piantou","effect/piantou")
    spine:setPosition(visibleSize.width/2,visibleSize.height/2)
    spine:setAnimation(0,"animation",false)
    scene:addChild(spine)
    
    return scene
end

function MainScene.createLogo()

    local visibleSize=cc.Director:getInstance():getVisibleSize()

    local layout = ccui.Layout:create()
    layout:setTouchEnabled(true)
    layout:setContentSize(visibleSize)
    layout:setBackGroundColor(cc.c3b(255,255,255))
    layout:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
    layout:setOpacity(255)

    local logo = cc.Sprite:create("Image/logo.png")
    logo:setPosition(visibleSize.width/2,visibleSize.height/2)
    logo:setCascadeColorEnabled(true)
    logo:setScaleX(visibleSize.width / 960)
    logo:setScaleY(visibleSize.height/ 640)
    -- logo:setTextureRect(cc.rect(0,0,visibleSize.width,visibleSize.height))
    -- logo:setHeight(visibleSize.height)
    layout:addChild(logo)

    return layout
end


