DropItem = class ("DropItem")

DropItem.JewelryIconList={
    2541,
    2542,
    2538,
    2539,
    2543,
    2540,
}


DropItem.WeaponIconList={
    2546,
    2547,
    2548,
    
}


function DropItem:ctor()

    
end
function DropItem.getJewelryIconId(award)
    return DropItem.JewelryIconList[award.Type]
end

function DropItem.getWeaponIconId(award)
    return DropItem.WeaponIconList[award.Profession]
end


function DropItem.GetGameItem(awardID)
    return GameData_List.Game_Item[awardID]
end

function DropItem.creat(mm_x,mm_y,awardID,fixX,nums,endType)
    local base = DropItem.new()
    table.copy(itemValue,base)
    local typeIndex = -1
    local ImagePath = ""
    local quality_type = 1 
    local itemName = ""
    
    local award=nil
    if DropItem.GetGameItem(awardID) then --普通道具&普通装备
    
        award = DropItem.GetGameItem(awardID)
        quality_type = award.Quality
        itemName = GameDataTransfer.GetGameString(award.Equip_Name)
        ImagePath = "Icons/diao/"..award.ShowItem..".png"
        if awardID < 10 then  base.needNum = true end
--    elseif GameDataTransfer.GetGameJewelry(awardID) then --饰品
--        award = GameDataTransfer.GetGameJewelry(awardID)
--        itemName = GameDataTransfer.GetGameString(award.Name)
--        quality_type = award.Quality
--        ImagePath = "Icons/diao/"..DropItem.getJewelryIconId(award)..".png"
--    elseif GameDataTransfer.GetGameWeapon(awardID) then --武器
--        award = GameDataTransfer.GetGameWeapon(awardID)
--        itemName = GameDataTransfer.GetGameString(award.Name)
--        quality_type = award.Quality
--        ImagePath = "Icons/diao/"..DropItem.getWeaponIconId(award)..".png"
--    elseif GameDataTransfer.GetGamePackage(awardID) then --普通道具
--        award = GameDataTransfer.GetGamePackage(awardID)
--        itemName = GameDataTransfer.GetGameString(award.Name)
--        quality_type = award.Quality
--        ImagePath = GameDataTransfer.GetIconPath(award.Icon)
--    else
--        if GameDataTransfer.GetBasicAwardIconID(awardID) ~= nil then
--            ImagePath = "Icons/diao/"..GameDataTransfer.GetBasicAwardIconID(awardID)..".png"
--            quality_type = 1
--            itemName = GameDataTransfer.GetSysString(awardID+str_system.STRING_NAME_AWARD)
--            base.needNum = true
--        end
    end
    
    
    base.name = itemName
    base.haveNum = nums
    base:initSpine(ImagePath,itemName,quality_type)
    base.quality_type = quality_type
    local end_type = 0
    if endType and endType > 0 then end_type = endType end
    base:setXY(mm_x,mm_y,fixX,end_type)

    


    return base
end

function DropItem:delete() --删除共有指针
    
    if self.baseNode ~= nil then
        self.touchNode = nil   
        self.name=""   
        self.canCollect = false  
        self.baseNode:removeFromParent()
        self.shadowNode:removeFromParent()
        self.shadowNode = nil
        self.baseNode=nil
    end
    
    
end

function DropItem:setXY(m_x,m_y,fixX,end_type)
    local fixY = Random(100,400)
    local groundY = GameManager.getObjGroundY(fixX,m_y+200+fixY) + self.offset
    --local fixgroundY = GameManager.getGroundY(fixX) + self.offset
    self.baseNode:setPositionX(m_x)
    self.baseNode:setPositionY(m_y)
    
    self.shadowNode:setPositionX(fixX)
    self.shadowNode:setPositionY(groundY)
    
    local function moveEnd()
        self.canCollect = true
        self.nameNode:setVisible(true)
        
        --local tempWS = cc.CSLoader:createNode("DLW.csb")
        --local t_tempWS=  cc.CSLoader:createTimeline("DLW.csb")
        --self.baseNode:addChild(tempWS)
        --tempWS:setPosition(win2:getPosition())
        --tempWS:runAction(t_tempWS)
        --t_tempWS:gotoFrameAndPlay(0,true)
        
        
        
--        local pNode = tempWS:getChildren()
--        local nowPNode = pNode[1]:getChildren()
--        for key, var in pairs(nowPNode) do
--            if var.setPositionType then
--                var:setPositionType(cc.POSITION_TYPE_GROUPED)
--            end
--
--        end
--        
--        self.baseNode:reorderChild(tempWS,3)
        
        if end_type == 0 then
            local up = cc.MoveBy:create(0.5,{x=0,y=30})
            local down = up:reverse()
            local re = cc.RepeatForever:create(cc.Sequence:create(up,down))--cc.Repeat:create(cc.Sequence:create(),int)
            self.baseNode:runAction(re)
        end
    end
    
    local startAction = cc.EaseInOut:create(cc.MoveTo:create(0.5,{x = m_x+(fixX - m_x)/2,y = groundY + 200+ fixY}),1.35)
    local endAction =   cc.EaseBounceOut:create(cc.EaseInOut:create(cc.MoveTo:create(0.5,{x = fixX,y = groundY }),0.65))
    local rotateAction1 = cc.RotateTo:create(0.5,720)
    local rotateAction2 = cc.RotateBy:create(0.5,720)
    local cF = cc.CallFunc:create(moveEnd)
    local A1 = cc.Spawn:create(startAction,rotateAction1)
    local A2 = cc.Spawn:create(endAction,rotateAction2)
    
    if end_type == 0 then
        self.baseNode:runAction(cc.Sequence:create(A1,A2,cc.MoveBy:create(0,{x=0,y=25}),cF))
    else
        self.baseNode:runAction(cc.Sequence:create(A1,A2,cF))
    end

end
function DropItem:getBox()
    local bb = self.touchNode:getBoundingBox()
    local nowX,nowY = self.baseNode:getPosition()
    bb.x = bb.x + nowX
    bb.y = bb.y + nowY
    
    return bb
end
function DropItem:initSpine(ImagePath,itemName,qT)
    
    self.baseNode=cc.Node:create()
    --cclog("now Image path = %s",ImagePath)
    
    if not cc.FileUtils:getInstance():isFileExist(ImagePath) then
        ImagePath = string.gsub(ImagePath,"jpg","png")
    end
    
    local backImg =cc.Sprite:create(ImagePath)   --模板图片
    --backImg:setSpriteFrame(ImagePath)
    local imgHeight = backImg:getTextureRect().height
    backImg:setAnchorPoint({x = 0.5, y = 0.5})
    --backImg:setScale(1)
    self.baseNode:addChild(backImg,1,1)
    
    local backName = ccui.Text:create(itemName,"Number/Number-ty3.ttf",12)
    backName:setColor(quality_color[qT])
    backName:enableOutline(cc.c4b(0,0,0,255),1)
    
    local textHeight = backName:getContentSize().height
    
    self.baseNode:addChild(backName,2,2)
    
    backImg:setPosition(0,0)
    
    backName:setPosition(0,imgHeight/2+textHeight/2 + 5)
    self.offset = 0
    self.touchNode = backImg
    
    backName:setVisible(false)
    self.nameNode = backName

    self.shadowNode = cc.CSLoader:createNode("yingzi.csb")
    self.shadowNode:setScaleX(0.7)
    self.shadowNode:setScaleY(0.7)
    --self:addChild(self._sprite)

end