require "tools/Tools"
--[[
Monster Actors Values：
]]--

---hurtEffect
--cc.SpriteFrameCache:getInstance():addSpriteFrames("FX/FX.plist")
--RECTS = {
--    iceBolt = cc.SpriteFrameCache:getInstance():getSpriteFrame("icebolt.png"):getRect(),
--    iceSpike =cc.SpriteFrameCache:getInstance():getSpriteFrame("iceSpike1.png"):getRect(),
--    fireBall = cc.SpriteFrameCache:getInstance():getSpriteFrame("fireball1.png"):getRect(),
--    thunderBall = cc.SpriteFrameCache:getInstance():getSpriteFrame("thunderball.png"):getRect(),
--}
--cc.SpriteFrameCache:getInstance():addSpriteFrames("battlefieldUI/battleFieldUI.plist")

--animationCache = cc.AnimationCache:getInstance()
--local hurtAnimation = cc.Animation:create()
--for i=1,5 do
--    name = "hit"..i..".png"
--    hurtAnimation:addSpriteFrame(cc.SpriteFrameCache:getInstance():getSpriteFrame(name))
--end
--hurtAnimation:setDelayPerUnit(0.1)
--animationCache:addAnimation(hurtAnimation,"hurtAnimation")
--local fireBallAnim = cc.Animation:create()
--for i=2,5 do
--    name = "fireball"..i..".png"
--    fireBallAnim:addSpriteFrame(cc.SpriteFrameCache:getInstance():getSpriteFrame(name))
--end
--fireBallAnim:setDelayPerUnit(0.1)
--animationCache:addAnimation(fireBallAnim,"fireBallAnim")

FXZorder = 1999
CelLine = 0.009


BuffType = enum{
 "maxhp=1",
 "attack",
 "defend",
 "critrate",
 "toughness",
 "critattack",
 "critreduce",
 "hp=100",
 "movespeed",
 "stun",
 "freeze",
 "brun",
 "frozen",
 "addEnergy"
}

BuffCastType = enum{
    "ManKill=1",
    "addEnergy",
    
}
--G values

G =
{
    winSize = cc.Director:getInstance():getWinSize(),
    bloodPercentDropSpeed = 2,
    defaultLeft=0,
    defaultRight=3840,
    activearea = {left = 0, right = 3840, bottom = 0, top = 720},
}


--Audios
BGM_RES = 
{
    MAINMENUBGM = "audios/01 Beast Hunt.mp3",
    MAINMENUSTART= "audios/effects/magical_3.mp3",
    BATTLEFIELDBGM = "audios/The_Last_Encounter_Short_Loop.mp3",
    CHOOSEROLESCENEBGM = "audios/Imminent Threat Beat B FULL Loop.mp3"
}

--play2d id
AUDIO_ID = 
{
    MAINMENUBGM,
    BATTLEFIELDBGM,
    CHOOSEROLECHAPTERBGM,
    KNIGHTNORMALATTACK,
    KNIGHTSPECIALATTACK,
    ARCHERATTACK
    
}

EnumRaceType = 
    { 
        "HERO",  --only this
        "MONSTER", --and this
        "Boss"
    }
    
EnumRaceType = CreateEnumTable(EnumRaceType) 

EnumHitType =
    {
        "Nothing", --无反应
        "minor",   --轻击
        "serious",  --重击
        "airHit", --浮空
        "stun", --眩晕
        "knockBack", --击退
        "knock" --击飞
        
        
    }
EnumHitType = CreateEnumTable(EnumHitType)

EnumCombo = {
    [1]="D_1",
    [2]="D_2",
    [3]="D_3",
    [4]="D_4",
    [5]="D_5"
}



EnumStateType =
    { 
        "stand",   --待机
        "run",  --跑动
        "jump",  --跳
        "minor_injured", --受轻伤
        "serious_injured", --受重伤
        "inair", --浮空
        "stun", --眩晕
        "freeze", --冻结
        "knockout", --击飞
        "knockback", --击退
        "breakShield", --被破甲
        "defens", --格挡
        "roll", --翻滚
        "couch", --躺下
        "readytodie", --躺下
        "dead",  --死亡&删除
        "Bossdead",  --死亡&删除
        "Show",
        "win",  --胜利
        "attack", --攻击
        "skill_1", --技能1
        "skill_2", --技能2
        "skill_3", --技能3
        "skill_4", --技能4
        "skill_5", --技能5
        "skill_6", --技能6
        "skill_7", --技能7
        "skill_8", --技能8
        "skill_9" --技能9
        
    }
EnumStateType = CreateEnumTable(EnumStateType) 
--common value is used to reset an actor

ActorCommonValues =    --角色基本属性
{
--    move_pro={
--            needFixXY = false,
--            shouldCheckHit = false, --是否检测攻击碰撞
--            actor_move = false,
--            should_play_couch = true,
--            enable_gravity = true,   --是否开启引力模式
--            force_move = false,
--            skillFixX = 0,
--            SkillFixY =0,
--            button_temp_dir = 1,
--            actor_y_offset =0,
--            actor_now_scale = 1,
--            actor_show_type = 1,
--            speed_x = 1,
--            gravity_speed = 10,
--            camera_x = 0,
--            RollSpeed=0,      --翻滚速度
--            collideRect = cc.rect(0,0,2,2),  --角色碰撞盒
--            hitEffectRect = cc.rect(0,0,2,2),  --受击光效盒
--            m_CollitionBox = cc.rect(0,0,2,2),  --攻击碰撞盒
--            temp_CollitionBox = cc.rect(0,0,2,2), --临时攻击碰撞盒
--            temp_move_point = cc.p(0,0),
--            x             = 0,
--            y             = 0,
--            _range_speed_x    = 10,
--            _range_speed_y    = 10,
--            ground_y      = 0,
--            _moveto_point   = cc.p(-1,-1),
--            Actor_motion_speed = 1,
--            skill_move_type = 1,
--            _curFacing      = 1, -- current direction the actor is facing, in radians, 0 is to the right
--            lastX = 0,
--            move_temp_x = 0,
--    },
--    
--    battle_pro ={
--            --lastAddEnergyTime = 0,
--            --nowAddEnergyTime =0,
--            accept_add_time = 0,
--            standup_invincible = false,
--            low_hp_warnning = false,
--            monster_combo = true,
--            should_furry = false,
--            _comboShouldAccept = true,   --when the time equal 0 then interpput the combo
--            _actionComplete = false,  -- 动作播完
--            _isInvincible = false,   --actor is invincible 无敌状态
--            _canChangeState = true,   --现阶段是否可以改变状态
--            need_Bullet_Assign = false,
--            _LastcomboStep = 0,
--            power_time = 0,
--            _comboAcceptTime = 1,   --when the time equal 0 then interpput the combo
--            _now_comboStep       = 1,       --which combo attack will make 
--            _comboStep       = 1,       --which combo attack will make 
--            _comboMax       = 5,       --which combo attack will make 
--            normal_hit_delay = 0,
--            _skill_hit_step  = 0,
--            Last_skill_step = 0,
--            Last_skill_release = 0,
--            _LastState    = EnumStateType.stand,   --此状态的前一个状态
--            _ActorState   = EnumStateType.stand,  --actor states
--            _AirHitState   = EnumHitType.minor,  --浮空受击状态
--            _fallTime     = 1,      --time for change to stand states after fall to  the ground
--            _stunTime     = 0,      --time for change to stand states after fall to  the ground
--            _isInAir      = false,  --actor is in air?
--            _isPowerUp    = false,  --霸体状态
--            _isHitTheGround    = false,  --霸体状态
--            _search_range   = 1000,
--            _attack_range   = 200,
--            _hard_time      = 0, --动作硬直时间
--            _request_hard_time    = 0, --需要硬直的时间
--            _break_time      = 0, --霸体硬直时间
--            _request_break_time    = 0, --霸体需要硬直的时间
--            skill_list      = nil, --the skill list
--            normal_att_list = nil, -- normal attack list
--            skill_cd        = nil, -- skill cd list
--            last_skill_id = 0,
--            now_skill_id=0,
--
--            role_energy = 0,
--
--            can_add_combo = false,
--            hit_combo_value = 0,
--            hit_combo_time = 0, 
--            hit_id   = 0,
--            hit_start_time   = 0,
--            _shield          = 500,
--            _shieldMax       = 500,
--            _hp             = 1000, --current hit point
--            _hp_max         = 1000, --current hit point
--            
--            can_drink = false,
--            shouldCheckCounter = false,
--            shouldDeleteAD = false ,
--            counterModeEnable = false,
--            counterMode = false,
--            combo_skill_mode =false,
--            _last_att_id=0,
--            _last_d_id=0,
--            all_resist = false,
--            temp_hit_type=1,
--            
--            
--            
--    },
--    count_pro ={
--            in_air_count = 0,
--            use_full_skill_count=0,
--            last_kill_npc = 0,
--            now_kill_npc = 0,
--            hit_affter_dead = 0,
--            balance_count = 10,
--            continue_hit_count = 0,
--            hit_npc_count = 0,
--            isStorageSkill = false,
--            StorageSkilleachDam = 0,
--            StorageSkillAllDam = 0,
--            StorageSkillAllNum = 0,
--            StorageSkillCount = 0,
--            StorageSkillEndActionID = 0,
--            skill_release_count =0,
--            die_hit_count = 0,
--            shadowCount = 6,
--            light_count = 0,
--            gold_count =0,
--            hit_combo_skill_now_count = 0,
--            hit_combo_skill_all_count = 70,
--            _shield_hit_count  = 0,
--            _shield_hit_time  = 0,
--            drink_count = 0,
--            
--            _float_time = 0,
--            _float_count = 0,
--            
--    
--    },
--    basic_pro ={
--            in_PVE = false,
--            first_die = true,
--            have_elite_mark = false,
--            pet_tips_showing = false,
--            already_send_balance = false,
--            skill_press = false,
--            shadowMode = false,
--            isPlayerRole = false,
--            isNpcRole = false,
--            actor_should_drop = false,
--            actor_is_friend = false,
--            _AIEnabled      = false, --if false, AI will not run
--            World_Boss = false,
--            start_skill = false,
--            qte_furry = false,
--            inPower_mode = false,
--            first_show = false,
--            attRange = 0,
--            extra_sound_effect =0,
--            _gamescene = nil,
--            actor_name = nil,
--            tipData = 0,
--            _actor_id=0,
--            _actor_type=0,
--            role_id=0,
--            _wave_id=0,
--            basic_attack = 0,       --角色攻击力
--            basic_defend = 0,       --角色防御力
--            _curAnimation = "",     --当前动作名称
--            
--            _target         = nil, --the enemy actor 
--            soundControl ={
--                now_skill_sound_list = nil,
--            },
--            AITime = 0,
--            AttTime = 0,
--            AIFunction = nil,
--            AIValue = 0,
--            AIActionDone = false,
--            attackRate_list = nil,
--
--            defenceRate_list = nil,
--
--            lifeRate_list   = nil,
--
--            tempNowShadow = nil,
--
--            hit_id_list = nil,
--
--            Buff_List =0,
--
--            equip_pets = {},
--            element_type = 0,
--            Counter_Skill_Index =0,
--            gameisWin = false,
--            _Blood_1 = nil,
--            _Blood_2 = nil,
--            extra_sound_effect =0,
--            ultra_mode = 1,
--            drink_maxcd = 3,
--            drink_cd = 0,
--            drink_button = 0,
--            ready_to_play_die = 0,
--            
--            
--            level =1,
--            
--            _is_boss = false,
--            _ai_level = 1,
--            _ai_should_hit = true,
--            all_dropItemName = nil,
--
--    },
    jumpattack = 0,
    isDoubleJump = 0,
    in_air_count = 0,
    in_PVE = false,
    use_full_skill_count=0,
    lastAddEnergyTime = 0,
    nowAddEnergyTime =0,
    last_kill_npc = 0,
    now_kill_npc = 0,
    Actor_motion_speed = 1,
    first_die = true,
    hit_by_qte = false,
    standup_invincible = false,
    needFixXY = false,
    skillFixX = 0,
    SkillFixY =0,
    have_elite_mark = false,
    pet_tips_showing = false,
    tipData = 0,
    hit_affter_dead = 0,
    low_hp_warnning = false,
    monster_combo = true,
    should_furry = false,
    skill_move_type = 1,
    _LastcomboStep = 0,
    already_send_balance = false,
    balance_count = 10,
    continue_hit_count = 0,
    hit_npc_count = 0,
    isStorageSkill = false,
    StorageSkilleachDam = 0,
    StorageSkillAllDam = 0,
    StorageSkillAllNum = 0,
    StorageSkillCount = 0,
    StorageSkillEndActionID = 0,
    skill_press = false,
    skill_release_count =0,
    power_time = 0,
    shadowCount = 6,
    shadowMode = false,
    isPlayerRole = false,
    isNpcRole = false,
    actor_now_scale = 1,
    
    button_temp_dir = 1,
    
    actor_show_type = 1,
    
    actor_is_friend = false,
    
    actor_y_offset =0,
    actor_name = nil,
    
    actor_move = false,
    
    actor_should_drop = false,
    
    die_hit_count = 0,
    
    skill_last_hit = false,
    
    is_skill_att = false,
    
    should_play_couch = true,
    
    accept_add_time = 0,
    
    _actor_id=0,
    
    _actor_type=0,
    
    role_id=0,
    
    _wave_id=0,
    
    speed_x = 1,        --移动速度current speed the actor is traveling in units/seconds
    
    camera_x = 0,       --摄像机X位置
    camera_y = 0,       --摄像机X位置
    
    light_count = 0,
    gold_count =0,
    
    basic_attack = 0,       --角色攻击力
    
    basic_defend = 0,       --角色防御力
    
    _curAnimation = "",     --当前动作名称
    
    RollSpeed=0,      --翻滚速度
    
    collideRect = cc.rect(0,0,2,2),  --角色碰撞盒
    
    hitEffectRect = cc.rect(0,0,2,2),  --受击光效盒
    
    m_CollitionBox = cc.rect(0,0,2,2),  --攻击碰撞盒
    
    temp_CollitionBox = cc.rect(0,0,2,2), --临时攻击碰撞盒
    
    temp_move_point = cc.p(0,0),
    
    shouldCheckHit = false, --是否检测攻击碰撞
    skillchange = false, --技能是否可以切换
    isPause = false, --是否检测攻击碰撞
    _aliveTime      = 0, --time the actor is alive in seconds
        
    --runtime modified values
    _curFacing      = 1, -- current direction the actor is facing, in radians, 0 is to the right
    
    _isalive        = true,
    
    _AITimer        = 0, -- accumulated timer before AI will execute, in seconds
    
    _AIEnabled      = false, --if false, AI will not run
    _attackTimer    = 0, --accumulated timer to decide when to attack, in seconds
    _cooldown       = false, --if its true, then you are currently playing attacking animation,
    _hp             = 1000, --current hit point
    _hp_max         = 1000, --current hit point
    
    _comboAcceptTime = 1,   --when the time equal 0 then interpput the combo
    
    _now_comboStep       = 1,       --which combo attack will make 
    
    _comboStep       = 1,       --which combo attack will make 
    
    _comboMax       = 5,       --which combo attack will make 
    
    _comboShouldAccept = true,   --when the time equal 0 then interpput the combo
    
    _isCanDange     = false,  -- can dan ge 
    
    _actionComplete = false,  -- 动作播完
    
    x             = 0,
    y             = 0,
    ground_y      = 0,
    normal_hit_delay = 0,
    _skill_hit_step  = 0,
    Last_skill_step = 0,
    gravity_speed = 10,
    enable_gravity = true,   --actor is invincible 无敌状态
    _isInvincible = false,   --actor is invincible 无敌状态
    _canChangeState =true,   --现阶段是否可以改变状态
    _LastState    = EnumStateType.stand,   --此状态的前一个状态
    _ActorState   = EnumStateType.stand,  --actor states
    _AirHitState   = EnumHitType.minor,  --浮空受击状态
    Last_skill_release = 0,
    _fallTime     = 1,      --time for change to stand states after fall to  the ground
    _stunTime     = 0,      --time for change to stand states after fall to  the ground
    _isInAir      = false,  --actor is in air?
    _isPowerUp    = false,  --霸体状态
    _isHitTheGround    = false,  --霸体状态
    _gamescene = nil,
    _search_range   = 1000,
    _attack_range   = 200,
    --target variables
    _targetFacing   = 0, --direction the actor Wants to turn to
    
    _hard_time      = 0, --动作硬直时间
    _request_hard_time    = 0, --需要硬直的时间
    
    _break_time      = 0, --霸体硬直时间
    _request_break_time    = 0, --霸体需要硬直的时间
    
    _moveto_point   = cc.p(-1,-1),
    
    _range_speed_x    = 10,
    _range_speed_y    = 10,
    
    _target         = nil, --the enemy actor 
    
    skill_list      = nil, --the skill list
    normal_att_list = nil, -- normal attack list
    skill_cd        = nil, -- skill cd list
    
    soundControl ={
        now_skill_sound_list = nil,
    },
    
    CDtime = 0,
    AITime = 0,
    AttTime = 0,
    AIFunction = nil,
    AIValue = 0,
    AIActionDone = false,
    attackRate_list = nil,
    
    defenceRate_list = nil,
    
    lifeRate_list   = nil,
    
    tempNowShadow = nil,
    
    hit_id_list = nil,
    
    Buff_List =0,
    
    equip_pets = {},
    
    last_skill_id = 0,
    now_skill_id=0,
    
    role_energy = 0,
    
    can_add_combo = false,
    hit_combo_value = 0,
    hit_combo_time = 0, 
    
    hit_combo_skill_now_count = 0,
    hit_combo_skill_all_count = 70,
    
    hit_id   = 0,
    hit_start_time   = 0,
    
    _shield          = 500,
    _shieldMax       = 500,
    _shield_hit_count  = 0,
    _shield_hit_time  = 0,
    element_type = 0,
    Counter_Skill_Index =0,
    AI_data = nil,
    gameisWin = false,
    _Blood_1 = nil,
    _Blood_2 = nil,
}

ActorModifiValues =    --角色可调属性
{   
--    other_pro ={
--            MAX_HIT_TIME = 0,   --记录异常
--            MAX_LOST_HP = 0,
--            MAX_ATTACK_DAMAGE =0,
--            MAX_DRINK_TIME = 0,
--            _no_hurt = false,
--            game_already_done = false,
--            game_already_time =0,
--            counter_time = 0,
--            Auto_hit_ratio = 0.1,
--            Auto_hit_time = 0,
--            Auto_temp_Interval = 0,
--            Auto_Interval = 0,
--            damage_reduce_percent=0,
--            attUp=0,
--            attDown=0,
--            defUp=0,
--            defDown=0,
--            hpUp=0,
--            hpDown=0,
--            energyUp=0,
--            energyDown=0,
--            critUp=0,
--            critwn=0,
--            cirtEx = 0,
--            cirtExMinus = 0,
--    },
    World_Boss = false,
    start_skill = false,
    qte_furry = false,
    attRange = 0,
    MAX_HIT_TIME = 0,   --记录异常
    MAX_LOST_HP = 0,
    MAX_ATTACK_DAMAGE =0,
    MAX_DRINK_TIME = 0,
 
    extra_sound_effect =0,
    force_move = false,
    can_drink = false,
    drink_maxcd = 3,
    drink_cd = 0,
    drink_button = 0,
    drink_count = 0,
    ultra_mode = 1,
    inPower_mode = false,
    first_show = false,
    ready_to_play_die = 0,
    lastX = 0,
    level =1,
    _max_falltime = 2,
    _max_float_time = 2,
    _float_time = 0,
    _float_count = 0,
    move_temp_x = 0,
    _is_boss = false,
    _ai_level = 1,
    _ai_should_hit = true,
    shouldCheckCounter = false,
    shouldDeleteAD = false ,
    counterModeEnable = false,
    counterMode = false,
    combo_skill_mode =false,
    counter_time = 0,
    Auto_hit_ratio = 0.1,
    Auto_hit_time = 0,
    Auto_temp_Interval = 0,
    Auto_Length = 0,
    Auto_Interval = 0,
    game_already_done = false,
    game_already_time =0,
    _ai_respon_time = 0,
    _no_hurt = false,
    _changeDir=false,
    is_hit_effect = false,
    _temp_ai_count = 0,
    _Attack_Press = false,
    _Attack_Press_time = 0,
    _temp_y = 0,
    _last_att_id=0,
    _last_d_id=0,
    damage_reduce_percent=0,
    attUp=0,
    attDown=0,
    defUp=0,
    defDown=0,
    hpUp=0,
    hpDown=0,
    energyUp=0,
    energyDown=0,
    critUp=0,
    critwn=0,
    cirtEx = 0,
    cirtExMinus = 0,
    need_Bullet_Assign = false,
    
    all_resist = false,
    all_dropItemName = nil,
    temp_hit_type=1,
    
    resist_list = {
       minor_injured = 1, --受轻伤
       serious_injured = 2, --受重伤
       inair = 4, --浮空
       stun = 8, --眩晕
       knockback = 16, --击退
       knockout = 32, --击飞
       hitMove = 64, --受击位移
       strike = 128, --强攻
    },
    ProfessionRestrainList = nil,
    
    now_elementAtt = {
        0,
        0,
        0,
        0,
        0,
        0
    },
    
    now_elementDef = {
        0,
        0,
        0,
        0,
        0,
        0
    }

    
}

FbInitValues =    --副本可调属性
    {
        time_warnning = false,
        boss_show_end = false,
        showUpObj =0,
        need_check_type = 1,
        need_check_camera_move = false,
        past_camera_x =0,
        preDt = 1/60,
        m_Restart = false,
        CounterModeIsFinish = false,
        Combo_node = nil,
        Energy_node = nil,
        game_layout =nil,
        follow_x = 0,
        follow_speed_level = 30,
        pass_time = 0,
        limit_time = 120,
        full_time=0,
        wave_wait_time = 2,
        wave_now_wait_time = 0,
        FB_list = nil,
        wave_count = 1,
        wave_nowStep = 1,
        fb_isFinish = false,
        kill_id_list = nil,
        shock_time = 0,
        shock_range = 0,
        shock_count = 0,
        star_count = 0,
        map_id=1,
        offset_x=0,
        offset_y=0,
        monster_start_id=10,
        follow_target = nil,
        loading_done = false,
        running_count=0,
        scaleOffset_x = 0,
        scaleOffset_y = 0,
        lastSceneScale = 1.0,
        targetSceneScale = 1.0,
        SceneScaleSpeed = 5, 
        all_boundingBoxs = nil,
        playerList = nil,
        nowMonsterList = nil,
        nowBulletList = nil,
        nowShadowList = nil,
        all_game_pause = false,
        game_isPause = false
        
        
}

BulletValue = {              --子弹属性
    x = 0,
    y = 0,
    camera_x=0,
    camera_y=0,
    bullet_id=1,  --子弹ID
    bullet_hit_id = 0, --子弹受击效果
    bullet_hit_step = 0, --子弹受击效果
    updateType = 0, --子弹更新类型 0为正常 1为CSB动画
    speed = 0,  --子弹速度
    angle = 0,  --子弹角度
    dir = 1,  --子弹方向
    checkUpdate = true,
    penetration = false,    --是否贯穿
    isDead = false,         --是否死亡
    attack_range = 0,       --打击范围，以半径为单位
    attack_type = 0,        --打击类型
    live_distance = 0,      --生效距离
    duration = 0,           --生命时间
    interval=0,             --攻击间隔
    now_interval=0,             --攻击间隔
    effect_dir = 1,
    _float_count = 0,
    pass_time =0,
    damage = 0,             --子弹伤害
    mode = 0,               --子弹类型
    target=nil,             --目标列表
    ground=nil,             --目标列表
    _spine_1=nil,
    _gamescene = nil,
    point_tl=nil,
    point_bl=nil,
    point_tr=nil,
    point_br=nil,
    temp_box = {x=0,y=0,width=2,height=2},
    temp_Hit_list = {},
    fixDamage = 1,
    isPause = false,
    isWin = false,
    made_Damage = false,
    should_checkhit_atOnce = false,
    warning_tips_end =0,
    opening_tips = 0,
    _request_break_time=0,
    _break_time=0,
    
}

itemValue ={

     baseNode = 0,
     touchNode = 0,
     nameNode = 0,
     shadowNode = 0,
     name =0,
     offset = 0,
     haveNum = 0,
     quality_type = 1,
     canCollect = false,
     needNum = false,
}

ShadowValue = {
    x = 0,
    y = 0,
    target_id=0,
    target = nil,
}

ActorDefaultValues =
{
    _racetype       = EnumRaceType.HERO, --type of the actor
    _statetype      = nil, -- AI state machine
    _sprite3d       = nil, --place to hold 3d model
    
    _radius         = 50, --actor collider size
    _mass           = 100, --weight of the role, it affects collision
    _shadowSize     = 70, --the size of the shadow under the actor

    --character strength
    _maxhp          = 1000,
    _defense        = 100,
    _specialAttackChance = 0, 
    _recoverTime    = 0.8,--time takes to recover from knock, in seconds
    
    _speed          = 500, --actor maximum movement speed in units/seconds
    
    _AIFrequency    = 1.0, --how often AI executes in seconds
    _attackFrequency = 0.01, --an attack move every few seconds
    
    _attackRange    = 100, --distance the actor will stop and commence attack
    
    --attack collider info, it can be customized
    _normalAttack   = {--data for normal attack
        minRange = 0, -- collider inner radius
        maxRange = 130, --collider outer radius
        angle    = DEGREES_TO_RADIANS(30), -- collider angle, 360 for full circle, other wise, a fan shape is created
        knock    = 50, --attack knock back distance
        damage   = 800, -- attack damage
        mask     = EnumRaceType.HERO, -- who created this attack collider
        duration = 0, -- 0 duration means it will be removed upon calculation
        speed    = 0, -- speed the collider is traveling
        criticalChance=0
    }, 
}




ReSkin = 
{
    knight = {weapon = 0, armour = 0, helmet = 0},
    archer = {weapon = 0, armour = 0, helmet = 0},
    mage = {weapon = 0, armour = 0, helmet = 0}
}